 %{
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

Function Name:  B_LL
Created:        6/26/2011 by Nicholas W Papageorge
Last Modified:  9/10/2015 by Nicholas W Papageorge
Copyright:      Nicholas W Papageorge. All rights reserved.
Project:        How Does Medical Innovation Create Value?
                Health, Human Capital and the Labor Market
Description:    Computes the likelihood function for a given
                set of parameters.
%}







function ll=B_LL(th_ml)

 
%1  GLOBAL OBJECTS

global TP ERRORS_CALC
global T MODEL
global N I L
global N_H N_E N_v N_A N_dm0 N_dm1 N_dl1 DIM DIM_S N_p
global obs ind T_i startI endI 
global v_it  H_it  A_it  I_it  F_it  E_it 
global v_it1 H_it1 A_it1 I_it1 F_it1 N_1_0 N_2_0
global IN_it1 AE_it
global d_it_m  d_m0_0 d_m1_0 d_m2_0 d_m3_0  
global d_it1_l d_l0_1 
global d_it1_m d_m0_1 d_m1_1 d_m2_1 d_m3_1  
global p_it pd INCd d_h cd4I
global N_it1 B_it1
global obsB indB T_iB startIB endIB H_itB A_itB IB NB
global beta beta_p beta_D beta_H beta_F beta_B beta_I beta_N
global    LU1 LA1 LP1 LS1 LD1 LH1 LF1 LB1 LI1 LN1
global LT LU2 LA2 LP2 LS2 LD2 LH2 LF2 LB2 LI2 LN2
global death I_death N_death
global LLD1g LLD2g LLD3g LLD4g LLCD1g LLCD2g LLH1g LLH2g LLF1g LLF2g
global LLN1g LLI1g LLP1g LLB1g LLTg












%2  CONSTRUCT PARAMETERS / COEFFICIENTS

th_P1=beta_p(1:17,1);
th_S1=ones(4,1)*beta_p(18,1);
th_D1=beta_D(1:9,1);
th_H1=beta_H(1:4,1);
th_F1=beta_F(1:9,1);
th_B1=beta_B(1:4,1);
th_I1=beta_I(1:13,1);
th_N1=beta_N(10:27,1);

th_ml_U1   =th_ml(1:LU1,1);      
th_ml_A1   =th_ml(LU1+1:LU1+LA1,1);      
th_ml_P1   =th_ml(LU1+LA1+1:LU1+LA1+LP1,1);      
th_ml_S1   =th_ml(LU1+LA1+LP1+1:LU1+LA1+LP1+LS1,1);      
th_ml_D1   =th_ml(LU1+LA1+LP1+LS1+1:LU1+LA1+LP1+LS1+LD1,1);   
th_ml_H1   =th_ml(LU1+LA1+LP1+LS1+LD1+1:LU1+LA1+LP1+LS1+LD1+LH1,1);
th_ml_F1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1,1);
th_ml_B1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1,1);
th_ml_I1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1,1);
th_ml_N1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1,1);

if L~=1
th_P2=beta_p(1:17,1);
th_S2=ones(4,1)*beta_p(18,1);
th_D2=beta_D(1:9,1);
th_H2=beta_H(1:4,1);
th_F2=beta_F(1:9,1);
th_B2=beta_B(1:4,1);
th_I2=beta_I(1:13,1);
th_N2=beta_N(10:27,1);


th_ml_T    =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT,1)     
th_T=C_TYPEP(th_ml_T);

th_ml_U2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2,1);
th_ml_A2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2,1);      
th_ml_P2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2,1);       
th_ml_S2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2,1);        
th_ml_D2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2,1);        
th_ml_H2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2,1);   
th_ml_F2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2,1);  
th_ml_B2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2,1);  
th_ml_I2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2,1);  
th_ml_N2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2+LN2,1);  
end

a=(A_it-30)*2+1; 

if MODEL==4 
th_H1(1:4,1)=th_ml_H1(1:4,1);
th_H2(1:4,1)=th_ml_H2(1:4,1);
th_D1(1:9,1)=th_ml_D1(1:9,1);
th_D2(1:9,1)=th_ml_D1(1:9,1);
th_D2(4,1)=th_ml_D2(1,1);
th_D2(7,1)=th_ml_D2(2,1);
th_F1(1:9,1)=th_ml_F1(1:9,1);
th_F2(1:9,1)=th_ml_F1(1:9,1);
th_F2(4,1)=th_ml_F2(1,1);
th_F2(7,1)=th_ml_F2(2,1);
end

if MODEL==5
th_H1(1:4,1)=th_ml_H1(1:4,1);
th_H2(1:4,1)=th_ml_H2(1:4,1);
th_D1(1:9,1)=th_ml_D1(1:9,1);
th_D2(1:9,1)=th_ml_D1(1:9,1);
th_D2(4,1)=th_ml_D2(1,1);
th_D2(7,1)=th_ml_D2(2,1);
th_F1(1:9,1)=th_ml_F1(1:9,1);
th_F2(1:9,1)=th_ml_F1(1:9,1);
th_F2(4,1)=th_ml_F2(1,1);
th_F2(7,1)=th_ml_F2(2,1);

th_P1=th_ml_P1(1:18,1);
th_I1=th_ml_I1(1:13,1);
th_N1=th_ml_N1(1:18,1);
th_B1=th_ml_B1(1:4,1);
end



%3  PRINT DURING ESTIMATION
format short g

if MODEL==1 || MODEL==2
th_ml_U1
th_ml_A1
end
    
if MODEL==3
th_ml_U1
th_ml_U2
th_ml_A1
th_ml_A2
end

if MODEL==4
th_ml_U1
th_ml_U2
th_ml_A1
th_ml_A2
th_ml_D1
th_ml_D2
th_ml_H1
th_ml_H2
th_ml_F1
th_ml_F2
end

if MODEL==5
th_ml_U1
th_ml_U2
th_ml_A1
th_ml_A2
th_ml_D1
th_ml_D2
th_ml_H1
th_ml_H2
th_ml_F1
th_ml_F2
th_ml_P1
th_ml_B1
th_ml_I1
th_ml_N1
end















%4 SOLVE DDP PROBLEM & OBTAIN CCPS FOR CURRENT th_ml

CCP=D_DPP(th_ml);

sig(:,1)=CCP(:,71,1);
if L==2
sig(:,2)=CCP(:,71,2);
end
CCP=CCP(:,1:70,:);


















%5  CONSTRUCT LIKELIHOOD INPUTS

l_ccp=zeros(N,L);
l_sig=zeros(N,1);

for j=1:N

    l_ccp(j,1)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),1);
if L~=1
    l_ccp(j,2)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),2);

    
if L==4
    l_ccp(j,3)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),3);
    l_ccp(j,4)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),4);
end
end
    l_sig(j,1)=...
        sig(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),1);
end

if MODEL==5
    l_sig=th_ml_P1(18,1)*ones(N,1);
end









%   CONSTRUCT LIKELIHOOD: CHOICES

if LU2==0
LLD1=zeros(I,1);


n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLD1(i)=prod(l_ccp(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LD=0;
for i=1:I   
LDi=...    
    log(LLD1(i,1));  
    LD=LD+LDi;
end
end














if LU2~=0 && L==2
LLD1=zeros(I,1);
LLD2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLD1(i)=prod(l_ccp(startI(n):endI(n),1));  
    LLD2(i)=prod(l_ccp(startI(n):endI(n),2));
    n=n+T_i(n);
    i=i+1;
end
    
LD=0;    
for i=1:I   
LDi=...    
    log(th_T(1,1)*(LLD1(i,1))+(1-th_T(1,1))*(LLD2(i,1)));  
    LD=LD+LDi;
end    
end





l_ccp(isinf(l_ccp))=0;








if LU2~=0 && L==4
LLD1=zeros(I,1);
LLD2=zeros(I,1);
LLD3=zeros(I,1);
LLD4=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLD1(i)=prod(l_ccp(startI(n):endI(n),1));  
    LLD2(i)=prod(l_ccp(startI(n):endI(n),2));
    LLD3(i)=prod(l_ccp(startI(n):endI(n),3));  
    LLD4(i)=prod(l_ccp(startI(n):endI(n),4));
    n=n+T_i(n);
    i=i+1;
end
    
LD=0;    

for i=1:I   
LDi=...    
    log(th_T(1,1)*(LLD1(i,1))+...
        th_T(2,1)*(LLD2(i,1))+...
        th_T(3,1)*(LLD3(i,1))+...
        th_T(4,1)*(LLD4(i,1)));
    
    
    LD=LD+LDi;
end    
end








%   CONSTRUCT LIKELIHOOD: OUT-OF-POCKET COSTS

if LP2==0
XB_P=...
    th_P1(1,1)*H_it+...    
    th_P1(2,1)*times((1-F_it),H_it)+...
    th_P1(3,1)*times((1-F_it),(1-H_it))+...
    th_P1(4,1)*I_it+...
    th_P1(5,1)*d_m1_0+...
    th_P1(6,1)*d_m2_0+...
    th_P1(7,1)*d_m3_0+...
    th_P1(8,1)*N_1_0+...
    th_P1(9,1)*N_2_0+...
    th_P1(10,1)*times(N_1_0,d_m1_0)+...
    th_P1(11,1)*times(N_2_0,d_m1_0)+...    
    th_P1(12,1)*times(N_1_0,d_m2_0)+...
    th_P1(13,1)*times(N_2_0,d_m2_0)+...    
    th_P1(14,1)*times(N_1_0,d_m3_0)+...
    th_P1(15,1)*times(N_2_0,d_m3_0)+...    
    th_P1(16,1)*(v_it)+...
    th_P1(17,1);

f_p=zeros(N,1);
%TOBIT

for c=1:1
z=times((p_it-XB_P(:,c)),(p_it-XB_P(:,c)));
y1=2*(times(l_sig,l_sig));
y2=times(-1,power(y1,-1));
x=times(z,y2);
w=exp(x);
v1=(2*pi*(times(l_sig,l_sig)));
v2=power(v1,(-1/2));
u=times(v2,w);
t=power(u,pd);
s=times(XB_P(:,c),power(l_sig,-1));
r=normcdf(s,0,1);
q=1-r;
p=power(q,(1-pd));
o=times(p,t);
n= 1E-1000*ones(N,1);
f_p(:,c)=max(n,o);
end

LLP1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLP1(i)=prod(f_p(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LP=0;
for i=1:I
LPi=...    
    log(LLP1(i,1));  
    LP=LP+LPi;
end

elseif LP2~=0
XB_P1=...
    th_P1(1,1)*H_it+...    
    th_P1(2,1)*times((1-F_it),H_it)+...
    th_P1(3,1)*times((1-F_it),(1-H_it))+...
    th_P1(4,1)*I_it+...
    th_P1(5,1)*d_m1_0+...
    th_P1(6,1)*d_m2_0+...
    th_P1(7,1)*d_m3_0+...
    th_P1(8,1)*N_1_0+...
    th_P1(9,1)*N_2_0+...
    th_P1(10,1)*times(N_1_0,d_m1_0)+...
    th_P1(11,1)*times(N_2_0,d_m1_0)+...    
    th_P1(12,1)*times(N_1_0,d_m2_0)+...
    th_P1(13,1)*times(N_2_0,d_m2_0)+...    
    th_P1(14,1)*times(N_1_0,d_m3_0)+...
    th_P1(15,1)*times(N_2_0,d_m3_0)+...    
    th_P1(16,1)*(v_it)+...
    th_P1(17,1);    
      
XB_P2=...
    th_P2(1,1)*H_it+...    
    th_P2(2,1)*times((1-F_it),H_it)+...
    th_P2(3,1)*times((1-F_it),(1-H_it))+...
    th_P2(4,1)*I_it+...
    th_P2(5,1)*d_m1_0+...
    th_P2(6,1)*d_m2_0+...
    th_P2(7,1)*d_m3_0+...
    th_P2(8,1)*N_1_0+...
    th_P2(9,1)*N_2_0+...
    th_P2(10,1) *times(N_1_0,d_m1_0)+...
    th_P2(11,1)*times(N_2_0,d_m1_0)+...    
    th_P2(12,1)*times(N_1_0,d_m2_0)+...
    th_P2(13,1)*times(N_2_0,d_m2_0)+...    
    th_P2(14,1)*times(N_1_0,d_m3_0)+...
    th_P2(15,1)*times(N_2_0,d_m3_0)+...    
    th_P2(16,1)*(v_it)+...
    th_P2(17,1);

XB_P=[XB_P1 XB_P2]; 

f_p=zeros(N,L);
for c=1:L
z=times((p_it-XB_P(:,c)),(p_it-XB_P(:,c)));
y1=2*(times(l_sig,l_sig));
y2=times(-1,power(y1,-1));
x=times(z,y2);
w=exp(x);
v1=(2*pi*(times(l_sig,l_sig)));
v2=power(v1,(-1/2));
u=times(v2,w);
t=power(u,pd);
s=times(XB_P(:,c),power(l_sig,-1));
r=normcdf(s,0,1);
q=1-r;
p=power(q,(1-pd));
o=times(p,t);
n= 1E-1000*ones(N,1);
f_p(:,c)=max(n,o);
end

LLP1=zeros(I,1);
LLP2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLP1(i)=prod(f_p(startI(n):endI(n),1));  
    LLP2(i)=prod(f_p(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

LP=0;
for i=1:I
LPi=...    
    th_T(1,1)*log(LLP1(i,1))+(1-th_T(1,1))*log(LLP2(i,1));  
    LP=LP+LPi;

end
end


























%   CONSTRUCT LIKELIHOOD: Health

if LD2==0 && LH2==0
    XB_D=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd=exp(XB_D);
f_cd=times(f_cd,power((1+f_cd),-1));
f_cd=times(power(f_cd,cd4I),power((1-f_cd),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LCD=0;
for i=1:I
LCDi=...    
    log(LLCD1(i,1));  
    LCD=LCD+LCDi;

end


XB_H=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h=exp(XB_H);
f_h=times(f_h,power((1+f_h),-1));
f_h=times(power(f_h,H_it1),power((1-f_h),(1-H_it1)));

LLH1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LH=0;
for i=1:I
LHi=...    
    log(LLH1(i,1));  
    LH=LH+LHi;

end



























elseif LD2==0 && LH2~=0
XB_D1=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D1);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));


f_cd=exp(XB_D1);
f_cd=times(f_cd,power((1+f_cd),-1));
f_cd=times(power(f_cd,cd4I),power((1-f_cd),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LCD=0;
for i=1:I
LCDi=...    
    log(LLCD1(i,1));  
    LCD=LCD+LCDi;

end

XB_H1=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h1=exp(XB_H1);
f_h1=times(f_h1,power((1+f_h1),-1));
f_h1=times(power(f_h1,H_it1),power((1-f_h1),(1-H_it1)));


XB_H2=...
    th_H2(1,1)*H_it+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


f_h2=exp(XB_H2);
f_h2=times(f_h2,power((1+f_h2),-1));
f_h2=times(power(f_h2,H_it1),power((1-f_h2),(1-H_it1)));

f_h=[f_h1 f_h2];

LLH1=zeros(I,1);
LLH2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    LLH2(i)=prod(f_h(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

LH=0;
for i=1:I
LHi=...    
    th_T(1,1)*log(LLH1(i,1))+(1-th_T(1,1))*log(LLH2(i,1));  
    LH=LH+LHi;

end
















elseif LD2~=0 && LH2==0
XB_D1=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D1);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd1=exp(XB_D1);
f_cd1=times(f_cd1,power((1+f_cd1),-1));
f_cd1=times(power(f_cd1,cd4I),power((1-f_cd1),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd1(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H1=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h1=exp(XB_H1);
f_h1=times(f_h1,power((1+f_h1),-1));
f_h1=times(power(f_h1,H_it1),power((1-f_h1),(1-H_it1)));





XB_D2=...
    th_D2(1,1)*H_it+...
    th_D2(2,1)*times((1-H_it),d_m1_1)+...
    th_D2(3,1)*times((1-H_it),d_m2_1)+...
    th_D2(4,1)*times((1-H_it),d_m3_1)+...
    th_D2(5,1)*times((H_it)  ,d_m1_1)+...
    th_D2(6,1)*times((H_it)  ,d_m2_1)+...
    th_D2(7,1)*times((H_it)  ,d_m3_1)+...
    th_D2(8,1)*v_it+...
    th_D2(9,1);

DH=exp(XB_D2);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd2=exp(XB_D2);
f_cd2=times(f_cd2,power((1+f_cd2),-1));
f_cd2=times(power(f_cd2,cd4I),power((1-f_cd2),(1-cd4I)));

LLCD2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD2(i)=prod(f_cd2(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end



XB_H2=...
    th_H2(1,1)*H_it+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


f_h2=exp(XB_H2);
f_h2=times(f_h2,power((1+f_h2),-1));
f_h2=times(power(f_h2,H_it1),power((1-f_h2),(1-H_it1)));

f_h=[f_h1 f_h2];

LLH1=zeros(I,1);
LLH2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    LLH2(i)=prod(f_h(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

LH=0;
for i=1:I
LHi=...    
    th_T(1,1)*log(LLH1(i,1))+(1-th_T(1,1))*log(LLH2(i,1));  
    LH=LH+LHi;

end

LCD=0;
for i=1:I
LCDi=...    
    th_T(1,1)*log(LLCD1(i,1))+(1-th_T(1,1))*log(LLCD2(i,1));  
    LCD=LCD+LCDi;
end









elseif LD2~=0 && LH2~=0
XB_D1=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D1);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd1=exp(XB_D1);
f_cd1=times(f_cd1,power((1+f_cd1),-1));
f_cd1=times(power(f_cd1,cd4I),power((1-f_cd1),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd1(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H1=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h1=exp(XB_H1);
f_h1=times(f_h1,power((1+f_h1),-1));
f_h1=times(power(f_h1,H_it1),power((1-f_h1),(1-H_it1)));





XB_D2=...
    th_D2(1,1)*H_it+...
    th_D2(2,1)*times((1-H_it),d_m1_1)+...
    th_D2(3,1)*times((1-H_it),d_m2_1)+...
    th_D2(4,1)*times((1-H_it),d_m3_1)+...
    th_D2(5,1)*times((H_it)  ,d_m1_1)+...
    th_D2(6,1)*times((H_it)  ,d_m2_1)+...
    th_D2(7,1)*times((H_it)  ,d_m3_1)+...
    th_D2(8,1)*v_it+...
    th_D2(9,1);

DH=exp(XB_D2);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd2=exp(XB_D2);
f_cd2=times(f_cd2,power((1+f_cd2),-1));
f_cd2=times(power(f_cd2,cd4I),power((1-f_cd2),(1-cd4I)));

LLCD2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD2(i)=prod(f_cd2(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H2=...
    th_H2(1,1)*H_it+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


f_h2=exp(XB_H2);
f_h2=times(f_h2,power((1+f_h2),-1));
f_h2=times(power(f_h2,H_it1),power((1-f_h2),(1-H_it1)));

f_h=[f_h1 f_h2];

LLH1=zeros(I,1);
LLH2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    LLH2(i)=prod(f_h(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

LH=0;
for i=1:I
LHi=...    
    th_T(1,1)*log(LLH1(i,1))+(1-th_T(1,1))*log(LLH2(i,1));  
    LH=LH+LHi;

end

LCD=0;
for i=1:I
LCDi=...    
    th_T(1,1)*log(LLCD1(i,1))+(1-th_T(1,1))*log(LLCD2(i,1));  
    LCD=LCD+LCDi;
end
end

 



























%   CONSTRUCT LIKELIHOOD: Symptoms, Side Effects


if LF2==0

XB_F=...
    th_F1(1,1)*H_it+...
    th_F1(2,1)*times((1-H_it),d_m1_1)+...
    th_F1(3,1)*times((1-H_it),d_m2_1)+...
    th_F1(4,1)*times((1-H_it),d_m3_1)+...
    th_F1(5,1)*times((H_it)  ,d_m1_1)+...
    th_F1(6,1)*times((H_it)  ,d_m2_1)+...
    th_F1(7,1)*times((H_it)  ,d_m3_1)+...
    th_F1(8,1)*v_it+...
    th_F1(9,1);


f_f=exp(XB_F);
f_f=times(f_f,power((1+f_f),-1));
f_f=times(power(f_f,F_it1),power((1-f_f),(1-F_it1)));

LLF1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLF1(i)=prod(f_f(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LF=0;
for i=1:I
LFi=...    
    log(LLF1(i,1));  
    LF=LF+LFi;

end

elseif LF2~=0

XB_F1=...
    th_F1(1,1)*H_it+...
    th_F1(2,1)*times((1-H_it),d_m1_1)+...
    th_F1(3,1)*times((1-H_it),d_m2_1)+...
    th_F1(4,1)*times((1-H_it),d_m3_1)+...
    th_F1(5,1)*times((H_it)  ,d_m1_1)+...
    th_F1(6,1)*times((H_it)  ,d_m2_1)+...
    th_F1(7,1)*times((H_it)  ,d_m3_1)+...
    th_F1(8,1)*v_it+...
    th_F1(9,1);

f_f1=exp(XB_F1);
f_f1=times(f_f1,power((1+f_f1),-1));
f_f1=times(power(f_f1,F_it1),power((1-f_f1),(1-F_it1)));

XB_F2=...
    th_F2(1,1)*H_it+...
    th_F2(2,1)*times((1-H_it),d_m1_1)+...
    th_F2(3,1)*times((1-H_it),d_m2_1)+...
    th_F2(4,1)*times((1-H_it),d_m3_1)+...
    th_F2(5,1)*times((H_it)  ,d_m1_1)+...
    th_F2(6,1)*times((H_it)  ,d_m2_1)+...
    th_F2(7,1)*times((H_it)  ,d_m3_1)+...
    th_F2(8,1)*v_it+...
    th_F2(9,1);


f_f2=exp(XB_F2);
f_f2=times(f_f2,power((1+f_f2),-1));
f_f2=times(power(f_f2,F_it1),power((1-f_f2),(1-F_it1)));

f_f=[f_f1 f_f2];

LLF1=zeros(I,1);
LLF2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLF1(i)=prod(f_f(startI(n):endI(n),1));  
    LLF2(i)=prod(f_f(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

LF=0;
for i=1:I
LFi=...    
    th_T(1,1)*log(LLF1(i,1))+(1-th_T(1,1))*log(LLF2(i,1));  
    LF=LF+LFi;

end
end



















%   CONSTRUCT LIKELIHOOD: Income


if LI2==0
XB_I=...
    th_I1(1,1)*H_it+...
    th_I1(2,1)*AE_it+...
    th_I1(3,1)*times(AE_it,AE_it)+...
    th_I1(4,1)*A_it+...
    th_I1(5,1)*(v_it-14)+...
   (times(d_it1_l,...
   (th_I1(6,1)+... 
    th_I1(7,1)*H_it+...
    th_I1(8,1)*AE_it+...
    th_I1(9,1)*times(AE_it,AE_it)+...
    th_I1(10,1)*A_it+...
    th_I1(11,1)*(v_it-14))))+...
    th_I1(12,1);

 
f_i=zeros(N,1);
for c=1:1
z=times(IN_it1-XB_I(:,c),power(th_I1(13,1),-1));
y=normpdf(z,0,1);
x=times(y,power(th_I1(13,1),-1));
w=power(x,INCd);
v=times(XB_I(:,c)-2500,power(th_I1(13,1),-1));
u=normcdf(v,0,1);
t=1-u;
s=power(t,(1-INCd));
r=times(s,w);
q= 1E-1000*ones(N,1);
f_i(:,c)=max(q,r);    
end

 
LLI1=zeros(I,1);

 
n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLI1(i)=prod(f_i(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

 
LI=0;
for i=1:I
LIi=...    
    log(LLI1(i,1));  
    LI=LI+LIi;
end

 
elseif LI2~=0
XB_I1=...
    th_I1(1,1)*H_it+...
    th_I1(2,1)*AE_it+...
    th_I1(3,1)*times(AE_it,AE_it)+...
    th_I1(4,1)*A_it+...
    th_I1(5,1)*(v_it-14)+...
   (times(d_it1_l,...
   (th_I1(6,1)+... 
    th_I1(7,1)*H_it+...
    th_I1(8,1)*AE_it+...
    th_I1(9,1)*times(AE_it,AE_it)+...
    th_I1(10,1)*A_it+...
    th_I1(11,1)*(v_it-14))))+...
    th_I1(12,1);  

      
XB_I2=...
    th_I2(1,1)*H_it+...
    th_I2(2,1)*AE_it+...
    th_I2(3,1)*times(AE_it,AE_it)+...
    th_I2(4,1)*A_it+...
    th_I2(5,1)*(v_it-14)+...
   (times(d_it1_l,...
   (th_I2(6,1)+... 
    th_I2(7,1)*H_it+...
    th_I2(8,1)*AE_it+...
    th_I2(9,1)*times(AE_it,AE_it)+...
    th_I2(10,1)*A_it+...
    th_I2(11,1)*(v_it-14))))+...
    th_I2(12,1); 

 
XB_I=[XB_I1 XB_I2]; 

 
f_i=zeros(N,2);
for c=1:2
z=times(IN_it1-XB_I(:,c),power(th_I1(13,1),-1));
y=normpdf(z,0,1);
x=times(y,power(th_I1(13,1),-1));
w=power(x,INCd);
v=times(XB_I(:,c)-2500,power(th_I1(13,1),-1));
u=normcdf(v,0,1);
t=1-u;
s=power(t,(1-INCd));
r=times(s,w);
q= 1E-1000*ones(N,1);
f_i(:,c)=max(q,r);    
end

 
LLI1=zeros(I,1);
LLI2=zeros(I,1);

 
n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLI1(i)=prod(f_i(startI(n):endI(n),1));  
    LLI2(i)=prod(f_i(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

 
LI=0;
for i=1:I
LIi=...    
    th_T(1,1)*log(LLI1(i,1))+(1-th_T(1,1))*log(LLI2(i,1));  
    LI=LI+LIi;

 
end
end
 





%   CONSTRUCT LIKELIHOOD: INSURANCE

if LN1~=0
    
XB_N11=...
    th_N1(1,1)*d_it1_l+...
    th_N1(2,1)*H_it+...
    th_N1(3,1)*E_it+...
    th_N1(4,1)*E_it.*E_it+...
    th_N1(5,1)*A_it+...
    th_N1(6,1)*A_it.*A_it+...
    th_N1(7,1)*v_it+...
    th_N1(8,1)*(v_it-24).*(v_it>=25)+...
    th_N1(9,1);

XB_N12=...
    th_N1(10,1)*d_it1_l+...
    th_N1(11,1)*H_it+...
    th_N1(12,1)*E_it+...
    th_N1(13,1)*E_it.*E_it+...
    th_N1(14,1)*A_it+...
    th_N1(15,1)*A_it.*A_it+...
    th_N1(16,1)*v_it+...
    th_N1(17,1)*(v_it-24).*(v_it>=25)+...
    th_N1(18,1);

f_n11=exp(XB_N11);
f_n12=exp(XB_N12);

f_n1=times(f_n11,(power((1+f_n11+f_n12),-1)));
f_n2=times(f_n12,(power((1+f_n11+f_n12),-1)));

f_n0=1-f_n1-f_n2;

f_n=times((times((power(f_n0,(N_it1==0))),(power(f_n1,(N_it1==1))))),(power(f_n2,(N_it1==2))));

LLN1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLN1(i)=prod(f_n(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end

LN=0;
for i=1:I   
LNi=...    
    log(LLN1(i,1));  
    LN=LN+LNi;
end
end




%   CONSTRUCT LIKELIHOOD: SURVIVAL

if LB1~=0
    
XB_B1=...
    th_B1(1,1)*H_itB+...
    th_B1(2,1)*A_itB.*H_itB+...
    th_B1(3,1)*A_itB+...
    th_B1(4,1);

f_b1=exp(XB_B1);

f_b1=times(f_b1,(power((1+f_b1),-1)));
f_b0=1-f_b1;

f_b=times((power(f_b0,(B_it1==0))),(power(f_b1,(B_it1==1))));

LLB1=zeros(IB,1);

n=1;
i=1;
while ((n<=NB)&&(i<=IB));
    LLB1(i)=prod(f_b(startIB(n):endIB(n),1));  
    n=n+T_iB(n);
    i=i+1;
end

LB=0;
for i=1:IB   
LBi=...    
    log(LLB1(i,1));  
    LB=LB+LBi;
end
end





%   CONSTRUCT LIKELIHOOD: CHECK SOME STUFF



% LH=0;
% for i=1:I
% LHi=...    
%     th_T(1,1)*log(LLH1(i,1))+(1-th_T(1,1))*log(LLH2(i,1));  
%     LH=LH+LHi;
% 
% end
% 
% LCD=0;
% for i=1:I
% LCDi=...    
%     th_T(1,1)*log(LLCD1(i,1))+(1-th_T(1,1))*log(LLCD2(i,1));  
%     LCD=LCD+LCDi;
% end













%11  CONSTRUCT LIKELIHOOD from COMPONENTS
format short g
LD
LCD
LH
LF
LP
LI
if MODEL==5
LB
LN
end

if L==1 || (L==2 && LU2~=0 && (LH2==0 && LD2==0))
LL=LD;
end



if L==4 && LU2~=0 && (LH2~=0 && LD2==0)
LL=0;
for i=1:I   
Li=...    
    log(th_T(1,1)*(LLD1(i,1))*LLH1(i,1)+...
        th_T(2,1)*(LLD2(i,1))*LLH1(i,1)+...
        th_T(3,1)*(LLD3(i,1))*LLH2(i,1)+...
        th_T(4,1)*(LLD4(i,1))*LLH2(i,1));
    LL=LL+Li;
end
end


if L==4 && LU2~=0 && (LH2==0 && LD2~=0)
LL=0;
for i=1:I   
Li=...    
    log(th_T(1,1)*(LLD1(i,1))*LLCD1(i,1)+...
        th_T(2,1)*(LLD2(i,1))*LLCD1(i,1)+...
        th_T(3,1)*(LLD3(i,1))*LLCD2(i,1)+...
        th_T(4,1)*(LLD4(i,1))*LLCD2(i,1));
    LL=LL+Li;
end
end


if L==4 && LU2~=0 && (LH2~=0 && LD2~=0)
LL=0;
for i=1:I   
Li=...    
    log(th_T(1,1)*(LLD1(i,1))*LLCD1(i,1)*LLH1(i,1)+...
        th_T(2,1)*(LLD2(i,1))*LLCD1(i,1)*LLH1(i,1)+...
        th_T(3,1)*(LLD3(i,1))*LLCD2(i,1)*LLH2(i,1)+...
        th_T(4,1)*(LLD4(i,1))*LLCD2(i,1)*LLH2(i,1));
    LL=LL+Li;
end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if MODEL==4
    
LL=0;
for i=1:I   
Li=...    
    log(th_T(1,1)*(LLD1(i,1))*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)+...
        th_T(2,1)*(LLD2(i,1))*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)+...
        th_T(3,1)*(LLD3(i,1))*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)+...
        th_T(4,1)*(LLD4(i,1))*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1));
    LL=LL+Li;
end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if MODEL==5

LL=0;
for i=1:I   
Li=...    
    log(th_T(1,1)*(LLD1(i,1))*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)+...
        th_T(2,1)*(LLD2(i,1))*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)+...
        th_T(3,1)*(LLD3(i,1))*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)+...
        th_T(4,1)*(LLD4(i,1))*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1));
    LL=LL+Li;
end

LL = LL + sum(log(LLP1));
LL = LL + sum(log(LLB1));
LL = LL + sum(log(LLI1));
LL = LL + sum(log(LLN1));

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if ERRORS_CALC==1 && MODEL==1

    LLD1g=LLD1;
    
end

if ERRORS_CALC==1 && MODEL==2

    LLD1g=LLD1;
    
end

if ERRORS_CALC==1 && MODEL==3

    LLD1g=LLD1;
    LLD2g=LLD2;
    LLTg=th_T;
    
end

if ERRORS_CALC==1 && MODEL==4

    LLD1g=LLD1;
    LLD2g=LLD2;
    LLD3g=LLD3;
    LLD4g=LLD4;
    LLTg=th_T;
    LLCD1g=LLCD1;
    LLCD2g=LLCD2;
    LLH1g=LLH1;
    LLH2g=LLH2;
    LLF1g=LLF1;
    LLF2g=LLF2;
    
end


if ERRORS_CALC==1 && MODEL==5

    LLD1g=LLD1;
    LLD2g=LLD2;
    LLD3g=LLD3;
    LLD4g=LLD4;
    LLTg=th_T;
    LLCD1g=LLCD1;
    LLCD2g=LLCD2;
    LLH1g=LLH1;
    LLH2g=LLH2;
    LLF1g=LLF1;
    LLF2g=LLF2;
    LLP1g=LLP1;
    LLB1g=LLB1;
    LLI1g=LLI1;
    LLN1g=LLN1;

        
    
end



ll =(-1)*(LL);





















