%{
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

Function Name:  C_TYPEP
Created:        6/26/2011 by Nicholas W Papageorge
Last Modified:  9/10/2015 by Nicholas W Papageorge
Copyright:      Nicholas W Papageorge. All rights reserved.
Project:        How Does Medical Innovation Create Value?
                Health, Human Capital and the Labor Market
Description:    Computes type probability
%}

function  [pi_1]  = C_TYPEP(x)

global MODEL

if length(x)==1 && MODEL==3
x1=(exp(x(1,1)))/(1+exp(x(1,1)));
x2=1-x1;
pi_1=[x1;x2];


elseif length(x)==1 && (MODEL==4)
x1=(exp(x(1,1)))/(1+exp(x(1,1)));
x2=1-x1;
pi_1=[x1;x2];


elseif MODEL==4
x1=(exp(x(1,1))/(1+exp(x(1,1))));
x2=(1-x1)*(exp(x(2,1))/(1+exp(x(2,1))));
x3=(1-x1-x2)*(exp(x(3,1))/(1+exp(x(3,1))));

pi_1(1,1)=x1;
pi_1(2,1)=x2;
pi_1(3,1)=x3;
pi_1(4,1)=(1-x1-x2-x3);

elseif MODEL==5

pi_1(1,1)=x(1,1);
pi_1(2,1)=x(2,1);
pi_1(3,1)=x(3,1);
pi_1(4,1)=(1-x(1,1)-x(2,1)-x(3,1));

end

display 'PREF-HEALTH 1-1 2-1 1-2 2-2'

pi_1

end


