%{
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

Function Name:  D_DPP
Created:        6/26/2011 by Nicholas W Papageorge
Last Modified:  9/10/2015 by Nicholas W Papageorge
Copyright:      Nicholas W Papageorge. All rights reserved.
Project:        How Does Medical Innovation Create Value?
                Health, Human Capital and the Labor Market
Description:    Solves the dynamic programming problem
                for a given set of parameters
%}







function CCP=D_DPP(th_ml)

%1  CALL GLOBAL OBJECTS

global TP 
global T MODEL
global N I L
global N_H N_E N_v N_A N_dm0 N_dm1 N_dl1 DIM DIM_S N_p
global obs ind T_i startI endI 
global v_it  H_it  A_it  E_it 
global v_it1 H_it1 A_it1 I_it1 F_it1 N_1_0 N_2_0
global d_it_m  d_m0_0 d_m1_0 d_m2_0 d_m3_0  
global d_it1_l d_l0_1 
global d_it1_m d_m0_1 d_m1_1 d_m2_1 d_m3_1  
global p_it pd INCd d_h cd4I
global beta beta_p beta_D beta_H beta_F beta_B beta_I beta_N
global    LU1 LA1 LP1 LS1 LD1 LH1 LF1 LB1 LI1 LN1
global LT LU2 LA2 LP2 LS2 LD2 LH2 LF2 LB2 LI2 LN2












%2  PARAMETERS FOR EXPERIMENTATION: COMMENT OUT FOR ESTIMATION

% beta=0.95;
% 
% th_U1=[...
% -.01
% -1
% -.1
% .1];
% 
% th_P1           =beta_p(1:16,1);   
% th_S1           =ones(4,1)*beta_p(17,1);
% th_B1           =0;
% 
% alpha1=.89;







%2  CONSTRUCT PARAMETERS / COEFFICIENTS

th_P1=beta_p(1:17,1);
th_S1=ones(4,1)*beta_p(18,1);
th_D1=beta_D(1:9,1);
th_H1=beta_H(1:4,1);
th_F1=beta_F(1:9,1);
th_B1=beta_B(1:4,1);
th_I1=beta_I(1:13,1);
th_N1=beta_N(10:27,1);


th_ml_U1   =th_ml(1:LU1,1);      
th_ml_A1   =th_ml(LU1+1:LU1+LA1,1);      
th_ml_P1   =th_ml(LU1+LA1+1:LU1+LA1+LP1,1);      
th_ml_S1   =th_ml(LU1+LA1+LP1+1:LU1+LA1+LP1+LS1,1);      
th_ml_D1   =th_ml(LU1+LA1+LP1+LS1+1:LU1+LA1+LP1+LS1+LD1,1);  
th_ml_H1   =th_ml(LU1+LA1+LP1+LS1+LD1+1:LU1+LA1+LP1+LS1+LD1+LH1,1);
th_ml_F1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1,1);
th_ml_B1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1,1);
th_ml_I1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1,1);
th_ml_N1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1,1);
if LA2==0
alpha1     =times(exp(th_ml_A1),power(1+exp(th_ml_A1),-1))
end

if L~=1
th_P2=beta_p(1:17,1);
th_S2=ones(4,1)*beta_p(18,1); 
th_D2=beta_D(1:9,1);
th_H2=beta_H(1:4,1);
th_F2=beta_F(1:9,1);
th_B2=beta_B(1:4,1);
th_I2=beta_I(1:13,1);
th_N2=beta_N(10:27,1);


th_ml_T    =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LT+LN1,1);     
th_T=C_TYPEP(th_ml_T);

th_ml_U2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2,1);           
th_ml_A2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2,1);       
th_ml_P2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2,1);       
th_ml_S2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2,1);        
th_ml_D2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2,1);        
th_ml_H2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2,1);   
th_ml_F2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2,1);   
th_ml_B2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2,1);  
th_ml_I2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2,1);  
th_ml_N2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2+LN2,1);  
end
if LA2~=0 && MODEL~=5 % for errors, to avoid delta method
alpha1     =times(exp(th_ml_A1),power(1+exp(th_ml_A1),-1))
alpha2     =times(exp(th_ml_A2),power(1+exp(th_ml_A2),-1))
elseif MODEL==5
alpha1     =th_ml_A1;
alpha2     =th_ml_A2;
end

if MODEL==4 
th_H1(1:4,1)=th_ml_H1(1:4,1);
th_H2(1:4,1)=th_ml_H2(1:4,1);
th_D1(1:9,1)=th_ml_D1(1:9,1);
th_D2(1:9,1)=th_ml_D1(1:9,1);
th_D2(4,1)=th_ml_D2(1,1);
th_D2(7,1)=th_ml_D2(2,1);
th_F1(1:9,1)=th_ml_F1(1:9,1);
th_F2(1:9,1)=th_ml_F1(1:9,1);
th_F2(4,1)=th_ml_F2(1,1);
th_F2(7,1)=th_ml_F2(2,1);
end

if MODEL==5
th_H1(1:4,1)=th_ml_H1(1:4,1);
th_H2(1:4,1)=th_ml_H2(1:4,1);
th_D1(1:9,1)=th_ml_D1(1:9,1);
th_D2(1:9,1)=th_ml_D1(1:9,1);
th_D2(4,1)=th_ml_D2(1,1);
th_D2(7,1)=th_ml_D2(2,1);
th_F1(1:9,1)=th_ml_F1(1:9,1);
th_F2(1:9,1)=th_ml_F1(1:9,1);
th_F2(4,1)=th_ml_F2(1,1);
th_F2(7,1)=th_ml_F2(2,1);

th_P1=th_ml_P1(1:18,1);
th_I1=th_ml_I1(1:13,1);
th_N1=th_ml_N1(1:18,1);
th_B1=th_ml_B1(1:4,1);
end





%4  SETUP FOR BACKWARD RECURSION

CCP=zeros(DIM,71,L);







for type=1:L
V_A=zeros(DIM,71);
 
    
%5  BACKWARD RECURSION: BEGIN WITH RETIREMENT AGE (65)

%Start w. Retirement A=65)
    
for A=65 

%TP Cube Layer (Using A_it)
    a=(A-30)*2+1;                                         
%TP for this iteration
    TPa=TP(:,:,a);  

%Extract from TP Components for Flow Utility and Transitions
    
TP_v        =TPa(:,1);    
TP_dh       =TPa(:,2);
TP_H        =TPa(:,3);    
TP_E        =TPa(:,4);    
TP_dl0_1    =TPa(:,5);
TP_dl1_1    =TPa(:,6);
TP_dm0_0    =TPa(:,7);
TP_dm1_0    =TPa(:,8);
TP_dm2_0    =TPa(:,9);
TP_dm3_0    =TPa(:,10);
TP_dm0_1    =TPa(:,11);
TP_dm1_1    =TPa(:,12);
TP_dm2_1    =TPa(:,13);
TP_dm3_1    =TPa(:,14);

PP_B        =TPa(:,15);
PP_H        =TPa(:,16);
PP_F        =TPa(:,17);

EE_I         =TPa(:,18);

EE_N1        =TPa(:,19);
EE_N2        =TPa(:,20);

EE_IP    =(EE_I+2500)/5000;

%OOC ~ Health ~ Symptoms/SFX  

if type==1 || type==2
    
XB_B=...
    th_B1(1,1)*TP_H+...
    th_B1(2,1)*A*TP_H+...
    th_B1(3,1)*A+...
    th_B1(4,1);

P_B=exp(XB_B);
P_B=times(P_B,power((1+P_B),-1));     
    
XB_D=...
    th_D1(1,1)*TP_H+...
    th_D1(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_D1(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_D1(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_D1(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_D1(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_D1(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_D1(8,1)*TP_v+...
    th_D1(9,1);


DH=exp(XB_D);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-TP_H));
DH1=times(DH,(TP_H));

XB_H=...
    th_H1(1,1)*TP_H+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

P_H=exp(XB_H);
P_H=times(P_H,power((1+P_H),-1));



XB_F=...
    th_F1(1,1)*TP_H+...  
    th_F1(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_F1(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_F1(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_F1(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_F1(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_F1(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_F1(8,1)*TP_v+...
    th_F1(9,1);

P_F=exp(XB_F);
P_F=times(P_F,power((1+P_F),-1));

XB_I=...
    th_I1(1,1)*TP_H+...
    th_I1(2,1)*TP_E+...
    th_I1(3,1)*times(TP_E,TP_E)+...
    th_I1(4,1)*A+...
    th_I1(5,1)*(TP_v-14)+...
   (times(TP_dl1_1,...
   (th_I1(6,1)+... 
    th_I1(7,1)*TP_H+...
    th_I1(8,1)*TP_E+...
    th_I1(9,1)*times(TP_E,TP_E)+...
    th_I1(10,1)*A+...
    th_I1(11,1)*(TP_v-14))))+...
    th_I1(12,1);

sig=th_I1(13,1);

w=times((XB_I-2500),power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_I=(2500*(1-phi_2))+(times(phi_2,XB_I)+times(sig,phi_1)); %left censored; See C&T p541 
E_IP    =(E_I+2500)/5000;


XB_N_1=...
    th_N1(1,1)*TP_dl1_1+...
    th_N1(2,1)*TP_H+...
    th_N1(3,1)*TP_E+...
    th_N1(4,1)*times(TP_E,TP_E)+...
    th_N1(5,1)*A+...
    th_N1(6,1)*A^2+...
    th_N1(7,1)*(TP_v)+...
    th_N1(8,1)*times(TP_v-24,TP_dh)+...
    th_N1(9,1);

XB_N_2=...
    th_N1(10,1)*TP_dl1_1+...
    th_N1(11,1)*TP_H+...
    th_N1(12,1)*TP_E+...
    th_N1(13,1)*times(TP_E,TP_E)+...
    th_N1(14,1)*A+...
    th_N1(15,1)*A^2+...
    th_N1(16,1)*(TP_v)+...
    th_N1(17,1)*times(TP_v-24,TP_dh)+...
    th_N1(18,1);


XB_N_1=exp(XB_N_1);
XB_N_2=exp(XB_N_2);

E_N1=times(XB_N_1,power((1+XB_N_1+XB_N_2),-1));
E_N2=times(XB_N_2,power((1+XB_N_1+XB_N_2),-1));

XB_P=...
    th_P1(1,1)*P_H+...
    th_P1(2,1)*times((1-P_F),P_H)+...
    th_P1(3,1)*times((1-P_F),(1-P_H))+...
    th_P1(4,1)*E_IP+...
    th_P1(5,1)*TP_dm1_1+...
    th_P1(6,1)*TP_dm2_1+...
    th_P1(7,1)*TP_dm3_1+...
    th_P1(8,1)*E_N1+...
    th_P1(9,1)*E_N2+...
    th_P1(10,1)*times(E_N1,TP_dm1_1)+...
    th_P1(11,1)*times(E_N2,TP_dm1_1)+...    
    th_P1(12,1)*times(E_N1,TP_dm2_1)+...
    th_P1(13,1)*times(E_N2,TP_dm2_1)+...    
    th_P1(14,1)*times(E_N1,TP_dm3_1)+...
    th_P1(15,1)*times(E_N2,TP_dm3_1)+...    
    th_P1(16,1)*(TP_v)+...
    th_P1(17,1);

sig0=  th_S1(1,1)*TP_dm0_1;  
sig1=  th_S1(2,1)*TP_dm1_1;
sig2=  th_S1(3,1)*TP_dm2_1;
sig3=  th_S1(4,1)*TP_dm3_1;
sig=sig0+sig1+sig2+sig3;

w=times(XB_P,power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_P=times(phi_2,XB_P)+times(sig,phi_1); %left censored; See C&T p541


elseif type==3 || type==4

XB_B=...
    th_B2(1,1)*TP_H+...
    th_B2(2,1)*A*TP_H+...
    th_B2(3,1)*A+...
    th_B2(4,1);

P_B=exp(XB_B);
P_B=times(P_B,power((1+P_B),-1));    
    
XB_D=...
    th_D2(1,1)*TP_H+...
    th_D2(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_D2(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_D2(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_D2(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_D2(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_D2(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_D2(8,1)*TP_v+...
    th_D2(9,1);


DH=exp(XB_D);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-TP_H));
DH1=times(DH,(TP_H));

XB_H=...
    th_H2(1,1)*TP_H+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


P_H=exp(XB_H);
P_H=times(P_H,power((1+P_H),-1));


XB_F=...
    th_F2(1,1)*TP_H+...  
    th_F2(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_F2(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_F2(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_F2(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_F2(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_F2(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_F2(8,1)*TP_v+...
    th_F2(9,1);

P_F=exp(XB_F);
P_F=times(P_F,power((1+P_F),-1));


XB_I=...
    th_I2(1,1)*TP_H+...
    th_I2(2,1)*TP_E+...
    th_I2(3,1)*times(TP_E,TP_E)+...
    th_I2(4,1)*A+...
    th_I2(5,1)*(TP_v-14)+...
   (times(TP_dl1_1,...
   (th_I2(6,1)+... 
    th_I2(7,1)*TP_H+...
    th_I2(8,1)*TP_E+...
    th_I2(9,1)*times(TP_E,TP_E)+...
    th_I2(10,1)*A+...
    th_I2(11,1)*(TP_v-14))))+...
    th_I2(12,1);

sig=th_I2(13,1);

w=times((XB_I-2500),power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_I=(2500*(1-phi_2))+(times(phi_2,XB_I)+times(sig,phi_1)); %left censored; See C&T p541 
E_IP    =(E_I+2500)/5000;


XB_N_1=...
    th_N2(1,1)*TP_dl1_1+...
    th_N2(2,1)*TP_H+...
    th_N2(3,1)*TP_E+...
    th_N2(4,1)*times(TP_E,TP_E)+...
    th_N2(5,1)*A+...
    th_N2(6,1)*A^2+...
    th_N2(7,1)*(TP_v)+...
    th_N2(8,1)*times(TP_v-24,TP_dh)+...
    th_N2(9,1);

XB_N_2=...
    th_N2(10,1)*TP_dl1_1+...
    th_N2(11,1)*TP_H+...
    th_N2(12,1)*TP_E+...
    th_N2(13,1)*times(TP_E,TP_E)+...
    th_N2(14,1)*A+...
    th_N2(15,1)*A^2+...
    th_N2(16,1)*(TP_v)+...
    th_N2(17,1)*times(TP_v-24,TP_dh)+...
    th_N2(18,1);


XB_N_1=exp(XB_N_1);
XB_N_2=exp(XB_N_2);

E_N1=times(XB_N_1,power((1+XB_N_1+XB_N_2),-1));
E_N2=times(XB_N_2,power((1+XB_N_1+XB_N_2),-1));

XB_P=...
    th_P2(1,1)*P_H+...
    th_P2(2,1)*times((1-P_F),P_H)+...
    th_P2(3,1)*times((1-P_F),(1-P_H))+...
    th_P2(4,1)*E_IP+...
    th_P2(5,1)*TP_dm1_1+...
    th_P2(6,1)*TP_dm2_1+...
    th_P2(7,1)*TP_dm3_1+...
    th_P2(8,1)*E_N1+...
    th_P2(9,1)*E_N2+...
    th_P2(10,1)*times(E_N1,TP_dm1_1)+...
    th_P2(11,1)*times(E_N2,TP_dm1_1)+...    
    th_P2(12,1)*times(E_N1,TP_dm2_1)+...
    th_P2(13,1)*times(E_N2,TP_dm2_1)+...    
    th_P2(14,1)*times(E_N1,TP_dm3_1)+...
    th_P2(15,1)*times(E_N2,TP_dm3_1)+...    
    th_P2(16,1)*(TP_v)+...
    th_P2(17,1);

sig0=  th_S2(1,1)*TP_dm0_1;  
sig1=  th_S2(2,1)*TP_dm1_1;
sig2=  th_S2(3,1)*TP_dm2_1;
sig3=  th_S2(4,1)*TP_dm3_1;
sig=sig0+sig1+sig2+sig3;

w=times(XB_P,power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_P=times(phi_2,XB_P)+times(sig,phi_1); %left censored; See C&T p541

end


if LA1==1
    
    aE_C=(1/(1-alpha1(1,1)))*power((E_I-E_P),(1-alpha1(1,1)));

elseif LA1==2 && LA2==0

    aE_C11=(1/(1-alpha1(1,1)))*power((E_I-E_P),(1-alpha1(1,1)));
    aE_C12=(1/(1-alpha1(2,1)))*power((E_I-E_P),(1-alpha1(2,1)));
       
elseif LA1==2 && LA2==2

    aE_C11=(1/(1-alpha1(1,1)))*power((E_I-E_P),(1-alpha1(1,1)));
    aE_C12=(1/(1-alpha1(2,1)))*power((E_I-E_P),(1-alpha1(2,1)));
    aE_C21=(1/(1-alpha2(1,1)))*power((E_I-E_P),(1-alpha2(1,1)));
    aE_C22=(1/(1-alpha2(2,1)))*power((E_I-E_P),(1-alpha2(2,1)));
    
end
 



%Construct Expected Flow Utility
                                    
if type==1 || type==3
if MODEL==1   

FU=         aE_C+...
            th_ml_U1(1,1)*TP_dl1_1+...
            th_ml_U1(2,1)*(1-P_F)+...
            th_ml_U1(3,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(4,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(4,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(4,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_0),TP_dm0_1);  
                
elseif MODEL==2
    
FU=         times(P_F,...
           (aE_C11+...
            th_ml_U1(1,1)*TP_dl1_1))+...
            times((1-P_F),...
           (aE_C12+...
            th_ml_U1(2,1)+...
            th_ml_U1(3,1)*TP_dl1_1))+...
            times(times(P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)));   


elseif MODEL==3 || MODEL==4 || MODEL==5
 
    
FU=         times(P_F,...
           (aE_C11+...
            th_ml_U1(1,1)*TP_dl1_1))+...
            times((1-P_F),...
           (aE_C12+...
            th_ml_U1(2,1)+...
            th_ml_U1(3,1)*TP_dl1_1))+...
            times(times(P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)));   
   

end

elseif type==2 || type==4
if MODEL==3 || MODEL==4 || MODEL==5 


    
FU=         times(P_F,...
           (aE_C21+...
            th_ml_U2(1,1)*TP_dl1_1))+...
            times((1-P_F),...
           (aE_C22+...
            th_ml_U2(2,1)+...
            th_ml_U2(3,1)*TP_dl1_1))+...
            times(times(P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)));    


    
end   
end

FU=times((times(1,power((1-(times(beta,(1-P_B)))),-1))),FU);

V_A(:,a)=FU;

end        


















%6  BACKWARD RECURSION: AGE 65 to 30

for A=64.5:(-0.5):30

%TP Cube Layer (Using A_it)
    a=(A-30)*2+1;                                     
%TP for this iteration
    TPa=TP(:,:,a);  

%EXTRACT TP COMPONENTS FOR TRANSITIONS
    
TP_v        =TPa(:,1);    
TP_dh       =TPa(:,2);
TP_H        =TPa(:,3);    
TP_E        =TPa(:,4);    
TP_dl0_1    =TPa(:,5);
TP_dl1_1    =TPa(:,6);
TP_dm0_0    =TPa(:,7);
TP_dm1_0    =TPa(:,8);
TP_dm2_0    =TPa(:,9);
TP_dm3_0    =TPa(:,10);
TP_dm0_1    =TPa(:,11);
TP_dm1_1    =TPa(:,12);
TP_dm2_1    =TPa(:,13);
TP_dm3_1    =TPa(:,14);

PP_B        =TPa(:,15);
PP_H        =TPa(:,16);
PP_F        =TPa(:,17);

EE_I         =TPa(:,18);

EE_N1        =TPa(:,19);
EE_N2        =TPa(:,20);

EE_IP    =(EE_I+2500)/5000;

%OOC ~ Health ~ Symptoms/SFX  

if type==1 || type==2

XB_B=...
    th_B1(1,1)*TP_H+...
    th_B1(2,1)*A*TP_H+...
    th_B1(3,1)*A+...
    th_B1(4,1);

P_B=exp(XB_B);
P_B=times(P_B,power((1+P_B),-1));      
    
XB_D=...
    th_D1(1,1)*TP_H+...
    th_D1(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_D1(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_D1(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_D1(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_D1(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_D1(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_D1(8,1)*TP_v+...
    th_D1(9,1);


DH=exp(XB_D);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-TP_H));
DH1=times(DH,(TP_H));

XB_H=...
    th_H1(1,1)*TP_H+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);


P_H=exp(XB_H);
P_H=times(P_H,power((1+P_H),-1));

XB_F=...
    th_F1(1,1)*TP_H+...   
    th_F1(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_F1(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_F1(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_F1(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_F1(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_F1(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_F1(8,1)*TP_v+...
    th_F1(9,1);

P_F=exp(XB_F);
P_F=times(P_F,power((1+P_F),-1));

XB_I=...
    th_I1(1,1)*TP_H+...
    th_I1(2,1)*TP_E+...
    th_I1(3,1)*times(TP_E,TP_E)+...
    th_I1(4,1)*A+...
    th_I1(5,1)*(TP_v-14)+...
   (times(TP_dl1_1,...
   (th_I1(6,1)+... 
    th_I1(7,1)*TP_H+...
    th_I1(8,1)*TP_E+...
    th_I1(9,1)*times(TP_E,TP_E)+...
    th_I1(10,1)*A+...
    th_I1(11,1)*(TP_v-14))))+...
    th_I1(12,1);

sig=th_I1(13,1);

w=times((XB_I-2500),power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_I=(2500*(1-phi_2))+(times(phi_2,XB_I)+times(sig,phi_1)); %left censored; See C&T p541 
E_IP    =(E_I+2500)/5000;

XB_N_1=...
    th_N1(1,1)*TP_dl1_1+...
    th_N1(2,1)*TP_H+...
    th_N1(3,1)*TP_E+...
    th_N1(4,1)*times(TP_E,TP_E)+...
    th_N1(5,1)*A+...
    th_N1(6,1)*A^2+...
    th_N1(7,1)*(TP_v)+...
    th_N1(8,1)*times(TP_v-24,TP_dh)+...
    th_N1(9,1);

XB_N_2=...
    th_N1(10,1)*TP_dl1_1+...
    th_N1(11,1)*TP_H+...
    th_N1(12,1)*TP_E+...
    th_N1(13,1)*times(TP_E,TP_E)+...
    th_N1(14,1)*A+...
    th_N1(15,1)*A^2+...
    th_N1(16,1)*(TP_v)+...
    th_N1(17,1)*times(TP_v-24,TP_dh)+...
    th_N1(18,1);


XB_N_1=exp(XB_N_1);
XB_N_2=exp(XB_N_2);

E_N1=times(XB_N_1,power((1+XB_N_1+XB_N_2),-1));
E_N2=times(XB_N_2,power((1+XB_N_1+XB_N_2),-1)); 


XB_P=...
    th_P1(1,1)*P_H+...
    th_P1(2,1)*times((1-P_F),P_H)+...
    th_P1(3,1)*times((1-P_F),(1-P_H))+...
    th_P1(4,1)*E_IP+...
    th_P1(5,1)*TP_dm1_1+...
    th_P1(6,1)*TP_dm2_1+...
    th_P1(7,1)*TP_dm3_1+...
    th_P1(8,1)*E_N1+...
    th_P1(9,1)*E_N2+...
    th_P1(10,1)*times(E_N1,TP_dm1_1)+...
    th_P1(11,1)*times(E_N2,TP_dm1_1)+...    
    th_P1(12,1)*times(E_N1,TP_dm2_1)+...
    th_P1(13,1)*times(E_N2,TP_dm2_1)+...    
    th_P1(14,1)*times(E_N1,TP_dm3_1)+...
    th_P1(15,1)*times(E_N2,TP_dm3_1)+...    
    th_P1(16,1)*(TP_v)+...
    th_P1(17,1);

sig0=  th_S1(1,1)*TP_dm0_1;  
sig1=  th_S1(2,1)*TP_dm1_1;
sig2=  th_S1(3,1)*TP_dm2_1;
sig3=  th_S1(4,1)*TP_dm3_1;
sig=sig0+sig1+sig2+sig3;

w=times(XB_P,power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_P=times(phi_2,XB_P)+times(sig,phi_1); %left censored; See C&T p541

elseif type==3 || type==4

XB_B=...
    th_B2(1,1)*TP_H+...
    th_B2(2,1)*A*TP_H+...
    th_B2(3,1)*A+...
    th_B2(4,1);

P_B=exp(XB_B);
P_B=times(P_B,power((1+P_B),-1));       
    
XB_D=...
    th_D2(1,1)*TP_H+...
    th_D2(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_D2(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_D2(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_D2(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_D2(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_D2(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_D2(8,1)*TP_v+...
    th_D2(9,1);

DH=exp(XB_D);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-TP_H));
DH1=times(DH,(TP_H));

XB_H=...
    th_H2(1,1)*TP_H+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


P_H=exp(XB_H);
P_H=times(P_H,power((1+P_H),-1));

XB_F=...
    th_F2(1,1)*TP_H+...   
    th_F2(2,1)*times((1-TP_H),TP_dm1_1)+...
    th_F2(3,1)*times((1-TP_H),TP_dm2_1)+...
    th_F2(4,1)*times((1-TP_H),TP_dm3_1)+...
    th_F2(5,1)*times((TP_H)  ,TP_dm1_1)+...
    th_F2(6,1)*times((TP_H)  ,TP_dm2_1)+...
    th_F2(7,1)*times((TP_H)  ,TP_dm3_1)+...
    th_F2(8,1)*TP_v+...
    th_F2(9,1);


P_F=exp(XB_F);
P_F=times(P_F,power((1+P_F),-1));

XB_I=...
    th_I2(1,1)*TP_H+...
    th_I2(2,1)*TP_E+...
    th_I2(3,1)*times(TP_E,TP_E)+...
    th_I2(4,1)*A+...
    th_I2(5,1)*(TP_v-14)+...
   (times(TP_dl1_1,...
   (th_I2(6,1)+... 
    th_I2(7,1)*TP_H+...
    th_I2(8,1)*TP_E+...
    th_I2(9,1)*times(TP_E,TP_E)+...
    th_I2(10,1)*A+...
    th_I2(11,1)*(TP_v-14))))+...
    th_I2(12,1);

sig=th_I2(13,1);

w=times((XB_I-2500),power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_I=(2500*(1-phi_2))+(times(phi_2,XB_I)+times(sig,phi_1)); %left censored; See C&T p541 
E_IP    =(E_I+2500)/5000;


XB_N_1=...
    th_N2(1,1)*TP_dl1_1+...
    th_N2(2,1)*TP_H+...
    th_N2(3,1)*TP_E+...
    th_N2(4,1)*times(TP_E,TP_E)+...
    th_N2(5,1)*A+...
    th_N2(6,1)*A^2+...
    th_N2(7,1)*(TP_v)+...
    th_N2(8,1)*times(TP_v-24,TP_dh)+...
    th_N2(9,1);

XB_N_2=...
    th_N2(10,1)*TP_dl1_1+...
    th_N2(11,1)*TP_H+...
    th_N2(12,1)*TP_E+...
    th_N2(13,1)*times(TP_E,TP_E)+...
    th_N2(14,1)*A+...
    th_N2(15,1)*A^2+...
    th_N2(16,1)*(TP_v)+...
    th_N2(17,1)*times(TP_v-24,TP_dh)+...
    th_N2(18,1);


XB_N_1=exp(XB_N_1);
XB_N_2=exp(XB_N_2);

E_N1=times(XB_N_1,power((1+XB_N_1+XB_N_2),-1));
E_N2=times(XB_N_2,power((1+XB_N_1+XB_N_2),-1));


XB_P=...
    th_P2(1,1)*P_H+...
    th_P2(2,1)*times((1-P_F),P_H)+...
    th_P2(3,1)*times((1-P_F),(1-P_H))+...
    th_P2(4,1)*E_IP+...
    th_P2(5,1)*TP_dm1_1+...
    th_P2(6,1)*TP_dm2_1+...
    th_P2(7,1)*TP_dm3_1+...
    th_P2(8,1)*E_N1+...
    th_P2(9,1)*E_N2+...
    th_P2(10,1)*times(E_N1,TP_dm1_1)+...
    th_P2(11,1)*times(E_N2,TP_dm1_1)+...    
    th_P2(12,1)*times(E_N1,TP_dm2_1)+...
    th_P2(13,1)*times(E_N2,TP_dm2_1)+...    
    th_P2(14,1)*times(E_N1,TP_dm3_1)+...
    th_P2(15,1)*times(E_N2,TP_dm3_1)+...    
    th_P2(16,1)*(TP_v)+...
    th_P2(17,1);

sig0=  th_S2(1,1)*TP_dm0_1;  
sig1=  th_S2(2,1)*TP_dm1_1;
sig2=  th_S2(3,1)*TP_dm2_1;
sig3=  th_S2(4,1)*TP_dm3_1;
sig=sig0+sig1+sig2+sig3;

w=times(XB_P,power(sig,-1));
phi_1=normpdf(w,0,1);  
phi_2=normcdf(w,0,1);  
E_P=times(phi_2,XB_P)+times(sig,phi_1); %left censored; See C&T p541

end


if LA1==1
    
    aE_C=(1/(1-alpha1(1,1)))*power((E_I-E_P),(1-alpha1(1,1)));

elseif LA1==2 && LA2==0

    aE_C11=(1/(1-alpha1(1,1)))*power((E_I-E_P),(1-alpha1(1,1)));
    aE_C12=(1/(1-alpha1(2,1)))*power((E_I-E_P),(1-alpha1(2,1)));
       
elseif LA1==2 && LA2==2

    aE_C11=(1/(1-alpha1(1,1)))*power((E_I-E_P),(1-alpha1(1,1)));
    aE_C12=(1/(1-alpha1(2,1)))*power((E_I-E_P),(1-alpha1(2,1)));
    aE_C21=(1/(1-alpha2(1,1)))*power((E_I-E_P),(1-alpha2(1,1)));
    aE_C22=(1/(1-alpha2(2,1)))*power((E_I-E_P),(1-alpha2(2,1)));
    
end



%Construct Expected Flow Utility
                                    
if type==1 || type==3
if MODEL==1   

FU=         aE_C+...
            th_ml_U1(1,1)*TP_dl1_1+...
            th_ml_U1(2,1)*(1-P_F)+...
            th_ml_U1(3,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(4,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(4,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(4,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_0),TP_dm0_1);    
                
elseif MODEL==2
    
FU=         times(P_F,...
           (aE_C11+...
            th_ml_U1(1,1)*TP_dl1_1))+...
            times((1-P_F),...
           (aE_C12+...
            th_ml_U1(2,1)+...
            th_ml_U1(3,1)*TP_dl1_1))+...
            times(times(P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)));  


  


elseif MODEL==3 || MODEL==4 || MODEL==5
 
 
FU=         times(P_F,...
           (aE_C11+...
            th_ml_U1(1,1)*TP_dl1_1))+...
            times((1-P_F),...
           (aE_C12+...
            th_ml_U1(2,1)+...
            th_ml_U1(3,1)*TP_dl1_1))+...
            times(times(P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)));   
   

end

elseif type==2 || type==4
if MODEL==3 || MODEL==4 || MODEL==5 

    
FU=         times(P_F,...
           (aE_C21+...
            th_ml_U2(1,1)*TP_dl1_1))+...
            times((1-P_F),...
           (aE_C22+...
            th_ml_U2(2,1)+...
            th_ml_U2(3,1)*TP_dl1_1))+...
            times(times(P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,P_F),...
           (th_ml_U1(4,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(5,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(6,1)*times((1-TP_dm0_0),TP_dm0_1)))+...  
            times(times(1-P_H,1-P_F),...
           (th_ml_U1(7,1)*times(TP_dm0_0,(1-TP_dm0_1))+...                   
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm1_0,(1-TP_dm1_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm2_0,(1-TP_dm2_1))))+...                  
            th_ml_U1(8,1)*times((1-TP_dm0_1),(times(TP_dm3_0,(1-TP_dm3_1))))+...                  
            th_ml_U1(9,1)*times((1-TP_dm0_0),TP_dm0_1)));   

        
end   
end
   
%Obtain Continuation (a+1) Payoffs for each choice/state combo.
%Use error structure to obtain probabilities at next age

% CHOICE SPECIFIC VALUES --> PROBABILITIES

% VA1=V_A(:,(a+1))

CORRECTION=max(V_A(:,(a+1)));
VA1=V_A(:,(a+1))-CORRECTION;

%HERE: forming {ln[\sum_{d^{'}}(v_t+1(x_{t+1},d^{'}_t+1)]+\gamma}

VA11=VA1(1:810);
VA11=reshape(VA11,6,[]);
% VA11=exp(VA11);
% VA11=sum(VA11);
% VA11=log(VA11);
% V1=transpose(VA11);
% V1=V1+.5772;        
V1=.5772+transpose(log(sum(exp(VA11))))+CORRECTION;

VA11=VA1(811:3530);
VA11=reshape(VA11,8,[]);
% VA11=exp(VA11);
% VA11=sum(VA11);
% VA11=log(VA11);
% V2=transpose(VA11);
% V2=V2+.5772; 
V2=.5772+transpose(log(sum(exp(VA11))))+CORRECTION;

VA11=VA1(3531:4340);
VA11=reshape(VA11,6,[]);
% VA11=exp(VA11);
% VA11=sum(VA11);
% VA11=log(VA11);
% V3=transpose(VA11);
% V3=V3+.5772; 
V3=.5772+transpose(log(sum(exp(VA11))))+CORRECTION;

VA11=VA1(4341:7060);
VA11=reshape(VA11,8,[]);
% VA11=exp(VA11);
% VA11=sum(VA11);
% VA11=log(VA11);
% V4=transpose(VA11);
% V4=V4+.5772;        
V4=.5772+transpose(log(sum(exp(VA11))))+CORRECTION;



weight1=0.95;
weight2=0.05;
        
for i=1:18:793
for j=((i-1)/18)*3+1
k=(j-1)/3+1;
if mod(k,5)~=0    

V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1)) *V1(j+0,1))+(P_H(i+0,1) *V3(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V1(j+0,1))+(P_H(i+1,1) *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V1(j+3,1))+(P_H(i+1,1) *V3(j+3,1)));

V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1)) *V1(j+1,1))+(P_H(i+2,1) *V3(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V1(j+1,1))+(P_H(i+3,1) *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V1(j+4,1))+(P_H(i+3,1) *V3(j+4,1)));

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1)) *V1(j+2,1))+(P_H(i+4,1) *V3(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V1(j+2,1))+(P_H(i+5,1) *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V1(j+5,1))+(P_H(i+5,1) *V3(j+5,1)));

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1)) *V1(j+0,1))+(P_H(i+6,1) *V3(j+0,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V1(j+0,1))+(P_H(i+7,1) *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V1(j+3,1))+(P_H(i+7,1) *V3(j+3,1)));

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1)) *V1(j+1,1))+(P_H(i+8,1) *V3(j+1,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V1(j+1,1))+(P_H(i+9,1) *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V1(j+4,1))+(P_H(i+9,1) *V3(j+4,1)));

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))*V1(j+2,1))+(P_H(i+10,1)*V3(j+2,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V1(j+2,1))+(P_H(i+11,1)*V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V1(j+5,1))+(P_H(i+11,1)*V3(j+5,1)));

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))*V1(j+0,1))+(P_H(i+12,1)*V3(j+0,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V1(j+0,1))+(P_H(i+13,1)*V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V1(j+3,1))+(P_H(i+13,1)*V3(j+3,1)));

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))*V1(j+1,1))+(P_H(i+14,1)*V3(j+1,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V1(j+1,1))+(P_H(i+15,1)*V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V1(j+4,1))+(P_H(i+15,1)*V3(j+4,1)));

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))*V1(j+2,1))+(P_H(i+16,1)*V3(j+2,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V1(j+2,1))+(P_H(i+17,1)*V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V1(j+5,1))+(P_H(i+17,1)*V3(j+5,1)));

else
    
V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1)) *   V1(j+0,1))             +(P_H(i+0,1)   *V3(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *   V1(j+0,1))             +(P_H(i+1,1)   *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *(2*V1(j+0,1)-V1(j+0-3,1)))+(P_H(i+1,1)*(2*V3(j+0,1)-V3(j+0-3,1))));
    
V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1)) *   V1(j+1,1))             +(P_H(i+2,1)   *V3(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *   V1(j+1,1))             +(P_H(i+3,1)   *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *(2*V1(j+1,1)-V1(j+1-3,1)))+(P_H(i+3,1)*(2*V3(j+1,1)-V3(j+1-3,1))));

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1)) *   V1(j+2,1))             +(P_H(i+4,1)   *V3(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *   V1(j+2,1))             +(P_H(i+5,1)   *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *(2*V1(j+2,1)-V1(j+2-3,1)))+(P_H(i+5,1)*(2*V3(j+2,1)-V3(j+2-3,1))));

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1)) *   V1(j+0,1))             +(P_H(i+6,1)   *V3(j+0,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *   V1(j+0,1))             +(P_H(i+7,1)   *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *(2*V1(j+0,1)-V1(j+0-3,1)))+(P_H(i+7,1)*(2*V3(j+0,1)-V3(j+0-3,1))));

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1)) *   V1(j+1,1))             +(P_H(i+8,1)   *V3(j+1,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *   V1(j+1,1))             +(P_H(i+9,1)   *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *(2*V1(j+1,1)-V1(j+1-3,1)))+(P_H(i+9,1)*(2*V3(j+1,1)-V3(j+1-3,1))));

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))*   V1(j+2,1))             +(P_H(i+10,1)   *V3(j+2,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*   V1(j+2,1))             +(P_H(i+11,1)   *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*(2*V1(j+2,1)-V1(j+2-3,1)))+(P_H(i+11,1)*(2*V3(j+2,1)-V3(j+2-3,1))));

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))*   V1(j+0,1))             +(P_H(i+12,1)   *V3(j+0,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*   V1(j+0,1))             +(P_H(i+13,1)   *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*(2*V1(j+0,1)-V1(j+0-3,1)))+(P_H(i+13,1)*(2*V3(j+0,1)-V3(j+0-3,1))));

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))*   V1(j+1,1))             +(P_H(i+14,1)   *V3(j+1,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*   V1(j+1,1))             +(P_H(i+15,1)   *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*(2*V1(j+1,1)-V1(j+1-3,1)))+(P_H(i+15,1)*(2*V3(j+1,1)-V3(j+1-3,1))));

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))*   V1(j+2,1))             +(P_H(i+16,1)   *V3(j+2,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*   V1(j+2,1))             +(P_H(i+17,1)   *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*(2*V1(j+2,1)-V1(j+2-3,1)))+(P_H(i+17,1)*(2*V3(j+2,1)-V3(j+2-3,1))));

end
end
end

for i=811:32:3499
for j=((i-811)/32)*4+1    
k=(j-1)/4+1;
if mod(k,5)~=0 
           
V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1)) *V2(j+0,1))+(P_H(i+0,1) *V4(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V2(j+0,1))+(P_H(i+1,1) *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V2(j+4,1))+(P_H(i+1,1) *V4(j+4,1)));

V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1)) *V2(j+1,1))+(P_H(i+2,1) *V4(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V2(j+1,1))+(P_H(i+3,1) *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V2(j+5,1))+(P_H(i+3,1) *V4(j+5,1)));

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1)) *V2(j+2,1))+(P_H(i+4,1) *V4(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V2(j+2,1))+(P_H(i+5,1) *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V2(j+6,1))+(P_H(i+5,1) *V4(j+6,1)));

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1)) *V2(j+3,1))+(P_H(i+6,1) *V4(j+3,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V2(j+3,1))+(P_H(i+7,1) *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V2(j+7,1))+(P_H(i+7,1) *V4(j+7,1)));

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1)) *V2(j+0,1))+(P_H(i+8,1) *V4(j+0,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V2(j+0,1))+(P_H(i+9,1) *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V2(j+4,1))+(P_H(i+9,1) *V4(j+4,1)));

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))*V2(j+1,1))+(P_H(i+10,1)*V4(j+1,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V2(j+1,1))+(P_H(i+11,1)*V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V2(j+5,1))+(P_H(i+11,1)*V4(j+5,1)));

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))*V2(j+2,1))+(P_H(i+12,1)*V4(j+2,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V2(j+2,1))+(P_H(i+13,1)*V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V2(j+6,1))+(P_H(i+13,1)*V4(j+6,1)));

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))*V2(j+3,1))+(P_H(i+14,1)*V4(j+3,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V2(j+3,1))+(P_H(i+15,1)*V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V2(j+7,1))+(P_H(i+15,1)*V4(j+7,1)));

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))*V2(j+0,1))+(P_H(i+16,1)*V4(j+0,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V2(j+0,1))+(P_H(i+17,1)*V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V2(j+4,1))+(P_H(i+17,1)*V4(j+4,1)));

V_A(i+18,a)=FU(i+18,1)  +        (beta*(1-P_B(i+18,1)))*(((1-P_H(i+18,1))*V2(j+1,1))+(P_H(i+18,1)*V4(j+1,1)));
V_A(i+19,a)=FU(i+19,1)  +weight1*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))*V2(j+1,1))+(P_H(i+19,1)*V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))*V2(j+5,1))+(P_H(i+19,1)*V4(j+5,1)));

V_A(i+20,a)=FU(i+20,1)  +        (beta*(1-P_B(i+20,1)))*(((1-P_H(i+20,1))*V2(j+2,1))+(P_H(i+20,1)*V4(j+2,1)));
V_A(i+21,a)=FU(i+21,1)  +weight1*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))*V2(j+2,1))+(P_H(i+21,1)*V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))*V2(j+6,1))+(P_H(i+21,1)*V4(j+6,1)));

V_A(i+22,a)=FU(i+22,1)  +        (beta*(1-P_B(i+22,1)))*(((1-P_H(i+22,1))*V2(j+3,1))+(P_H(i+22,1)*V4(j+3,1)));
V_A(i+23,a)=FU(i+23,1)  +weight1*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))*V2(j+3,1))+(P_H(i+23,1)*V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))*V2(j+7,1))+(P_H(i+23,1)*V4(j+7,1)));

V_A(i+24,a)=FU(i+24,1)  +        (beta*(1-P_B(i+24,1)))*(((1-P_H(i+24,1))*V2(j+0,1))+(P_H(i+24,1)*V4(j+0,1)));
V_A(i+25,a)=FU(i+25,1)  +weight1*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))*V2(j+0,1))+(P_H(i+25,1)*V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))*V2(j+4,1))+(P_H(i+25,1)*V4(j+4,1)));

V_A(i+26,a)=FU(i+26,1)  +        (beta*(1-P_B(i+26,1)))*(((1-P_H(i+26,1))*V2(j+1,1))+(P_H(i+26,1)*V4(j+1,1)));
V_A(i+27,a)=FU(i+27,1)  +weight1*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))*V2(j+1,1))+(P_H(i+27,1)*V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))*V2(j+5,1))+(P_H(i+27,1)*V4(j+5,1)));

V_A(i+28,a)=FU(i+28,1)  +        (beta*(1-P_B(i+28,1)))*(((1-P_H(i+28,1))*V2(j+2,1))+(P_H(i+28,1)*V4(j+2,1)));
V_A(i+29,a)=FU(i+29,1)  +weight1*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))*V2(j+2,1))+(P_H(i+29,1)*V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))*V2(j+6,1))+(P_H(i+29,1)*V4(j+6,1)));

V_A(i+30,a)=FU(i+30,1)  +        (beta*(1-P_B(i+30,1)))*(((1-P_H(i+30,1))*V2(j+3,1))+(P_H(i+30,1)*V4(j+3,1)));
V_A(i+31,a)=FU(i+31,1)  +weight1*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))*V2(j+3,1))+(P_H(i+31,1)*V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))*V2(j+7,1))+(P_H(i+31,1)*V4(j+7,1)));    

                    
                    
                    
                    
else
    
V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1))    *V2(j+0,1))             +(P_H(i+0,1)   *V4(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1))    *V2(j+0,1))             +(P_H(i+1,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+1,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    
                  
V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1))    *V2(j+1,1))             +(P_H(i+2,1)   *V4(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1))    *V2(j+1,1))             +(P_H(i+3,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+3,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1))    *V2(j+2,1))             +(P_H(i+4,1)   *V4(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1))    *V2(j+2,1))             +(P_H(i+5,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+5,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1))    *V2(j+3,1))             +(P_H(i+6,1)   *V4(j+3,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1))    *V2(j+3,1))             +(P_H(i+7,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+7,1)*(2*V4(j+3,1)-V4(j+3-4,1))));                    

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1))    *V2(j+0,1))             +(P_H(i+8,1)   *V4(j+0,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1))    *V2(j+0,1))             +(P_H(i+9,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+9,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))   *V2(j+1,1))             +(P_H(i+10,1)   *V4(j+1,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))   *V2(j+1,1))             +(P_H(i+11,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+11,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    
    
V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))   *V2(j+2,1))             +(P_H(i+12,1)   *V4(j+2,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))   *V2(j+2,1))             +(P_H(i+13,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+13,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))   *V2(j+3,1))             +(P_H(i+14,1)   *V4(j+3,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))   *V2(j+3,1))             +(P_H(i+15,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+15,1)*(2*V4(j+3,1)-V4(j+3-4,1))));                    

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))   *V2(j+0,1))             +(P_H(i+16,1)   *V4(j+0,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))   *V2(j+0,1))             +(P_H(i+17,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+17,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    

V_A(i+18,a)=FU(i+18,1)  +        (beta*(1-P_B(i+18,1)))*(((1-P_H(i+18,1))   *V2(j+1,1))             +(P_H(i+18,1)   *V4(j+1,1)));
V_A(i+19,a)=FU(i+19,1)  +weight1*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))   *V2(j+1,1))             +(P_H(i+19,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))*(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+19,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+20,a)=FU(i+20,1)  +        (beta*(1-P_B(i+20,1)))*(((1-P_H(i+20,1))   *V2(j+2,1))             +(P_H(i+20,1)   *V4(j+2,1)));
V_A(i+21,a)=FU(i+21,1)  +weight1*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))   *V2(j+2,1))             +(P_H(i+21,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))*(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+21,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+22,a)=FU(i+22,1)  +        (beta*(1-P_B(i+22,1)))*(((1-P_H(i+22,1))   *V2(j+3,1))             +(P_H(i+22,1)   *V4(j+3,1)));
V_A(i+23,a)=FU(i+23,1)  +weight1*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))   *V2(j+3,1))             +(P_H(i+23,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))*(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+23,1)*(2*V4(j+3,1)-V4(j+3-4,1))));                    

V_A(i+24,a)=FU(i+24,1)  +        (beta*(1-P_B(i+24,1)))*(((1-P_H(i+24,1))   *V2(j+0,1))             +(P_H(i+24,1)   *V4(j+0,1)));
V_A(i+25,a)=FU(i+25,1)  +weight1*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))   *V2(j+0,1))             +(P_H(i+25,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))*(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+25,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    

V_A(i+26,a)=FU(i+26,1)  +        (beta*(1-P_B(i+26,1)))*(((1-P_H(i+26,1))   *V2(j+1,1))             +(P_H(i+26,1)   *V4(j+1,1)));
V_A(i+27,a)=FU(i+27,1)  +weight1*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))   *V2(j+1,1))             +(P_H(i+27,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))*(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+27,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+28,a)=FU(i+28,1)  +        (beta*(1-P_B(i+28,1)))*(((1-P_H(i+28,1))   *V2(j+2,1))             +(P_H(i+28,1)   *V4(j+2,1)));
V_A(i+29,a)=FU(i+29,1)  +weight1*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))   *V2(j+2,1))             +(P_H(i+29,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))*(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+29,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+30,a)=FU(i+30,1)  +        (beta*(1-P_B(i+30,1)))*(((1-P_H(i+30,1))   *V2(j+3,1))             +(P_H(i+30,1)   *V4(j+3,1)));
V_A(i+31,a)=FU(i+31,1)  +weight1*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))   *V2(j+3,1))             +(P_H(i+31,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))*(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+31,1)*(2*V4(j+3,1)-V4(j+3-4,1))));            
end                    
end
end

for i=3531:18:4323
for j=((i-3531)/18)*3+1
k=(j-1)/3+1;
if mod(k,5)~=0    

V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1)) *V1(j+0,1))+(P_H(i+0,1) *V3(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V1(j+0,1))+(P_H(i+1,1) *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V1(j+3,1))+(P_H(i+1,1) *V3(j+3,1)));

V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1)) *V1(j+1,1))+(P_H(i+2,1) *V3(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V1(j+1,1))+(P_H(i+3,1) *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V1(j+4,1))+(P_H(i+3,1) *V3(j+4,1)));

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1)) *V1(j+2,1))+(P_H(i+4,1) *V3(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V1(j+2,1))+(P_H(i+5,1) *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V1(j+5,1))+(P_H(i+5,1) *V3(j+5,1)));

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1)) *V1(j+0,1))+(P_H(i+6,1) *V3(j+0,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V1(j+0,1))+(P_H(i+7,1) *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V1(j+3,1))+(P_H(i+7,1) *V3(j+3,1)));

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1)) *V1(j+1,1))+(P_H(i+8,1) *V3(j+1,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V1(j+1,1))+(P_H(i+9,1) *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V1(j+4,1))+(P_H(i+9,1) *V3(j+4,1)));

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))*V1(j+2,1))+(P_H(i+10,1)*V3(j+2,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V1(j+2,1))+(P_H(i+11,1)*V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V1(j+5,1))+(P_H(i+11,1)*V3(j+5,1)));

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))*V1(j+0,1))+(P_H(i+12,1)*V3(j+0,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V1(j+0,1))+(P_H(i+13,1)*V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V1(j+3,1))+(P_H(i+13,1)*V3(j+3,1)));

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))*V1(j+1,1))+(P_H(i+14,1)*V3(j+1,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V1(j+1,1))+(P_H(i+15,1)*V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V1(j+4,1))+(P_H(i+15,1)*V3(j+4,1)));

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))*V1(j+2,1))+(P_H(i+16,1)*V3(j+2,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V1(j+2,1))+(P_H(i+17,1)*V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V1(j+5,1))+(P_H(i+17,1)*V3(j+5,1)));


else
    
V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1)) *   V1(j+0,1))             +(P_H(i+0,1)   *V3(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *   V1(j+0,1))             +(P_H(i+1,1)   *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *(2*V1(j+0,1)-V1(j+0-3,1)))+(P_H(i+1,1)*(2*V3(j+0,1)-V3(j+0-3,1))));
    
V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1)) *   V1(j+1,1))             +(P_H(i+2,1)   *V3(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *   V1(j+1,1))             +(P_H(i+3,1)   *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *(2*V1(j+1,1)-V1(j+1-3,1)))+(P_H(i+3,1)*(2*V3(j+1,1)-V3(j+1-3,1))));

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1)) *   V1(j+2,1))             +(P_H(i+4,1)   *V3(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *   V1(j+2,1))             +(P_H(i+5,1)   *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *(2*V1(j+2,1)-V1(j+2-3,1)))+(P_H(i+5,1)*(2*V3(j+2,1)-V3(j+2-3,1))));

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1)) *   V1(j+0,1))             +(P_H(i+6,1)   *V3(j+0,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *   V1(j+0,1))             +(P_H(i+7,1)   *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *(2*V1(j+0,1)-V1(j+0-3,1)))+(P_H(i+7,1)*(2*V3(j+0,1)-V3(j+0-3,1))));

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1)) *   V1(j+1,1))             +(P_H(i+8,1)   *V3(j+1,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *   V1(j+1,1))             +(P_H(i+9,1)   *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *(2*V1(j+1,1)-V1(j+1-3,1)))+(P_H(i+9,1)*(2*V3(j+1,1)-V3(j+1-3,1))));

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))*   V1(j+2,1))             +(P_H(i+10,1)   *V3(j+2,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*   V1(j+2,1))             +(P_H(i+11,1)   *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*(2*V1(j+2,1)-V1(j+2-3,1)))+(P_H(i+11,1)*(2*V3(j+2,1)-V3(j+2-3,1))));

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))*   V1(j+0,1))             +(P_H(i+12,1)   *V3(j+0,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*   V1(j+0,1))             +(P_H(i+13,1)   *V3(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*(2*V1(j+0,1)-V1(j+0-3,1)))+(P_H(i+13,1)*(2*V3(j+0,1)-V3(j+0-3,1))));

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))*   V1(j+1,1))             +(P_H(i+14,1)   *V3(j+1,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*   V1(j+1,1))             +(P_H(i+15,1)   *V3(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*(2*V1(j+1,1)-V1(j+1-3,1)))+(P_H(i+15,1)*(2*V3(j+1,1)-V3(j+1-3,1))));

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))*   V1(j+2,1))             +(P_H(i+16,1)   *V3(j+2,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*   V1(j+2,1))             +(P_H(i+17,1)   *V3(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*(2*V1(j+2,1)-V1(j+2-3,1)))+(P_H(i+17,1)*(2*V3(j+2,1)-V3(j+2-3,1))));


end
end
end


for i=4341:32:7029
for j=((i-4341)/32)*4+1      
k=(j-1)/4+1;
if mod(k,5)~=0 
           
V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1)) *V2(j+0,1))+(P_H(i+0,1) *V4(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V2(j+0,1))+(P_H(i+1,1) *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *V2(j+4,1))+(P_H(i+1,1) *V4(j+4,1)));

V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1)) *V2(j+1,1))+(P_H(i+2,1) *V4(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V2(j+1,1))+(P_H(i+3,1) *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *V2(j+5,1))+(P_H(i+3,1) *V4(j+5,1)));

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1)) *V2(j+2,1))+(P_H(i+4,1) *V4(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V2(j+2,1))+(P_H(i+5,1) *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *V2(j+6,1))+(P_H(i+5,1) *V4(j+6,1)));

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1)) *V2(j+3,1))+(P_H(i+6,1) *V4(j+3,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V2(j+3,1))+(P_H(i+7,1) *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *V2(j+7,1))+(P_H(i+7,1) *V4(j+7,1)));

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1)) *V2(j+0,1))+(P_H(i+8,1) *V4(j+0,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V2(j+0,1))+(P_H(i+9,1) *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *V2(j+4,1))+(P_H(i+9,1) *V4(j+4,1)));

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))*V2(j+1,1))+(P_H(i+10,1)*V4(j+1,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V2(j+1,1))+(P_H(i+11,1)*V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*V2(j+5,1))+(P_H(i+11,1)*V4(j+5,1)));

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))*V2(j+2,1))+(P_H(i+12,1)*V4(j+2,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V2(j+2,1))+(P_H(i+13,1)*V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*V2(j+6,1))+(P_H(i+13,1)*V4(j+6,1)));

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))*V2(j+3,1))+(P_H(i+14,1)*V4(j+3,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V2(j+3,1))+(P_H(i+15,1)*V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*V2(j+7,1))+(P_H(i+15,1)*V4(j+7,1)));

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))*V2(j+0,1))+(P_H(i+16,1)*V4(j+0,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V2(j+0,1))+(P_H(i+17,1)*V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*V2(j+4,1))+(P_H(i+17,1)*V4(j+4,1)));

V_A(i+18,a)=FU(i+18,1)  +        (beta*(1-P_B(i+18,1)))*(((1-P_H(i+18,1))*V2(j+1,1))+(P_H(i+18,1)*V4(j+1,1)));
V_A(i+19,a)=FU(i+19,1)  +weight1*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))*V2(j+1,1))+(P_H(i+19,1)*V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))*V2(j+5,1))+(P_H(i+19,1)*V4(j+5,1)));

V_A(i+20,a)=FU(i+20,1)  +        (beta*(1-P_B(i+20,1)))*(((1-P_H(i+20,1))*V2(j+2,1))+(P_H(i+20,1)*V4(j+2,1)));
V_A(i+21,a)=FU(i+21,1)  +weight1*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))*V2(j+2,1))+(P_H(i+21,1)*V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))*V2(j+6,1))+(P_H(i+21,1)*V4(j+6,1)));

V_A(i+22,a)=FU(i+22,1)  +        (beta*(1-P_B(i+22,1)))*(((1-P_H(i+22,1))*V2(j+3,1))+(P_H(i+22,1)*V4(j+3,1)));
V_A(i+23,a)=FU(i+23,1)  +weight1*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))*V2(j+3,1))+(P_H(i+23,1)*V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))*V2(j+7,1))+(P_H(i+23,1)*V4(j+7,1)));

V_A(i+24,a)=FU(i+24,1)  +        (beta*(1-P_B(i+24,1)))*(((1-P_H(i+24,1))*V2(j+0,1))+(P_H(i+24,1)*V4(j+0,1)));
V_A(i+25,a)=FU(i+25,1)  +weight1*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))*V2(j+0,1))+(P_H(i+25,1)*V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))*V2(j+4,1))+(P_H(i+25,1)*V4(j+4,1)));

V_A(i+26,a)=FU(i+26,1)  +        (beta*(1-P_B(i+26,1)))*(((1-P_H(i+26,1))*V2(j+1,1))+(P_H(i+26,1)*V4(j+1,1)));
V_A(i+27,a)=FU(i+27,1)  +weight1*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))*V2(j+1,1))+(P_H(i+27,1)*V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))*V2(j+5,1))+(P_H(i+27,1)*V4(j+5,1)));

V_A(i+28,a)=FU(i+28,1)  +        (beta*(1-P_B(i+28,1)))*(((1-P_H(i+28,1))*V2(j+2,1))+(P_H(i+28,1)*V4(j+2,1)));
V_A(i+29,a)=FU(i+29,1)  +weight1*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))*V2(j+2,1))+(P_H(i+29,1)*V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))*V2(j+6,1))+(P_H(i+29,1)*V4(j+6,1)));

V_A(i+30,a)=FU(i+30,1)  +        (beta*(1-P_B(i+30,1)))*(((1-P_H(i+30,1))*V2(j+3,1))+(P_H(i+30,1)*V4(j+3,1)));
V_A(i+31,a)=FU(i+31,1)  +weight1*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))*V2(j+3,1))+(P_H(i+31,1)*V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))*V2(j+7,1))+(P_H(i+31,1)*V4(j+7,1)));    

                    
                    
                    
                    
else
    
V_A(i+0,a) =FU(i+0,1)   +        (beta*(1-P_B(i+0,1))) *(((1-P_H(i+0,1))    *V2(j+0,1))             +(P_H(i+0,1)   *V4(j+0,1)));
V_A(i+1,a) =FU(i+1,1)   +weight1*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1))    *V2(j+0,1))             +(P_H(i+1,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+1,1))) *(((1-P_H(i+1,1)) *(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+1,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    
                    
V_A(i+2,a) =FU(i+2,1)   +        (beta*(1-P_B(i+2,1))) *(((1-P_H(i+2,1))    *V2(j+1,1))             +(P_H(i+2,1)   *V4(j+1,1)));
V_A(i+3,a) =FU(i+3,1)   +weight1*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1))    *V2(j+1,1))             +(P_H(i+3,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+3,1))) *(((1-P_H(i+3,1)) *(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+3,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+4,a) =FU(i+4,1)   +        (beta*(1-P_B(i+4,1))) *(((1-P_H(i+4,1))    *V2(j+2,1))             +(P_H(i+4,1)   *V4(j+2,1)));
V_A(i+5,a) =FU(i+5,1)   +weight1*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1))    *V2(j+2,1))             +(P_H(i+5,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+5,1))) *(((1-P_H(i+5,1)) *(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+5,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+6,a) =FU(i+6,1)   +        (beta*(1-P_B(i+6,1))) *(((1-P_H(i+6,1))    *V2(j+3,1))             +(P_H(i+6,1)   *V4(j+3,1)));
V_A(i+7,a) =FU(i+7,1)   +weight1*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1))    *V2(j+3,1))             +(P_H(i+7,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+7,1))) *(((1-P_H(i+7,1)) *(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+7,1)*(2*V4(j+3,1)-V4(j+3-4,1))));                    

V_A(i+8,a) =FU(i+8,1)   +        (beta*(1-P_B(i+8,1))) *(((1-P_H(i+8,1))    *V2(j+0,1))             +(P_H(i+8,1)   *V4(j+0,1)));
V_A(i+9,a) =FU(i+9,1)   +weight1*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1))    *V2(j+0,1))             +(P_H(i+9,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+9,1))) *(((1-P_H(i+9,1)) *(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+9,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    

V_A(i+10,a)=FU(i+10,1)  +        (beta*(1-P_B(i+10,1)))*(((1-P_H(i+10,1))   *V2(j+1,1))             +(P_H(i+10,1)   *V4(j+1,1)));
V_A(i+11,a)=FU(i+11,1)  +weight1*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))   *V2(j+1,1))             +(P_H(i+11,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+11,1)))*(((1-P_H(i+11,1))*(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+11,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+12,a)=FU(i+12,1)  +        (beta*(1-P_B(i+12,1)))*(((1-P_H(i+12,1))   *V2(j+2,1))             +(P_H(i+12,1)   *V4(j+2,1)));
V_A(i+13,a)=FU(i+13,1)  +weight1*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))   *V2(j+2,1))             +(P_H(i+13,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+13,1)))*(((1-P_H(i+13,1))*(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+13,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+14,a)=FU(i+14,1)  +        (beta*(1-P_B(i+14,1)))*(((1-P_H(i+14,1))   *V2(j+3,1))             +(P_H(i+14,1)   *V4(j+3,1)));
V_A(i+15,a)=FU(i+15,1)  +weight1*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))   *V2(j+3,1))             +(P_H(i+15,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+15,1)))*(((1-P_H(i+15,1))*(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+15,1)*(2*V4(j+3,1)-V4(j+3-4,1))));                    

V_A(i+16,a)=FU(i+16,1)  +        (beta*(1-P_B(i+16,1)))*(((1-P_H(i+16,1))   *V2(j+0,1))             +(P_H(i+16,1)   *V4(j+0,1)));
V_A(i+17,a)=FU(i+17,1)  +weight1*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))   *V2(j+0,1))             +(P_H(i+17,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+17,1)))*(((1-P_H(i+17,1))*(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+17,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    

V_A(i+18,a)=FU(i+18,1)  +        (beta*(1-P_B(i+18,1)))*(((1-P_H(i+18,1))   *V2(j+1,1))             +(P_H(i+18,1)   *V4(j+1,1)));
V_A(i+19,a)=FU(i+19,1)  +weight1*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))   *V2(j+1,1))             +(P_H(i+19,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+19,1)))*(((1-P_H(i+19,1))*(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+19,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+20,a)=FU(i+20,1)  +        (beta*(1-P_B(i+20,1)))*(((1-P_H(i+20,1))   *V2(j+2,1))             +(P_H(i+20,1)   *V4(j+2,1)));
V_A(i+21,a)=FU(i+21,1)  +weight1*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))   *V2(j+2,1))             +(P_H(i+21,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+21,1)))*(((1-P_H(i+21,1))*(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+21,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+22,a)=FU(i+22,1)  +        (beta*(1-P_B(i+22,1)))*(((1-P_H(i+22,1))   *V2(j+3,1))             +(P_H(i+22,1)   *V4(j+3,1)));
V_A(i+23,a)=FU(i+23,1)  +weight1*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))   *V2(j+3,1))             +(P_H(i+23,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+23,1)))*(((1-P_H(i+23,1))*(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+23,1)*(2*V4(j+3,1)-V4(j+3-4,1))));                    

V_A(i+24,a)=FU(i+24,1)  +        (beta*(1-P_B(i+24,1)))*(((1-P_H(i+24,1))   *V2(j+0,1))             +(P_H(i+24,1)   *V4(j+0,1)));
V_A(i+25,a)=FU(i+25,1)  +weight1*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))   *V2(j+0,1))             +(P_H(i+25,1)   *V4(j+0,1)))+...
                        +weight2*(beta*(1-P_B(i+25,1)))*(((1-P_H(i+25,1))*(2*V2(j+0,1)-V2(j+0-4,1)))+(P_H(i+25,1)*(2*V4(j+0,1)-V4(j+0-4,1))));                    

V_A(i+26,a)=FU(i+26,1)  +        (beta*(1-P_B(i+26,1)))*(((1-P_H(i+26,1))   *V2(j+1,1))             +(P_H(i+26,1)   *V4(j+1,1)));
V_A(i+27,a)=FU(i+27,1)  +weight1*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))   *V2(j+1,1))             +(P_H(i+27,1)   *V4(j+1,1)))+...
                        +weight2*(beta*(1-P_B(i+27,1)))*(((1-P_H(i+27,1))*(2*V2(j+1,1)-V2(j+1-4,1)))+(P_H(i+27,1)*(2*V4(j+1,1)-V4(j+1-4,1))));                    

V_A(i+28,a)=FU(i+28,1)  +        (beta*(1-P_B(i+28,1)))*(((1-P_H(i+28,1))   *V2(j+2,1))             +(P_H(i+28,1)   *V4(j+2,1)));
V_A(i+29,a)=FU(i+29,1)  +weight1*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))   *V2(j+2,1))             +(P_H(i+29,1)   *V4(j+2,1)))+...
                        +weight2*(beta*(1-P_B(i+29,1)))*(((1-P_H(i+29,1))*(2*V2(j+2,1)-V2(j+2-4,1)))+(P_H(i+29,1)*(2*V4(j+2,1)-V4(j+2-4,1))));                    

V_A(i+30,a)=FU(i+30,1)  +        (beta*(1-P_B(i+30,1)))*(((1-P_H(i+30,1))   *V2(j+3,1))             +(P_H(i+30,1)   *V4(j+3,1)));
V_A(i+31,a)=FU(i+31,1)  +weight1*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))   *V2(j+3,1))             +(P_H(i+31,1)   *V4(j+3,1)))+...
                        +weight2*(beta*(1-P_B(i+31,1)))*(((1-P_H(i+31,1))*(2*V2(j+3,1)-V2(j+3-4,1)))+(P_H(i+31,1)*(2*V4(j+3,1)-V4(j+3-4,1))));            
end                    
end
end

% V_A(:,a)

end




%7  USE V_A TO CREATE CCPS (EXPLOIT EV TYPE I ERROR ASSUMPTIONS)

% exp_VA=exp(V_A);
exp_VA=exp(V_A-(max(transpose(max(V_A)))));
ccp=zeros(size(V_A));

for d0=1:6:805
    d1=d0+5;
    for x=d0:d1
        
    ccp(x,:)=times(exp_VA(x,:),power((sum(exp_VA(d0:d1,:))),-1));
    
    end
end

for d0=811:8:3523 
    d1=d0+7; 
    for x=d0:d1

    ccp(x,:)=times(exp_VA(x,:),power((sum(exp_VA(d0:d1,:))),-1));
    
    end
end

for d0=3531:6:4335 
    d1=d0+5;
    for x=d0:d1
        
    ccp(x,:)=times(exp_VA(x,:),power((sum(exp_VA(d0:d1,:))),-1));
    
    end
end

for d0=4341:8:7053 
    d1=d0+7; 
    for x=d0:d1

    ccp(x,:)=times(exp_VA(x,:),power((sum(exp_VA(d0:d1,:))),-1));
    
    end
end

CCP(:,:,type)=[ccp(:,1:70) sig];
end
end
