%{
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

Function Name:  E_INDSM
Created:        6/26/2011 by Nicholas W Papageorge
Last Modified:  9/10/2015 by Nicholas W Papageorge
Copyright:      Nicholas W Papageorge. All rights reserved.
Project:        How Does Medical Innovation Create Value?
                Health, Human Capital and the Labor Market
Description:    Converts state variables to index
%}




function  indSM  = E_INDSM(v_it,E_it,d_m0,d_l1,d_m1,H_it)
global N_E N_dm0 N_dl1 N_dm1

if v_it<=23 && H_it==0
indSM = ...
(N_dl1)*(N_dm1-1)*(N_dm0-1)*N_E*(v_it-15)+...
(N_dl1)*(N_dm1-1)*(N_dm0-1)*((E_it-10)/10)+...
(N_dl1)*(N_dm1-1)*d_m0+...
(N_dl1)*d_m1+...
d_l1+1;

elseif v_it>23 && H_it==0
indSM = ...    
810+...
(N_dl1)*(N_dm1)*(N_dm0)*N_E*(v_it-24)+...
(N_dl1)*(N_dm1)*(N_dm0)*((E_it-10)/10)+...
(N_dl1)*(N_dm1)*d_m0+...
(N_dl1)*d_m1+...
d_l1+1;


elseif v_it<=23 && H_it==1
indSM = ...
3530+...
(N_dl1)*(N_dm1-1)*(N_dm0-1)*N_E*(v_it-15)+...
(N_dl1)*(N_dm1-1)*(N_dm0-1)*((E_it-10)/10)+...
(N_dl1)*(N_dm1-1)*d_m0+...
(N_dl1)*d_m1+...
d_l1+1;


elseif v_it>23 && H_it==1
indSM = ... 
4340+...
(N_dl1)*(N_dm1)*(N_dm0)*N_E*(v_it-24)+...
(N_dl1)*(N_dm1)*(N_dm0)*((E_it-10)/10)+...
(N_dl1)*(N_dm1)*d_m0+...
(N_dl1)*d_m1+...
d_l1+1;


end


