%{
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

Function Name:  ERRORS
Created:        6/26/2011 by Nicholas W Papageorge
Last Modified:  9/10/2015 by Nicholas W Papageorge
Copyright:      Nicholas W Papageorge. All rights reserved.
Project:        How Does Medical Innovation Create Value?
                Health, Human Capital and the Labor Market
Description:    Computes errors (using outer product measure,
                numerical derivatives and the delta method).
%}





function errors=F_ERRORS(th_ml)

%Call Globally Declared Objects

global TP ERRORS_CALC
global T MODEL
global N I L
global N_H N_E N_v N_A N_dm0 N_dm1 N_dl1 DIM DIM_S N_p
global obs ind T_i startI endI 
global v_it  H_it  A_it  E_it 
global v_it1 H_it1 A_it1 I_it1 F_it1 N_1_0 N_2_0
global d_it_m  d_m0_0 d_m1_0 d_m2_0 d_m3_0  
global d_it1_l d_l0_1 
global d_it1_m d_m0_1 d_m1_1 d_m2_1 d_m3_1  
global p_it pd INCd d_h cd4I
global beta beta_p beta_D beta_H beta_F beta_B beta_I beta_N
global    LU1 LA1 LP1 LS1 LD1 LH1 LF1 LB1 LI1 LN1
global LT LU2 LA2 LP2 LS2 LD2 LH2 LF2 LB2 LI2 LN2
global LLD1g LLD2g LLD3g LLD4g LLCD1g LLCD2g LLH1g LLH2g LLF1g LLF2g
global LLN1g LLI1g LLP1g LLB1g LLTg dead1 IB

ERRORS_CALC=1 ;




% 1  Set Perturbation and Begin Loop Over Parameters

eps3 = nthroot(eps, 3); 

for p=1:N_p
    
th_ml_ERROR=th_ml;
        
h=(eps3)*abs(th_ml(p,1));

% h=(eps3)*max(abs(th_ml(p,1)),1);
% if p<=11
% else
% h=1000*(eps3)*abs(th_ml(p,1));
% end
    
for g=1:2

    p
    g
    h

    th_ml(p,1);

if g==1;    
    th_ml_ERROR(p,1)=th_ml(p,1)+h;
elseif g==2;
    th_ml_ERROR(p,1)=th_ml(p,1)-h;
end;

LL = B_LL(th_ml_ERROR)    









if MODEL==1

li_PER(:,g) =   log(LLD1g) ;

end

if MODEL==2

li_PER(:,g) =   log(LLD1g) ;

end

if MODEL==3

li_PER(:,g) =   log(LLTg(1,1)*(LLD1g) + LLTg(2,1)*(LLD2g));

end

if MODEL==4

li_PER(:,g) =   log(...
                 LLTg(1,1)*(LLD1g).*(LLCD1g).*(LLH1g).*(LLF1g)+...
                 LLTg(2,1)*(LLD2g).*(LLCD1g).*(LLH1g).*(LLF1g)+...
                 LLTg(3,1)*(LLD3g).*(LLCD2g).*(LLH2g).*(LLF2g)+...
                 LLTg(4,1)*(LLD4g).*(LLCD2g).*(LLH2g).*(LLF2g));
                            
end

if MODEL==5

LLB1g_0=LLB1g(dead1==0) ;

li_PER_temp(:,g) =   log(...
                 LLTg(1,1)*(LLD1g).*(LLCD1g).*(LLH1g).*(LLF1g)+...
                 LLTg(2,1)*(LLD2g).*(LLCD1g).*(LLH1g).*(LLF1g)+...
                 LLTg(3,1)*(LLD3g).*(LLCD2g).*(LLH2g).*(LLF2g)+...
                 LLTg(4,1)*(LLD4g).*(LLCD2g).*(LLH2g).*(LLF2g))+...
                 log(LLP1g)+log(LLI1g)+log(LLN1g)+log(LLB1g_0) ;
                             
             
LLB1g_1(:,g)=LLB1g(dead1==1) ;
             

end


end


if MODEL==5
li_PER = [li_PER_temp ; LLB1g_1];
end

S_A(:,p) = times((li_PER(:,1)-li_PER(:,2)),(1/(2*h)))  ;
    
end    

CHECK=transpose(sum(S_A)) ;

AA=zeros(N_p,N_p); 
S_A_t=transpose(S_A);


if MODEL==5
for j=1:IB 
 Aj=S_A_t(:,j)*S_A(j,:);
 AA=AA+Aj;
end

else

for j=1:I 
 Aj=S_A_t(:,j)*S_A(j,:);
 AA=AA+Aj;
end

end


Avar=inv(AA);


for p=1:N_p

    errors(p,1)=sqrt(Avar(p,p));

end

format shortG
errors=[th_ml errors]

end

 
%%%%%% TRA$H %%%%%%
%%%%%% TRA$H %%%%%%
%%%%%% TRA$H %%%%%%
%%%%%% TRA$H %%%%%%
%%%%%% TRA$H %%%%%%