%{
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

Function Name:  POSTERIOR
Created:        6/26/2011 by Nick W Papageorge
Last Modified:  9/10/2015 by Nicholas W Papageorge
Copyright:      Nicholas W. Papageorge. All rights reserved.
Project:        How Does Medical Innovation Create Value?
                Health, Human Capital and the Labor Market
Description:    Solves the dynamic programming problem
Description:    Computes posterior probability of 
                unobserved type.
%}






function posterior=POSTERIOR(th_ml)


%1  GLOBAL OBJECTS

global TP 
global T MODEL
global N I L
global N_H N_E N_v N_A N_dm0 N_dm1 N_dl1 DIM DIM_S N_p
global obsB indB T_iB startIB endIB H_itB A_itB IB NB
global obs ind T_i startI endI 
global v_it  H_it  A_it  E_it 
global v_it1 H_it1 A_it1 I_it1 F_it1 B_it1 N_1_0 N_2_0
global d_it_m  d_m0_0 d_m1_0 d_m2_0 d_m3_0  
global d_it1_l d_l0_1 
global d_it1_m d_m0_1 d_m1_1 d_m2_1 d_m3_1  
global p_it pd INCd d_h cd4I
global beta beta_p beta_D beta_H beta_F beta_B beta_I beta_N
global    LU1 LA1 LP1 LS1 LD1 LH1 LF1 LB1 LI1 LN1
global LT LU2 LA2 LP2 LS2 LD2 LH2 LF2 LB2 LI2 LN2













%2  CONSTRUCT PARAMETERS / COEFFICIENTS

th_P1=beta_p(1:17,1);
th_S1=ones(4,1)*beta_p(18,1);
th_D1=beta_D(1:11,1);
th_H1=beta_H(1:4,1);
th_F1=beta_F(1:14,1);
th_B1=beta_B(1:4,1);
th_I1=beta_I(1:13,1);
th_N1=beta_N(10:27,1);


th_ml_U1   =th_ml(1:LU1,1);      
th_ml_A1   =th_ml(LU1+1:LU1+LA1,1);      
th_ml_P1   =th_ml(LU1+LA1+1:LU1+LA1+LP1,1);      
th_ml_S1   =th_ml(LU1+LA1+LP1+1:LU1+LA1+LP1+LS1,1);      
th_ml_D1   =th_ml(LU1+LA1+LP1+LS1+1:LU1+LA1+LP1+LS1+LD1,1);  
th_ml_H1   =th_ml(LU1+LA1+LP1+LS1+LD1+1:LU1+LA1+LP1+LS1+LD1+LH1,1);
th_ml_F1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1,1);
th_ml_B1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1,1);
th_ml_I1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1,1);
th_ml_N1   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1,1);

if L~=1
th_P2=beta_p(1:17,1);
th_S2=ones(4,1)*beta_p(18,1);
th_D2=beta_D(1:11,1);
th_H2=beta_H(1:4,1);
th_F2=beta_F(1:11,1);
th_B2=beta_B(1:4,1);
th_I2=beta_I(1:13,1);
th_N2=beta_N(10:27,1);


th_ml_T    =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LT,1);     
th_T=C_TYPEP(th_ml_T);
th_T

th_ml_U2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2,1);           
th_ml_A2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2,1);       
th_ml_P2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2,1);       
th_ml_S2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2,1);        
th_ml_D2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2,1);        
th_ml_H2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2,1);   
th_ml_F2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2,1);   
th_ml_B2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2,1);  
th_ml_I2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2,1);  
th_ml_N2   =th_ml(LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2+1:LU1+LA1+LP1+LS1+LD1+LH1+LF1+LB1+LI1+LN1+LT+LU2+LA2+LP2+LS2+LD2+LH2+LF2+LB2+LI2+LN2,1);  
end

a=(A_it-30)*2+1; 

if MODEL==4 || MODEL==5
th_H1(1:4,1)=th_ml_H1(1:4,1);
th_H2(1:4,1)=th_ml_H2(1:4,1);
th_D1(1:9,1)=th_ml_D1(1:9,1);
th_D2(1:9,1)=th_ml_D1(1:9,1);
th_D2(4,1)=th_ml_D2(1,1);
th_D2(7,1)=th_ml_D2(2,1);
th_F1(1:9,1)=th_ml_F1(1:9,1);
th_F2(1:9,1)=th_ml_F1(1:9,1);
th_F2(4,1)=th_ml_F2(1,1);
th_F2(7,1)=th_ml_F2(2,1);


% th_D1(4,1)=th_ml_D1(1,1);
% th_D1(7,1)=th_ml_D1(2,1);
% th_D2(4,1)=th_ml_D2(1,1);
% th_D2(7,1)=th_ml_D2(2,1);
% th_F1(4,1)=th_ml_F1(1,1);
% th_F1(7,1)=th_ml_F1(2,1);
% th_F2(4,1)=th_ml_F2(1,1);
% th_F2(7,1)=th_ml_F2(2,1);
% th_D1(1:7,1)=th_ml_D1(1:7,1);
% th_D1(9,1)=th_ml_D1(8,1);
% th_D2(1:7,1)=th_ml_D2(1:7,1);
% th_D2(9,1)=th_ml_D2(8,1);
% th_F1(1:7,1)=th_ml_F1(1:7,1);
% th_F1(9,1)=th_ml_F1(8,1);
% th_F2(1:7,1)=th_ml_F2(1:7,1);
% th_F2(9,1)=th_ml_F2(8,1);
% th_I1(6,1) =th_ml_I1(1,1);
% th_I1(12,1)=th_ml_I1(2,1);
% th_I2(6,1) =th_ml_I2(1,1);
% th_I2(12,1)=th_ml_I2(2,1);
end

%3  PRINT DURING ESTIMATION
format short g
if L==1
display "U1"
th_ml_U1
th_ml_A1
end

if L==2
th_ml_T
end

if L==2 && LU2==0
th_ml_U1
th_ml_A1
elseif L==2 && LU2~=0
th_ml_U1
th_ml_U2
th_ml_A1
th_ml_A2
end

if L==2 && (LD2~=0 || LH2~=0) 
th_ml_D1
th_ml_D2
th_ml_H1
th_ml_H2
end

if L==2 && LF2~=0 
th_ml_F1
th_ml_F2
end




















%4 SOLVE DDP PROBLEM & OBTAIN CCPS FOR CURRENT th_ml

CCP=D_DPP(th_ml);

sig(:,1)=CCP(:,71,1);
if L==2
sig(:,2)=CCP(:,71,2);
end
CCP=CCP(:,1:70,:);


















%5  CONSTRUCT LIKELIHOOD INPUTS

l_ccp=zeros(N,L);
l_sig=zeros(N,1);

for j=1:N

    l_ccp(j,1)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),1);
if L~=1
    l_ccp(j,2)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),2);

    
if L==4
    l_ccp(j,3)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),3);
    l_ccp(j,4)=...
        CCP(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),a(j,1),4);
end
end
    l_sig(j,1)=...
        sig(E_INDSM(v_it(j,1),E_it(j,1),d_it_m(j,1),d_it1_l(j,1),d_it1_m(j,1),H_it(j,1)),1);
end

















%6  CHOICES

if LU2==0
LLD1=zeros(I,1);


n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLD1(i)=prod(l_ccp(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end





elseif LU2~=0 && L==2
LLD1=zeros(I,1);
LLD2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLD1(i)=prod(l_ccp(startI(n):endI(n),1));  
    LLD2(i)=prod(l_ccp(startI(n):endI(n),2));
    n=n+T_i(n);
    i=i+1;
end
    





elseif LU2~=0 && L==4
LLD1=zeros(I,1);
LLD2=zeros(I,1);
LLD3=zeros(I,1);
LLD4=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLD1(i)=prod(l_ccp(startI(n):endI(n),1));  
    LLD2(i)=prod(l_ccp(startI(n):endI(n),2));
    LLD3(i)=prod(l_ccp(startI(n):endI(n),3));  
    LLD4(i)=prod(l_ccp(startI(n):endI(n),4));
    n=n+T_i(n);
    i=i+1;
end
end    



 

%7  CONSTRUCT LIKELIHOOD: OUT-OF-POCKET COSTS


if LP2~=0
XB_P1=...
    th_P1(1,1)*H_it+...    
    th_P1(2,1)*times((1-F_it),H_it)+...
    th_P1(3,1)*times((1-F_it),(1-H_it))+...
    th_P1(4,1)*I_it+...
    th_P1(5,1)*d_m1_0+...
    th_P1(6,1)*d_m2_0+...
    th_P1(7,1)*d_m3_0+...
    th_P1(8,1)*N_1_0+...
    th_P1(9,1)*N_2_0+...
    th_P1(10,1)*times(N_1_0,d_m1_0)+...
    th_P1(11,1)*times(N_2_0,d_m1_0)+...    
    th_P1(12,1)*times(N_1_0,d_m2_0)+...
    th_P1(13,1)*times(N_2_0,d_m2_0)+...    
    th_P1(14,1)*times(N_1_0,d_m3_0)+...
    th_P1(15,1)*times(N_2_0,d_m3_0)+...    
    th_P1(16,1)*(v_it)+...
    th_P1(17,1);  
      
XB_P2=...
    th_P2(1,1)*H_it+...    
    th_P2(2,1)*times((1-F_it),H_it)+...
    th_P2(3,1)*times((1-F_it),(1-H_it))+...
    th_P2(4,1)*I_it+...
    th_P2(5,1)*d_m1_0+...
    th_P2(6,1)*d_m2_0+...
    th_P2(7,1)*d_m3_0+...
    th_P2(8,1)*N_1_0+...
    th_P2(9,1)*N_2_0+...
    th_P2(10,1) *times(N_1_0,d_m1_0)+...
    th_P2(11,1)*times(N_2_0,d_m1_0)+...    
    th_P2(12,1)*times(N_1_0,d_m2_0)+...
    th_P2(13,1)*times(N_2_0,d_m2_0)+...    
    th_P2(14,1)*times(N_1_0,d_m3_0)+...
    th_P2(15,1)*times(N_2_0,d_m3_0)+...    
    th_P2(16,1)*(v_it)+...
    th_P2(17,1);

XB_P=[XB_P1 XB_P2]; 

f_p=zeros(N,L);
for c=1:L
z=times((p_it-XB_P(:,c)),(p_it-XB_P(:,c)));
y1=2*(times(l_sig,l_sig));
y2=times(-1,power(y1,-1));
x=times(z,y2);
w=exp(x);
v1=(2*pi*(times(l_sig,l_sig)));
v2=power(v1,(-1/2));
u=times(v2,w);
t=power(u,pd);
s=times(XB_P(:,c),power(l_sig,-1));
r=normcdf(s,0,1);
q=1-r;
p=power(q,(1-pd));
o=times(p,t);
n= 1E-75*ones(N,1);
f_p(:,c)=max(n,o);
end

LLP1=zeros(I,1);
LLP2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLP1(i)=prod(f_p(startI(n):endI(n),1));  
    LLP2(i)=prod(f_p(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end
end


























%7  CONSTRUCT LIKELIHOOD: Health



if LD2==0 && LH2==0
    XB_D=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd=exp(XB_D);
f_cd=times(f_cd,power((1+f_cd),-1));
f_cd=times(power(f_cd,cd4I),power((1-f_cd),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h=exp(XB_H);
f_h=times(f_h,power((1+f_h),-1));
f_h=times(power(f_h,H_it1),power((1-f_h),(1-H_it1)));

LLH1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end





























elseif LD2==0 && LH2~=0
XB_D1=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D1);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));


f_cd=exp(XB_D1);
f_cd=times(f_cd,power((1+f_cd),-1));
f_cd=times(power(f_cd,cd4I),power((1-f_cd),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H1=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h1=exp(XB_H1);
f_h1=times(f_h1,power((1+f_h1),-1));
f_h1=times(power(f_h1,H_it1),power((1-f_h1),(1-H_it1)));


XB_H2=...
    th_H2(1,1)*H_it+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


f_h2=exp(XB_H2);
f_h2=times(f_h2,power((1+f_h2),-1));
f_h2=times(power(f_h2,H_it1),power((1-f_h2),(1-H_it1)));

f_h=[f_h1 f_h2];

LLH1=zeros(I,1);
LLH2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    LLH2(i)=prod(f_h(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end


















elseif LD2~=0 && LH2==0
XB_D1=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D1);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd1=exp(XB_D1);
f_cd1=times(f_cd1,power((1+f_cd1),-1));
f_cd1=times(power(f_cd1,cd4I),power((1-f_cd1),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd1(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H1=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h1=exp(XB_H1);
f_h1=times(f_h1,power((1+f_h1),-1));
f_h1=times(power(f_h1,H_it1),power((1-f_h1),(1-H_it1)));





XB_D2=...
    th_D2(1,1)*H_it+...
    th_D2(2,1)*times((1-H_it),d_m1_1)+...
    th_D2(3,1)*times((1-H_it),d_m2_1)+...
    th_D2(4,1)*times((1-H_it),d_m3_1)+...
    th_D2(5,1)*times((H_it)  ,d_m1_1)+...
    th_D2(6,1)*times((H_it)  ,d_m2_1)+...
    th_D2(7,1)*times((H_it)  ,d_m3_1)+...
    th_D2(8,1)*v_it+...
    th_D2(9,1);

DH=exp(XB_D2);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd2=exp(XB_D2);
f_cd2=times(f_cd2,power((1+f_cd2),-1));
f_cd2=times(power(f_cd2,cd4I),power((1-f_cd2),(1-cd4I)));

LLCD2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD2(i)=prod(f_cd2(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end



XB_H2=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);


f_h2=exp(XB_H2);
f_h2=times(f_h2,power((1+f_h2),-1));
f_h2=times(power(f_h2,H_it1),power((1-f_h2),(1-H_it1)));

f_h=[f_h1 f_h2];

LLH1=zeros(I,1);
LLH2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    LLH2(i)=prod(f_h(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end










elseif LD2~=0 && LH2~=0
XB_D1=...
    th_D1(1,1)*H_it+...
    th_D1(2,1)*times((1-H_it),d_m1_1)+...
    th_D1(3,1)*times((1-H_it),d_m2_1)+...
    th_D1(4,1)*times((1-H_it),d_m3_1)+...
    th_D1(5,1)*times((H_it)  ,d_m1_1)+...
    th_D1(6,1)*times((H_it)  ,d_m2_1)+...
    th_D1(7,1)*times((H_it)  ,d_m3_1)+...
    th_D1(8,1)*v_it+...
    th_D1(9,1);

DH=exp(XB_D1);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd1=exp(XB_D1);
f_cd1=times(f_cd1,power((1+f_cd1),-1));
f_cd1=times(power(f_cd1,cd4I),power((1-f_cd1),(1-cd4I)));

LLCD1=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD1(i)=prod(f_cd1(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H1=...
    th_H1(1,1)*H_it+...
    th_H1(2,1)*DH0+...
    th_H1(3,1)*DH1+...
    th_H1(4,1);

f_h1=exp(XB_H1);
f_h1=times(f_h1,power((1+f_h1),-1));
f_h1=times(power(f_h1,H_it1),power((1-f_h1),(1-H_it1)));





XB_D2=...
    th_D2(1,1)*H_it+...
    th_D2(2,1)*times((1-H_it),d_m1_1)+...
    th_D2(3,1)*times((1-H_it),d_m2_1)+...
    th_D2(4,1)*times((1-H_it),d_m3_1)+...
    th_D2(5,1)*times((H_it)  ,d_m1_1)+...
    th_D2(6,1)*times((H_it)  ,d_m2_1)+...
    th_D2(7,1)*times((H_it)  ,d_m3_1)+...
    th_D2(8,1)*v_it+...
    th_D2(9,1);

DH=exp(XB_D2);
DH=times(DH,power((1+DH),-1));
DH0=times(DH,(1-H_it));
DH1=times(DH,(H_it));

f_cd2=exp(XB_D2);
f_cd2=times(f_cd2,power((1+f_cd2),-1));
f_cd2=times(power(f_cd2,cd4I),power((1-f_cd2),(1-cd4I)));

LLCD2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLCD2(i)=prod(f_cd2(startI(n):endI(n),1));  
    n=n+T_i(n);
    i=i+1;
end




XB_H2=...
    th_H2(1,1)*H_it+...
    th_H2(2,1)*DH0+...
    th_H2(3,1)*DH1+...
    th_H2(4,1);


f_h2=exp(XB_H2);
f_h2=times(f_h2,power((1+f_h2),-1));
f_h2=times(power(f_h2,H_it1),power((1-f_h2),(1-H_it1)));

f_h=[f_h1 f_h2];

LLH1=zeros(I,1);
LLH2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLH1(i)=prod(f_h(startI(n):endI(n),1));  
    LLH2(i)=prod(f_h(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end

end











 



























%8  CONSTRUCT LIKELIHOOD: Symptoms, Side Effects
if LF2~=0

XB_F1=...
    th_F1(1,1)*H_it+...
    th_F1(2,1)*times((1-H_it),d_m1_1)+...
    th_F1(3,1)*times((1-H_it),d_m2_1)+...
    th_F1(4,1)*times((1-H_it),d_m3_1)+...
    th_F1(5,1)*times((H_it)  ,d_m1_1)+...
    th_F1(6,1)*times((H_it)  ,d_m2_1)+...
    th_F1(7,1)*times((H_it)  ,d_m3_1)+...
    th_F1(8,1)*v_it+...
    th_F1(9,1);

f_f1=exp(XB_F1);
f_f1=times(f_f1,power((1+f_f1),-1));
f_f1=times(power(f_f1,F_it1),power((1-f_f1),(1-F_it1)));

XB_F2=...
    th_F2(1,1)*H_it+...
    th_F2(2,1)*times((1-H_it),d_m1_1)+...
    th_F2(3,1)*times((1-H_it),d_m2_1)+...
    th_F2(4,1)*times((1-H_it),d_m3_1)+...
    th_F2(5,1)*times((H_it)  ,d_m1_1)+...
    th_F2(6,1)*times((H_it)  ,d_m2_1)+...
    th_F2(7,1)*times((H_it)  ,d_m3_1)+...
    th_F2(8,1)*v_it+...
    th_F2(9,1);

f_f2=exp(XB_F2);
f_f2=times(f_f2,power((1+f_f2),-1));
f_f2=times(power(f_f2,F_it1),power((1-f_f2),(1-F_it1)));

f_f=[f_f1 f_f2];

LLF1=zeros(I,1);
LLF2=zeros(I,1);

n=1;
i=1;
while ((n<=N)&&(i<=I));
    LLF1(i)=prod(f_f(startI(n):endI(n),1));  
    LLF2(i)=prod(f_f(startI(n):endI(n),2));  
    n=n+T_i(n);
    i=i+1;
end
end











%9  CONSTRUCT LIKELIHOOD: DEATH


% if LB2==0
% 
% XB_B=...
%     th_B1(1,1)*H_itB+...
%     th_B1(2,1)*times(A_itB,H_itB)+...
%     th_B1(3,1)*A_itB+...
%     th_B1(4,1);
% 
% f_b=exp(XB_B);
% f_b=times(f_b,power((1+f_b),-1));
% f_b=times(power(f_b,B_it1),power((1-f_b),(1-B_it1)));
% 
% LLB1=zeros(IB,1);
% 
% n=1;
% i=1;
% while ((n<=NB)&&(i<=IB));
%     LLB1(i)=prod(f_b(startIB(n):endIB(n),1));  
%     n=n+T_iB(n);
%     i=i+1;
% end
% 
% LB=0;
% for i=1:IB
% LBi=...    
%     log(LLB1(i,1));  
%     LB=LB+LBi;
% 
% end
% 
% elseif LB2~=0
% 
% XB_B1=...
%     th_B1(1,1)*H_itB+...
%     th_B1(2,1)*times(A_itB,H_itB)+...
%     th_B1(3,1)*A_itB+...
%     th_B1(4,1);
% 
% f_b1=exp(XB_B1);
% f_b1=times(f_b1,power((1+f_b1),-1));
% f_b1=times(power(f_b1,B_it1),power((1-f_b1),(1-B_it1)));
% 
% XB_B2=...
%     th_B2(1,1)*H_itB+...
%     th_B2(2,1)*times(A_itB,H_itB)+...
%     th_B2(3,1)*A_itB+...
%     th_B2(4,1);
% 
% 
% f_b2=exp(XB_B2);
% f_b2=times(f_b2,power((1+f_b2),-1));
% f_b2=times(power(f_b2,B_it1),power((1-f_b2),(1-B_it1)));
% 
% f_b=[f_b1 f_b2];
% 
% LLB1=zeros(IB,1);
% LLB2=zeros(IB,1);
% 
% n=1;
% i=1;
% while ((n<=NB)&&(i<=IB));
%     LLB1(i)=prod(f_b(startIB(n):endIB(n),1));  
%     LLB2(i)=prod(f_b(startIB(n):endIB(n),2));  
%     n=n+T_iB(n);
%     i=i+1;
% end
% 
% LB=0;
% for i=1:IB
% LBi=...    
%     th_T(1,1)*log(LLB1(i,1))+(1-th_T(1,1))*log(LLB2(i,1));  
%     LB=LB+LBi;
% 
% end
% end



















%9  CONSTRUCT LIKELIHOOD: Symptoms, Side Effects
pt=zeros(I,L);




if L==2 && LU2~=0 && (LH2==0 && LD2==0) && LF2==0
for i=1:I
    pt(i,1)=LLD1(i,1)*th_T(1,1)/(LLD1(i,1)*th_T(1,1)+LLD2(i,1)*(1-th_T(1,1)));
end
    pt(:,2)=1-pt(:,1);
end







if L==4 && LU2~=0 && LD2~=0 && LH2==0
for i=1:I
    pt(i,1)=LLD1(i,1)*LLH1(i,1)*th_T(1,1)/...
        (LLD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLH2(i,1)*th_T(4,1));
    
    pt(i,2)=LLD2(i,1)*LLH1(i,1)*th_T(2,1)/...
        (LLD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLH2(i,1)*th_T(4,1));

    pt(i,3)=LLD3(i,1)*LLH2(i,1)*th_T(3,1)/...
        (LLD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLH2(i,1)*th_T(4,1));

end
    pt(:,4)=1-pt(:,1)-pt(:,2)-pt(:,3);
end





if L==4 && LU2~=0 && LD2==0 && LH2~=0 
for i=1:I
    pt(i,1)=LLD1(i,1)*LLH1(i,1)*th_T(1,1)/...
        (LLD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLH2(i,1)*th_T(4,1));
    
    pt(i,2)=LLD2(i,1)*LLH1(i,1)*th_T(2,1)/...
        (LLD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLH2(i,1)*th_T(4,1));

    pt(i,3)=LLD3(i,1)*LLH2(i,1)*th_T(3,1)/...
        (LLD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLH2(i,1)*th_T(4,1));

end
    pt(:,4)=1-pt(:,1)-pt(:,2)-pt(:,3);
end





if L==4 && LU2~=0 && LD2~=0 && LH2==0 
for i=1:I
    pt(i,1)=LLD1(i,1)*LLCD1(i,1)*th_T(1,1)/...
        (LLD1(i,1)*LLCD1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*th_T(4,1));
    
    pt(i,2)=LLD2(i,1)*LLCD1(i,1)*th_T(2,1)/...
        (LLD1(i,1)*LLCD1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*th_T(4,1));

    pt(i,3)=LLD3(i,1)*LLCD2(i,1)*th_T(3,1)/...
        (LLD1(i,1)*LLCD1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*th_T(4,1));

end
    pt(:,4)=1-pt(:,1)-pt(:,2)-pt(:,3);
end



if L==4 && LU2~=0 && LD2~=0 && LH2~=0 
for i=1:I
    pt(i,1)=LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(1,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(4,1));
    
    pt(i,2)=LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(2,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(4,1));

    pt(i,3)=LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(3,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*th_T(4,1));

end
    pt(:,4)=1-pt(:,1)-pt(:,2)-pt(:,3);
end


if L==4 && LU2~=0 && LD2~=0 && LH2~=0 && LF2~=0
for i=1:I
    pt(i,1)=LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(1,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(4,1));
    
    pt(i,2)=LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(2,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(4,1));

    pt(i,3)=LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(3,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*th_T(4,1));

end
    pt(:,4)=1-pt(:,1)-pt(:,2)-pt(:,3);
end


if L==4 && LU2~=0 && LD2~=0 && LH2~=0 && LF2~=0 && LB2~=0
for i=1:I
    pt(i,1)=LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*LLB1(i,1)*th_T(1,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*LLB1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*LLB1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(4,1));
    
    pt(i,2)=LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*LLB1(i,1)*th_T(2,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*LLB1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF1(i,1)*LLB1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(4,1));

    pt(i,3)=LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(3,1)/...
        (LLD1(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF2(i,1)*LLB1(i,1)*th_T(1,1)+...
         LLD2(i,1)*LLCD1(i,1)*LLH1(i,1)*LLF2(i,1)*LLB1(i,1)*th_T(2,1)+...
         LLD3(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(3,1)+...
         LLD4(i,1)*LLCD2(i,1)*LLH2(i,1)*LLF2(i,1)*LLB2(i,1)*th_T(4,1));

end
    pt(:,4)=1-pt(:,1)-pt(:,2)-pt(:,3);
end


if L==4
post_type=zeros(I,L);

i=1;
n=1;
j=1;
while i<=I
while j<=endI(n)
    post_type(j,:)=pt(i,:);
    j=j+1;
end
i=i+1;
n=n+T_i(n);
end

elseif L==2

post_type=zeros(I,1);

i=1;
n=1;
j=1;
while i<=I
while j<=endI(n)
    post_type(j,1)=pt(i,1);
    j=j+1;
end
i=i+1;
n=n+T_i(n);
end
 
end

posterior=post_type;
 
end






















