****************************
****************************
*MAIN DATA FILE
*FULL DATA
*FOR USE PROJECT:

*** VMI

*PAIRS
****************************
****************************
clear
clear matrix
set mem 80m


**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION

cd "~/Dropbox/WORK/VMI/PAPER/REPLICATION/"

**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION

**************************
**************************
*All Visits and Visit Info
**************************
**************************
                      
qui infix caseid 1-5 using "STATA/DATASETS/MainDataFile/MACSmen/data/hivstats.dat"
qui sort caseid
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/drugadh.dat"
qui sort caseid visit
qui merge caseid using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/drugf1.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/drugf2.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/lab_rslt.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/section2.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 8-10 using "STATA/DATASETS/MainDataFile/MACSmen/data/qol.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 form 9-10 using "STATA/DATASETS/MainDataFile/MACSmen/data/pwa.dat"
qui sort caseid visit
replace form=1 if form==20
replace form=. if form!=1
rename form pwa
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/v13herc.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count
qui clear

qui infix caseid 1-5 visit 6-8 using "STATA/DATASETS/MainDataFile/MACSmen/data/phy_exam.dat"
qui sort caseid visit
qui merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
qui sort caseid visit
qui drop _merge
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
qui count if caseid!=caseid[_n-1]
qui count

qui by caseid visit: keep if _n==1
qui drop if visit==.
qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace

count
count if caseid!=caseid[_n-1]

qui by caseid: egen maxvisit=max(visit)
qui by caseid: egen minvisit=min(visit)

qui save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace

*Total Participants
count if caseid!=caseid[_n-1]
*5622

*Total Subject-Visits
count
*98886

******************************
******************************
*HIV Status and Seroconversion
******************************
******************************

clear
infix caseid 1-5 status 6 posvis 16-18 negvis 7-9 using "STATA/DATASETS/MainDataFile/MACSmen/data/hivstats.dat"
sort caseid
merge caseid using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
sort caseid visit
preserve
by caseid:keep if _n==1
tabulate status
restore
drop _merge
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace

count
count if caseid!=caseid[_n-1]

tabulate status
preserve
by caseid: keep if _n==1
tabulate status
restore
gen d_sp=(status==2)
gen d_sc=(status==4)
gen d_ng=(status==1)

drop if status>4

tabulate status
preserve
by caseid: keep if _n==1
tabulate status
restore
count
count if caseid!=caseid[_n-1]
*******************************************
*******************************************
*DROPPING OF PROBLEMATIC OBSERVATIONS
*1: Status unclear
*2: Posvis with ending 1
*3: Posvis long after maxvisit (4465, 4878)
*4: diffyear is WAY OFF (1341)
*******************************************
*******************************************

count if status==4 & posvis==.
count if status==1 & posvis!=.
count if status==2 & posvis!=.

drop if status==4 & posvis==.
drop if status==1 & posvis!=.
drop if status==2 & posvis!=.

drop if caseid==4465
drop if caseid==4878
drop if caseid==1341

count
tabulate status
preserve
by caseid: keep if _n==1
count
tabulate status
restore

drop if posvis==11| posvis==11| posvis==21| posvis==41| posvis==71| posvis==81| posvis==191 | posvis==201 | posvis==211 | posvis==221 | posvis==241 |posvis==301

/*
replace posvis=20 if posvis==11
replace posvis=30 if posvis==21
replace posvis=50 if posvis==41
replace posvis=80 if posvis==71
replace posvis=90 if posvis==81
replace posvis=200 if posvis==191
replace posvis=210 if posvis==201
replace posvis=220 if posvis==211
replace posvis=230 if posvis==221
replace posvis=250 if posvis==241
replace posvis=310 if posvis==301
*/

drop if visit==381

*Total Subject-Visits
count
*97130
tabulate status
preserve
by caseid: keep if _n==1
*Total Subjects
count
*5519
restore

*******************
*Current HIV STATUS
*******************
gen d_nt  = (status==4 & visit<posvis | status==1)
gen d_pt  = (status==4 & visit>= posvis | status==2)

****
*ERA
****
gen d_pr = (visit<=240)
gen d_po = (visit>240)

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear


******************************
******************************
*Obtain Death/AIDS Information
******************************
******************************

infix caseid 1-5 death 873 DTHDATEyy 876-879 DCAUSE1 887-892 using "STATA/DATASETS/MainDataFile/MACSmen/data/outcome.dat"
rename DTHDATEyy dyear
sort caseid
merge caseid using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
keep if _merge!=1
drop _merge


gen maxyear=(((maxvisit-10)/20)+1984)
gen diffyear= dyear-maxyear

qui tabulate diffyear

sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace

clear

******************
*WORKING VARIABLE
*INDICATING: 
*CENSORED NEGATIVE
******************
infix caseid 1-5 visit 6-8 rtcen 2813 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
keep if _merge!=1
drop _merge

sort caseid visit
by caseid: egen mrtcen=max(rtcen)
drop rtcen
rename mrtcen rtcen
  
*NOTE this censor var will probably get a few HIV- subjects
*who attrit after visit 220-240

gen censor1=.
*replace censor1=1 if maxvisit==200 & (dyear==.) & d_ng==1
*replace censor1=1 if maxvisit==210 & (dyear==.) & d_ng==1
*replace censor1=1 if maxvisit==220 & (dyear==.) & d_ng==1
*replace censor1=1 if maxvisit==230 & (dyear==.) & d_ng==1
*replace censor1=1 if maxvisit==240 & (dyear==.) & d_ng==1
*replace censor1=1 if maxvisit==250 & (dyear==.) & d_ng==1
*replace censor1=1 if maxvisit==260 & (dyear==.) & d_ng==1
replace censor1=1 if rtcen==2
replace censor1=0 if d_sp==1
replace censor1=0 if censor1==.


gen censor2=.
replace censor2=1 if maxvisit==200 & dyear==. & d_ng==1
replace censor2=1 if maxvisit==210 & dyear==. & d_ng==1
replace censor2=1 if maxvisit==220 & dyear==. & d_ng==1
replace censor2=1 if maxvisit==230 & dyear==. & d_ng==1
replace censor2=1 if maxvisit==240 & dyear==. & d_ng==1
replace censor2=1 if maxvisit==250 & dyear==. & d_ng==1
replace censor2=1 if maxvisit==260 & dyear==. & d_ng==1
replace censor2=1 if rtcen==2
replace censor2=0 if d_sp==1
replace censor2=0 if censor2==.

count
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear

*************************
*************************
*CD4 Count and Viral Load
*************************
*************************
clear
infix caseid 1-5 visit 6-8 leu3n 225-228 leu3p 229-231 vload 364-370 ro2vl 330-336 using "STATA/DATASETS/MainDataFile/MACSmen/data/lab_rslt.dat"
rename leu3n cd4
rename leu3p pcd4
sort caseid visit

gen cd42=cd4^2
gen lcd4=cd4[_n-1] if ((visit-visit[_n-1]==10 & caseid==caseid[_n-1])|(visit[_n-1]==75 & caseid==caseid[_n-1]))
*21529 miss vals
*gen lcd4=cd4[_n-1] if (visit-visit[_n-1]==10 & caseid==caseid[_n-1])
*22097 miss vals

gen lcd42=lcd4^2
gen dcd4=cd4-lcd4
gen dcd42=dcd4^2

sort caseid visit
merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
keep if _merge!=1
drop _merge
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear


***************
***************
*MEDS and HAART
***************
***************
clear

*Visits 6-11, 75
clear
infix caseid 1-5 visit 6-8 /// 
maids 1774 /// Any AIDS med: (Visits 6-11, 15-41, 75)
m1aid 1738-1740 m2aid 1746-1748 m3aid 1754-1756 /// Any drugs to fight HIV (Visits 6-11, 75) [already in sub-vis format]
using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"

keep if visit>=60 & visit<=110
rename m1aid med1
rename m2aid med2
rename m3aid med3
tab maids
replace maids=2 if maids==1 & med1!=.
replace maids=2 if maids==. & med1!=.
reshape long med, i(caseid visit) j(d)
drop d

sort caseid visit maids med
quietly by caseid visit maids med: gen dup=cond(_N==1,0,_n)
keep if dup==0|dup==1
drop dup

save "STATA/DATASETS/MainDataFile/stata/datasets/drug6_11_75", replace

*Visit 12
clear
infix caseid 1-5 visit 6-8 /// 
cltrl 596 plct1 2626 ctdr1 770-772 plct2 2627 ctdr2 773-775 plct3 2628 ctdr3 776-778 /// Drugs CTRIAL (Visit 12)
d1nam 800-802 d2nam 833-835 d3nam 866-868 d4nam 899-901 /// Drugs Not CTRIAL (Visit 12)
using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
keep if visit==120
drop if plct1==2 | plct1==3 | plct2==2 | plct2==3
drop plct1 plct2 plct3
rename ctdr1 med1
rename ctdr2 med2
rename ctdr3 med3
rename d1nam med4
rename d2nam med5
rename d3nam med6
rename d4nam med7
reshape long med, i(caseid visit) j(d)
drop d cltrl

gen maids=1 if med==.
replace maids=2 if med!=.

sort caseid visit maids med
quietly by caseid visit maids med: gen dup=cond(_N==1,0,_n)
keep if dup==0|dup==1
drop dup

append using "STATA/DATASETS/MainDataFile/stata/datasets/drug6_11_75.dta"
sort caseid visit
erase "STATA/DATASETS/MainDataFile/stata/datasets/drug6_11_75.dta"
save "STATA/DATASETS/MainDataFile/stata/datasets/drug6_12_75", replace

*Drop Non ARV's using DGNAV from drugf1 as guide
replace med=1000+med

drop if ///
med==1093 | med==1095 | med==1096 | med==1097 | med==1102 | med==1103 | med==1104 | ///
med==1105 | med==1106 | med==1107 | med==1111 | med==1112 | med==1113 | med==1114 | ///
med==1115 | med==1116 | med==1117 | med==1118 | med==1119 | med==1120 | med==1121 | ///
med==1123 | med==1124 | med==1125 | med==1126 | med==1127 | med==1129 | med==1130 | /// 
med==1131 | med==1132 | med==1133 | med==1134 | med==1135 | med==1136 | med==1137 | ///
med==1138 | med==1139 | med==1140 | med==1141 | med==1143 | med==1144 | med==1145 | ///
med==1148 | med==1149 | med==1150 | med==1151 | med==1152 | med==1153 | med==1154 | ///
med==1155 | med==1156 | med==1157 | med==1158 | med==1160 | med==1161 | med==1162 | ///
med==1164 | med==1165 | med==1166 | med==1168 | med==1169 | med==1170 | med==1170 | ///
med==1173 | med==1174 | med==1175 | med==1176 | med==1177 | med==1178 | med==1181 | ///
med==1182 | med==1183 | med==1184 | med==1188 | med==1189 | med==1190 | med==1196 | ///
med==1197 | med==1199 | med==1200 | med==1203 | med==1207 | med==1225 | med==1226 | ///
med==1228 | med==1232 | med==1235 | med==1236 | med==1241 | med==1245 | med==1246 | ///
med==1196 | med==1197 | med==1198

replace med=1000 if maids==1

sort caseid visit
drop maids
save "STATA/DATASETS/MainDataFile/stata/datasets/drug6_12_75", replace

clear

****
*AVs
****
clear
infix caseid 1-5 visit 6-8 maids 1774 ml1ad 1878 ml2ad 1915 omdad 2417 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/drug.dta", replace
clear

infix caseid 1-5 visit 6-8 drgav 79-81 resf1 91 plcf1 88 using "STATA/DATASETS/MainDataFile/MACSmen/data/drugf1.dat"
sort caseid visit drgav resf1 plcf1
replace plcf1=1 if resf1==1

merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/drug.dta"
*keep if _merge!=1
drop _merge
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/drugav", replace

gen medav=.
replace medav=0 if maids==. & ml1ad==1 & visit>=130
replace medav=0 if maids==1 & ml1ad==. & visit>=130
replace medav=0 if maids==1 & ml1ad==1 & visit>=130
replace medav=0 if maids==2 & ml1ad==1 & visit>=130
replace medav=1 if maids==. & ml1ad==2 & visit>=130
replace medav=1 if maids==2 & ml1ad==2 & visit>=130

gen meds=.
replace meds=drgav+1000 if medav==. & drgav!=. & visit>=130
replace meds=drgav+1000 if medav==0 & drgav!=. & visit>=130
replace meds=drgav+1000 if medav==1 & drgav!=. & visit>=130
replace meds=1000 if medav==0 & drgav==. & visit>=130

gen dmed=meds

rename resf1 dtrial
replace dtrial=0 if dtrial==1
replace dtrial=1 if dtrial==2

replace dtrial=0 if meds==1000 & visit>=170
replace dtrial=. if meds==. & visit>=170
replace dtrial=. if visit<170

rename plcf1 dplacebo
replace dplacebo=0 if dplacebo==1
replace dplacebo=1 if dplacebo==2

replace dplacebo=0 if meds==1000 & visit>=130
replace dplacebo=. if meds==. & visit>=170
replace dplacebo=. if visit<130
replace dplacebo=0 if dtrial==0 & visit>=170
replace dplacebo=. if dtrial==. & visit>=170

drop maids  
drop ml1ad 
drop ml2ad
drop omdad 
drop drgav
drop medav
drop meds

sort caseid visit
merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/drug6_12_75" 
 
replace dmed=med if med!=. & visit<=120

drop _merge
drop med
 
sort caseid visit
count
count if visit>=130
count if dmed>=1000 & dmed!=. & visit>=130
count if dmed>1000 & dmed!=. & visit>=130

count if visit>=170
count if dmed>=1000 & dmed!=. & visit>=170
count if dmed>1000 & dmed!=. & visit>=170

tabulate dtrial if dmed>=1000 & dmed!=. & visit>=170
tabulate dtrial if dmed>1000 & dmed!=. & visit>=170

count if dmed>1000 & dmed!=. & visit>=170 & dtrial==1
tabulate dplacebo if dmed>1000 & dmed!=. & visit>=170 & dtrial==1

count if dmed>1000 & dmed!=. & visit>=130
tabulate dplacebo if dmed>1000 & dmed!=. & visit>=130


save "STATA/DATASETS/MainDataFile/stata/datasets/drugav.dta", replace
count
clear

*/
*****
*NAVs
*****

infix caseid 1-5 visit 6-8 maids 1774 ml1ad 1878 ml2ad 1915 omdad 2417 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/drug.dta", replace
clear

infix caseid 1-5 visit 6-8 dgnav 20-22 resf2 39 plcf2 38 using "STATA/DATASETS/MainDataFile/MACSmen/data/drugf2.dat"
sort caseid visit dgnav resf2 plcf2
replace plcf2=1 if resf2==1

merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/drug.dta"
*keep if _merge!=1
drop _merge
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/drugnav", replace

gen mednav=.
replace mednav=0 if maids==. & ml2ad==1 & visit>=130
replace mednav=0 if maids==1 & ml2ad==. & visit>=130
replace mednav=0 if maids==1 & ml2ad==1 & visit>=130
replace mednav=0 if maids==2 & ml2ad==1 & visit>=130
replace mednav=1 if maids==. & ml2ad==2 & visit>=130
replace mednav=1 if maids==2 & ml2ad==2 & visit>=130

gen navmeds=.
replace navmeds=dgnav+2000 if mednav==. & dgnav!=. & visit>=130
replace navmeds=dgnav+2000 if mednav==0 & dgnav!=. & visit>=130
replace navmeds=dgnav+2000 if mednav==1 & dgnav!=. & visit>=130
replace navmeds=2000 if mednav==0 & dgnav==. & visit>=130

gen dmed=navmeds

rename resf2 dtrial
replace dtrial=0 if dtrial==1
replace dtrial=1 if dtrial==2

replace dtrial=0 if navmeds==2000 & visit>=170
replace dtrial=. if navmeds==. & visit>=170
replace dtrial=. if visit<170

rename plcf2 dplacebo
replace dplacebo=0 if dplacebo==1
replace dplacebo=1 if dplacebo==2

replace dplacebo=0 if navmeds==2000 & visit>=130
replace dplacebo=. if navmeds==. & visit>=170
replace dplacebo=. if visit<130
replace dplacebo=0 if dtrial==0 & visit>=170
replace dplacebo=. if dtrial==. & visit>=170

drop maids  
drop ml1ad 
drop ml2ad
drop omdad 
drop dgnav
drop mednav
drop navmeds

sort caseid visit
count
count if visit>=130
count if dmed>=2000 & dmed!=. & visit>=130
count if dmed>2000 & dmed!=. & visit>=130

count if visit>=170
count if dmed>=2000 & dmed!=. & visit>=170
count if dmed>2000 & dmed!=. & visit>=170

tabulate dtrial if dmed>=2000 & dmed!=. & visit>=170
tabulate dtrial if dmed>2000 & dmed!=. & visit>=170

count if dmed>2000 & dmed!=. & visit>=170 & dtrial==1
tabulate dplacebo if dmed>2000 & dmed!=. & visit>=170 & dtrial==1

count if dmed>2000 & dmed!=. & visit>=130
tabulate dplacebo if dmed>2000 & dmed!=. & visit>=130

save "STATA/DATASETS/MainDataFile/stata/datasets/drugnav.dta", replace
count
clear

********
*APPEND*
********
clear
use "STATA/DATASETS/MainDataFile/stata/datasets/drugav.dta"
append using "STATA/DATASETS/MainDataFile/stata/datasets/drugnav.dta"
sort caseid visit dmed
save "STATA/DATASETS/MainDataFile/stata/datasets/drug.dta", replace

sort caseid visit dmed dtrial dplacebo
quietly by caseid visit dmed dtrial dplacebo: gen dup=cond(_N==1,0,_n)
keep if dup==0|dup==1
drop dup

gen meds=.
replace meds=1 if dmed>1000 & dmed<2000
replace meds=0 if dmed==1000
sort caseid visit
by caseid visit: egen mmeds=max(meds)
drop meds
rename mmeds meds

gen navmeds=.
replace navmeds=1 if dmed>2000 & dmed!=.
replace navmeds=0 if dmed==2000
sort caseid visit
by caseid visit: egen mnavmeds=max(navmeds)
drop navmeds
rename mnavmeds navmeds

gen trial=.
replace trial=0 if meds==0
replace trial=0 if meds==1 & dtrial==0
replace trial=1 if meds==1 & dtrial==1
sort caseid visit
by caseid visit: egen mtrial=max(trial)
drop trial
rename mtrial trial

gen navtrial=.
replace navtrial=0 if navmeds==0
replace navtrial=0 if navmeds==1 & dtrial==0
replace navtrial=1 if navmeds==1 & dtrial==1
sort caseid visit
by caseid visit: egen mnavtrial=max(navtrial)
drop navtrial
rename mnavtrial navtrial

gen placebo=.
replace placebo=0 if meds==0 & visit<170 & visit>=130
replace placebo=0 if meds==1 & dplacebo==0 & visit<170 & visit>=130
replace placebo=1 if meds==1 & dplacebo==1 & visit<170 & visit>=130
replace placebo=0 if meds==0 & visit>=170
replace placebo=0 if meds==1 & dtrial==0 & visit>=170
replace placebo=0 if meds==1 & dtrial==1 & dplacebo==0 & visit>=170
replace placebo=1 if meds==1 & dtrial==1 & dplacebo==1 & visit>=170
replace placebo=1 if meds==1 & dtrial==1 & dplacebo==1 & visit>=170
sort caseid visit
by caseid visit: egen mplacebo=max(placebo)
drop placebo
rename mplacebo placebo

gen navplacebo=.
replace navplacebo=0 if navmeds==0 & visit<170 & visit>=130
replace navplacebo=0 if navmeds==1 & dplacebo==0 & visit<170 & visit>=130
replace navplacebo=1 if navmeds==1 & dplacebo==1 & visit<170 & visit>=130
replace navplacebo=0 if navmeds==0 & visit>=170
replace navplacebo=0 if navmeds==1 & dtrial==0 & visit>=170
replace navplacebo=0 if navmeds==1 & dtrial==1 & dplacebo==0 & visit>=170
replace navplacebo=1 if navmeds==1 & dtrial==1 & dplacebo==1 & visit>=170
replace navplacebo=1 if navmeds==1 & dtrial==1 & dplacebo==1 & visit>=170
sort caseid visit
by caseid visit: egen mnavplacebo=max(navplacebo)
drop navplacebo
rename mnavplacebo navplacebo

tab meds
tab trial
tab placebo
tab navmeds 
tab navtrial
tab navplacebo

******
*HAART
******

gen nrti=0
by caseid visit: replace nrti=1 if ///
dmed==1092 | dmed==1094 |dmed==1147 |dmed==1159 |dmed==1179 |dmed==1194 | /// 
dmed==1204 | dmed==1218 |dmed==1222 |dmed==1224 |dmed==1234 |dmed==1239 | /// 
dmed==1180 | dmed==1185 |dmed==1186 |dmed==1187 |dmed==1201 |dmed==1205   
by caseid visit: replace nrti=2 if dmed==1227
by caseid visit: replace nrti=3 if dmed==1240
by caseid visit: replace nrti=. if dmed==.
by caseid visit: egen totnrti=total(nrti)
replace totnrti=. if dmed==.

gen nnrti=0
by caseid visit: replace nnrti=1 if ///
dmed==1191 | dmed==1220 | dmed==1221 | dmed==1223 | dmed==1244
by caseid visit: replace nnrti=. if dmed==.
by caseid visit: egen totnnrti=total(nnrti)
replace totnnrti=. if dmed==.

gen pi=0
by caseid visit: replace pi=1 if  ///
dmed==1193 | dmed==1210 | dmed==1211 | dmed==1212 | dmed==1216 | dmed==1217 | ///
dmed==1219 | dmed==1219 | dmed==1238 | dmed==1243 | dmed==1249 
by caseid visit: replace pi=. if dmed==.
by caseid visit: egen totpi=total(pi)
replace totpi=. if dmed==.

*HAART_1: >=2 NRTI's + 1 NNRTI

gen haart_1=0
replace haart_1=1 if (totnrti>=2 & totnnrti>=1)
replace haart_1=1 if (totnrti>=2 & totpi>=1)
replace haart_1=. if totnrti==. | totnnrti==. | totpi==.

*HAART_2: 1 NNRTI + Ritonavir + PI + >=0 NRTI

gen haart_2=0
gen ritonavir=0
replace ritonavir=1 if dmed==1211
replace ritonavir=. if dmed==.
by caseid visit: egen mritonavir=max(ritonavir)
drop ritonavir
rename mritonavir ritonavir
by caseid visit: replace haart_2=1 if (totnnrti>=1 & ritonavir==1 & totpi==2)
replace haart_2=. if ritonavir==. | totnnrti==. | totnrti==. | totpi==.

*HAART_3: >=3 NRTI's + Abacavir or Tenofovir & 0 NNRTI & 0 pi
gen aba_teno=0
replace aba_teno=1 if (dmed==1234 | dmed==1218)
replace aba_teno=. if dmed==.
by caseid visit: egen maba_teno=max(aba_teno)
drop aba_teno
rename maba_teno aba_teno
gen haart_3=0
by caseid visit: replace haart_3=1 if (aba_teno==1 & totnrti==1 & totnnrti==0 & totpi==0)
replace haart_3=. if aba_teno==. | totnrti==. | totnnrti==. | totpi==.

*HAART_4: >=2 PI's + Ritonavir
gen haart_4=0
replace haart_4=1 if (totpi>=3 & ritonavir==1)
replace haart_4=. if totpi==. | ritonavir==.

by caseid visit: egen hhaart_1=max(haart_1)
by caseid visit: egen hhaart_2=max(haart_2)
by caseid visit: egen hhaart_3=max(haart_3)
by caseid visit: egen hhaart_4=max(haart_4)
drop haart_1
drop haart_2
drop haart_3
drop haart_4
rename hhaart_1 haart_1
rename hhaart_2 haart_2
rename hhaart_3 haart_3
rename hhaart_4 haart_4

gen haart=.
replace haart=1 if haart_1==1 | haart_2==1 |haart_3==1 |haart_4==1
replace haart=0 if haart!=1 & meds==1
replace haart=0 if haart!=1 & meds==0

drop nrti nnrti pi totnrti totnnrti totpi ritonavir aba_teno
drop dmed dtrial dplacebo

sort caseid visit
quietly by caseid visit: gen dup=cond(_N==1,0,_n)
keep if dup==0|dup==1
drop dup

merge caseid visit using "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
keep if _merge!=1
drop _merge
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace


**********************
*Tabulate MEDS & TRIAL
**********************
count if visit>=60 & d_pt==1
tabulate meds if visit>=60 & d_pt==1

count if meds==1 & visit>=130 & d_pt==1
tabulate placebo if meds==1 & visit>=130 & d_pt==1

count if visit>=130 & d_pt==1
tabulate navmeds if visit>=130 & d_pt==1

count if navmeds==1 & visit>=130 & d_pt==1
tabulate  placebo if navmeds==1 & visit>=130 & d_pt==1


****

count if visit>=170 & d_pt==1
tabulate meds if visit>=170 & d_pt==1

count if visit>=170 & d_pt==1 & meds==1 
tabulate trial if visit>=170 & d_pt==1 & meds==1 

count if visit>=170 & d_pt==1 & meds==1 & trial==1
tabulate  placebo if meds==1 & visit>=170 & d_pt==1 & trial==1


****

count if visit>=170 & d_pt==1
tabulate navmeds if visit>=170 & d_pt==1

count if visit>=170 & d_pt==1 & navmeds==1 
tabulate navtrial if visit>=170 & d_pt==1 & navmeds==1 

count if visit>=170 & d_pt==1 & navmeds==1 & navtrial==1
tabulate  placebo if navmeds==1 & visit>=170 & d_pt==1 & navtrial==1

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear

 
*************
*************
*SECTION 2:
*Demographics
*************
*************

infix caseid 1-5 visit 6-8 borny 15-18 race 62 using "STATA/DATASETS/MainDataFile/MACSmen/data/section2.dat"

sort caseid visit
by caseid: replace borny=borny[1]
by caseid: replace race=race[1]
sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit
by caseid: replace borny=borny[1]
by caseid: replace race=race[1]

gen white=(race==1)
gen black=(race==3)
gen orace=(race==2|race==4|race==5|race==6|race==7)
gen nwhite=(race==2|race==3|race==4|race==5|race==6|race==7)

gen age=((1984-borny)+((visit-10)/20)) if visit!=75
replace age=(age[_n+1]-.5) if visit==75 & caseid==caseid[_n+1] 
replace age=1989-borny if visit==75 & caseid!=caseid[_n+1]

gen bage=age if visit==10|visit==75
by caseid: replace bage=bage[1]

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear



*************
*************
*SECTION 2:
*LABOR
*************
*************

infix caseid 1-5 visit 6-8 educa 24 ///
emdis 25 empot 26 emsel 27 ftime 49 ptime 61 retir 63 studt 84 unemp 86 uneno 87 using "STATA/DATASETS/MainDataFile/MACSmen/data/section2.dat"

sort caseid visit
by caseid: replace educa=educa[1]
sort caseid visit

merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit
by caseid: replace educa=educa[1]

gen college=(educa>4)
gen hschool=(educa<4 & educa!=.)
gen scolleg=(educa==4)

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear

*************
*************
*SECTION 2:
*LABOR 
*EXPERIENCE
*************
*************

infix caseid 1-5 visit 6-8 ftime 49 using "STATA/DATASETS/MainDataFile/MACSmen/data/section2.dat"

replace ftime=ftime-1
rename ftime fftime
sort caseid visit

merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"

sort caseid visit
drop if fftime==.

gen skip=0
replace skip=1 if visit[_n+1]-visit>30 & caseid==caseid[_n+1]
by caseid: egen max_skip=max(skip)

drop if max_skip==1
drop if minvisit==75

gen experf=0

by caseid: replace experf=(age-25)*2 if _n==1 & bage>=25

gen h_ftime=fftime*.5

by caseid: replace h_ftime=experf if _n==1
by caseid: replace h_ftime=1 	if h_ftime==.5 & visit[_n+1]-visit==20 
by caseid: replace h_ftime=1.5 	if h_ftime==.5 & visit[_n+1]-visit==30
by caseid: replace h_ftime=2 	if h_ftime==.5 & visit[_n+1]-visit==40

by caseid: gen expF=sum(h_ftime)

drop fftime h_ftime

drop if _merge==1
drop _merge
sort caseid visit

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear


*************
*************
*SECTION 4:
*LABOR
*************
*************

infix caseid 1-5 visit 6-8 incom 1610 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
replace incom=6 if incom==7
replace incom=6 if incom==8
replace incom=. if incom==9

merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

gen bincom=incom if visit==140
by caseid: egen mbincom=max(bincom)
drop bincom
rename mbincom bincom

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear

*********************
*********************
*SECTION 4:
*Insurance & Payments
*********************
*********************
*ocpay: total co-payments, outpatient stuff, etc.
*pmpay: total payments for prescriptions
*pcost: total premium payments for insurance

clear
infix caseid 1-5 visit 6-8 ///
hmoc 1471 gpic 1321 ipic 1628 mcaid 1793 mcare 1794 vaben 3398 champ 523 other 2539 ///
aztpa 242-246 appay 150-154 odpay 2356-2360 pmpay 2631-2635 ///
ocpay 2342-2346 pcost 2574-2578 hopay 1500-1504 nsmed 2231 nseek 2223 nmoth 2131  ///
using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"

foreach var of varlist hmoc gpic ipic mcaid mcare vaben champ other nsmed nseek nmoth {
qui replace `var'=0 if `var'==1 
qui replace `var'=1 if `var'==2 
}
*

gen dpay=pmpay
replace aztpa=0 if aztpa==. & (visit==140 | visit==150)
replace appay=0 if appay==. & (visit==140 | visit==150)
replace odpay=0 if odpay==. & (visit==140 | visit==150)
replace dpay=aztpa+appay+odpay if (visit==140 | visit==150)
replace dpay=. if dpay==88888 | dpay==99999
drop aztpa appay odpay pmpay

sort caseid visit

merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear

*************
*************
*SECTION 4:
*Side Effects
*Reported
*************
*************
clear
infix caseid 1-5 visit 6-8 fatig 1213 diarr 980 fever 1229 heada 1407 sweat 3002 ///
using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
drop if visit<60

sort caseid visit

foreach var of varlist fatig diarr fever heada sweat{
qui replace `var'=0 if `var'==1  
qui replace `var'=1 if `var'==2  
}
*
gen add=fatig+diarr+heada+fever+sweat

replace add = fatig+diarr+fever+sweat if visit==120
gen sfx = (add>0) if add!=.
sort caseid visit

merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear

/*
*************
*************
*SECTION 4:
*Side Effects
*LIVER
*************
*************
clear
infix caseid 1-5 visit 6-8 sgot 342-344 sgpt 345-347 tcell 351 dbili 108-109 ///
using "STATA/DATASETS/MainDataFile/MACSmen/data/lab_rslt.dat"

sort caseid visit

merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 
clear
*/

*************
*************
*SECTION 2:
*PSYCHOSOCIAL
*************
*************

infix caseid 1-5 visit 6-8 bprob 19 frest 48 life 54 cesd1 64 cesd2 65 cesd3 66 cesd4 67 cesd5 68 cesd6 69 cesd7 70 cesd8 71 cesd9 72 cesd10 73 cesd11 74 cesd12 75 cesd13 76 cesd14 77 cesd15 78 cesd16 79 cesd17 80 cesd18 81 cesd19 82 cesd20 83 talk 85 worth 88 using "STATA/DATASETS/MainDataFile/MACSmen/data/section2.dat"
sort caseid visit
tabulate cesd8
forvalues i=1(1)20{
replace cesd`i'=0 if cesd`i'==1
replace cesd`i'=1 if cesd`i'==2
replace cesd`i'=2 if cesd`i'==3
replace cesd`i'=3 if cesd`i'==4
}
replace cesd4=4 if cesd4==3
replace cesd4=3 if cesd4==0
replace cesd4=0 if cesd4==4
replace cesd4=5 if cesd4==2
replace cesd4=2 if cesd4==1
replace cesd4=1 if cesd4==5

replace cesd8=4 if cesd8==3
replace cesd8=3 if cesd8==0
replace cesd8=0 if cesd8==4
replace cesd8=5 if cesd8==2
replace cesd8=2 if cesd8==1
replace cesd8=1 if cesd8==5

replace cesd16=4 if cesd16==3
replace cesd16=3 if cesd16==0
replace cesd16=0 if cesd16==4
replace cesd16=5 if cesd16==2
replace cesd16=2 if cesd16==1
replace cesd16=1 if cesd16==5

replace cesd20=4 if cesd20==3
replace cesd20=3 if cesd20==0
replace cesd20=0 if cesd20==4
replace cesd20=5 if cesd20==2
replace cesd20=2 if cesd20==1
replace cesd20=1 if cesd20==5

gen cesd=(cesd1+cesd2+cesd3+cesd4+cesd5+cesd6+cesd7+cesd8+cesd9+cesd10+cesd11+cesd12+cesd13+cesd14+cesd15+cesd16+cesd17+cesd18+cesd19+cesd20)
gen hope=cesd8
gen depress=.
replace depress=1 if cesd>=16 & cesd!=.
replace depress=0 if cesd<16  & cesd!=.

replace hope=4 if hope==0
replace hope=0 if hope==3
replace hope=3 if hope==1
replace hope=1 if hope==0
tabulate hope

drop cesd1 cesd2 cesd3 cesd4 cesd5 cesd6 cesd7 cesd9 cesd10 cesd11 cesd12 cesd13 cesd14 cesd15 cesd16 cesd17 cesd18 cesd19 cesd20 
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
count if caseid!=caseid[_n-1] 

summarize cesd
count if cesd==.
tabulate hope

clear

/*
*************
*************
*SECTION 4:
*ALCOHOL
*************
*************

infix caseid 1-5 visit 6-8 drnk 1074 fdrnk 1224 fadrnk 1208 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
tabulate fdrnk

gen hdrnk=.
replace hdrnk=1 if fdrnk==1
replace hdrnk=1 if fdrnk==2
replace hdrnk=0 if fdrnk==0
replace hdrnk=0 if fdrnk>=3 & fdrnk!=.

*Subject Visits Before Merge
count
tabulate hdrnk
*Subjects Before Merge
preserve
by caseid: keep if _n==1
count
tabulate hdrnk
restore
sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

*Subject Visits After Merge
count
tabulate hdrnk
*Subjects After Merge
preserve
by caseid: keep if _n==1
count
tabulate hdrnk
restore

*drop drnk fdrnk fadrnk
by caseid: egen evhdrnk=max(hdrnk)

save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
*Subjects
preserve
by caseid: keep if _n==1
tabulate evhdrnk
restore
clear

*************
*************
*SECTION 4:
*SMOKING
*************
*************

infix caseid 1-5 visit 6-8 esmok 1191 smokn 2885 packs 2553 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
count
replace esmok=0 if esmok==1
replace esmok=1 if esmok==2

gen hsmoke=.
replace hsmoke=0 if smokn==. & packs==0 & esmok==.
replace hsmoke=0 if smokn==. & packs==5 & esmok==.
replace hsmoke=0 if smokn==1 & packs==. & esmok==.
replace hsmoke=0 if smokn==1 & packs==0 & esmok==.
replace hsmoke=0 if smokn==2 & packs==5 & esmok==.
replace hsmoke=0 if smokn==3 & packs==. & esmok==.
replace hsmoke=0 if smokn==3 & packs==0 & esmok==.
replace hsmoke=0 if smokn==3 & packs==5 & esmok==.

replace hsmoke=1 if smokn==. & packs==1 & esmok==.
replace hsmoke=1 if smokn==. & packs==2 & esmok==.
replace hsmoke=1 if smokn==. & packs==3 & esmok==.
replace hsmoke=1 if smokn==. & packs==4 & esmok==.
replace hsmoke=1 if smokn==2 & packs==. & esmok==.
replace hsmoke=1 if smokn==2 & packs==1 & esmok==.
replace hsmoke=1 if smokn==2 & packs==2 & esmok==.
replace hsmoke=1 if smokn==2 & packs==3 & esmok==.
replace hsmoke=1 if smokn==2 & packs==4 & esmok==.

replace hsmoke=0 if smokn==. & packs==. & esmok==0
replace hsmoke=0 if smokn==. & packs==0 & esmok==0
replace hsmoke=0 if smokn==1 & packs==. & esmok==0
replace hsmoke=0 if smokn==1 & packs==0 & esmok==0

replace hsmoke=0 if smokn==. & packs==0 & esmok==1
replace hsmoke=0 if smokn==. & packs==5 & esmok==1
replace hsmoke=0 if smokn==1 & packs==. & esmok==1
replace hsmoke=0 if smokn==1 & packs==0 & esmok==1
replace hsmoke=0 if smokn==2 & packs==5 & esmok==1
replace hsmoke=0 if smokn==3 & packs==. & esmok==1
replace hsmoke=0 if smokn==3 & packs==0 & esmok==1
replace hsmoke=0 if smokn==3 & packs==5 & esmok==1

replace hsmoke=1 if smokn==. & packs==1 & esmok==1
replace hsmoke=1 if smokn==. & packs==2 & esmok==1
replace hsmoke=1 if smokn==. & packs==3 & esmok==1
replace hsmoke=1 if smokn==. & packs==4 & esmok==1
replace hsmoke=1 if smokn==2 & packs==. & esmok==1
replace hsmoke=1 if smokn==2 & packs==1 & esmok==1
replace hsmoke=1 if smokn==2 & packs==2 & esmok==1
replace hsmoke=1 if smokn==2 & packs==3 & esmok==1
replace hsmoke=1 if smokn==2 & packs==4 & esmok==1


*Subject Visits Before Merge
count
tabulate hsmoke
*Subjects Before Merge
preserve
by caseid: keep if _n==1
count
tabulate hsmoke
restore
sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

*drop smokn packs esmok 

by caseid: egen evhsmoke=max(hsmoke)
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace

*Subject Visits
count
tabulate hsmoke
*Subjects
preserve
by caseid: keep if _n==1
tabulate evhsmoke
restore
clear


*************
*************
*SECTION 4:
*DRUG USE
*************
*************

infix caseid 1-5 visit 6-8 cokev 623 cokef 617 cracv 685 cracf 684 ocokv 2335 ocokf 2334 hashv 1386 hashf 1381 mdav 1809 mdaf 1799 upprv 3375 upprf 3369 poppv 2657 poppf 2652 pcpv 2597 pcpf 2585 downv 1064 downf 1059 opiav 2434 opiaf 2432 spebv 2902 spebf 2901 stmdv 2980 stmdf 2978 stmd1 2971 st1df 2904 stmd2 2972 st2df 2906 stmd3 2973 st3df 2908 stmd4 2974 st4df 2910 stmd5 2975 st5df 2910 stmd6 2976 st6df 2913 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
count

gen coke=.
replace coke=1 if cokev==. & cokef==1 & visit<=110
replace coke=1 if cokev==. & cokef==2 & visit<=110
replace coke=1 if cokev==. & cokef==3 & visit<=110
replace coke=1 if cokev==. & cokef==4 & visit<=110
replace coke=1 if cokev==2 & cokef==. & visit<=110
replace coke=1 if cokev==2 & cokef==1 & visit<=110
replace coke=1 if cokev==2 & cokef==2 & visit<=110
replace coke=1 if cokev==2 & cokef==3 & visit<=110
replace coke=1 if cokev==2 & cokef==4 & visit<=110

replace coke=0 if cokev==. & cokef==5 & visit<=110
replace coke=0 if cokev==1 & cokef==. & visit<=110
replace coke=0 if cokev==1 & cokef==5 & visit<=110

gen crac=.
replace crac=1 if cracv==. & cracf==1 & visit>110
replace crac=1 if cracv==. & cracf==2 & visit>110
replace crac=1 if cracv==. & cracf==3 & visit>110
replace crac=1 if cracv==. & cracf==4 & visit>110
replace crac=1 if cracv==2 & cracf==. & visit>110
replace crac=1 if cracv==2 & cracf==1 & visit>110
replace crac=1 if cracv==2 & cracf==2 & visit>110
replace crac=1 if cracv==2 & cracf==3 & visit>110
replace crac=1 if cracv==2 & cracf==4 & visit>110

replace crac=0 if cracv==1 & cracf==. & visit>110

gen ocok=.
replace ocok=1 if ocokv==. & ocokf==1 & visit>110
replace ocok=1 if ocokv==. & ocokf==2 & visit>110
replace ocok=1 if ocokv==. & ocokf==3 & visit>110
replace ocok=1 if ocokv==. & ocokf==4 & visit>110
replace ocok=1 if ocokv==2 & ocokf==. & visit>110
replace ocok=1 if ocokv==2 & ocokf==1 & visit>110
replace ocok=1 if ocokv==2 & ocokf==2 & visit>110
replace ocok=1 if ocokv==2 & ocokf==3 & visit>110
replace ocok=1 if ocokv==2 & ocokf==4 & visit>110

replace ocok=0 if ocokv==1 & ocokf==. & visit>110

replace coke=1 if crac==1 & visit>110
replace coke=1 if ocok==1 & visit>110
replace coke=0 if crac==0 & visit>110
replace coke=0 if ocok==0 & visit>110


gen hash=.
replace hash=1 if hashv==. & hashf==1 
replace hash=1 if hashv==. & hashf==2
replace hash=1 if hashv==. & hashf==3
replace hash=1 if hashv==. & hashf==4
replace hash=1 if hashv==2 & hashf==.
replace hash=1 if hashv==2 & hashf==1
replace hash=1 if hashv==2 & hashf==2
replace hash=1 if hashv==2 & hashf==3
replace hash=1 if hashv==2 & hashf==4

replace hash=0 if hashv==. & hashf==5
replace hash=0 if hashv==1 & hashf==.
replace hash=0 if hashv==1 & hashf==5

gen mda=.
replace mda=1 if mdav==. & mdaf==1 
replace mda=1 if mdav==. & mdaf==2
replace mda=1 if mdav==. & mdaf==3
replace mda=1 if mdav==. & mdaf==4
replace mda=1 if mdav==2 & mdaf==.
replace mda=1 if mdav==2 & mdaf==1
replace mda=1 if mdav==2 & mdaf==2
replace mda=1 if mdav==2 & mdaf==3
replace mda=1 if mdav==2 & mdaf==4

replace mda=0 if mdav==. & mdaf==5
replace mda=0 if mdav==1 & mdaf==.
replace mda=0 if mdav==1 & mdaf==5

gen uppr=.
replace uppr=1 if upprv==. & upprf==1 
replace uppr=1 if upprv==. & upprf==2
replace uppr=1 if upprv==. & upprf==3
replace uppr=1 if upprv==. & upprf==4
replace uppr=1 if upprv==2 & upprf==.
replace uppr=1 if upprv==2 & upprf==1
replace uppr=1 if upprv==2 & upprf==2
replace uppr=1 if upprv==2 & upprf==3
replace uppr=1 if upprv==2 & upprf==4

replace uppr=0 if upprv==. & upprf==5
replace uppr=0 if upprv==1 & upprf==.
replace uppr=0 if upprv==1 & upprf==5

gen popp=.
replace popp=1 if poppv==. & poppf==1 
replace popp=1 if poppv==. & poppf==2
replace popp=1 if poppv==. & poppf==3
replace popp=1 if poppv==. & poppf==4
replace popp=1 if poppv==2 & poppf==.
replace popp=1 if poppv==2 & poppf==1
replace popp=1 if poppv==2 & poppf==2
replace popp=1 if poppv==2 & poppf==3
replace popp=1 if poppv==2 & poppf==4

replace popp=0 if poppv==. & poppf==5
replace popp=0 if poppv==1 & poppf==.
replace popp=0 if poppv==1 & poppf==5

gen pcp=.
replace pcp=1 if pcpv==. & pcpf==1 
replace pcp=1 if pcpv==. & pcpf==2
replace pcp=1 if pcpv==. & pcpf==3
replace pcp=1 if pcpv==. & pcpf==4
replace pcp=1 if pcpv==2 & pcpf==.
replace pcp=1 if pcpv==2 & pcpf==1
replace pcp=1 if pcpv==2 & pcpf==2
replace pcp=1 if pcpv==2 & pcpf==3
replace pcp=1 if pcpv==2 & pcpf==4

replace pcp=0 if pcpv==. & pcpf==5
replace pcp=0 if pcpv==1 & pcpf==.
replace pcp=0 if pcpv==1 & pcpf==5

gen down=.
replace down=1 if downv==. & downf==1 
replace down=1 if downv==. & downf==2
replace down=1 if downv==. & downf==3
replace down=1 if downv==. & downf==4
replace down=1 if downv==2 & downf==.
replace down=1 if downv==2 & downf==1
replace down=1 if downv==2 & downf==2
replace down=1 if downv==2 & downf==3
replace down=1 if downv==2 & downf==4

replace down=0 if downv==. & downf==5
replace down=0 if downv==1 & downf==.
replace down=0 if downv==1 & downf==5

gen opia=.
replace opia=1 if opiav==. & opiaf==1 
replace opia=1 if opiav==. & opiaf==2
replace opia=1 if opiav==. & opiaf==3
replace opia=1 if opiav==. & opiaf==4
replace opia=1 if opiav==2 & opiaf==.
replace opia=1 if opiav==2 & opiaf==1
replace opia=1 if opiav==2 & opiaf==2
replace opia=1 if opiav==2 & opiaf==3
replace opia=1 if opiav==2 & opiaf==4

replace opia=0 if opiav==. & opiaf==5
replace opia=0 if opiav==1 & opiaf==.
replace opia=0 if opiav==1 & opiaf==5

gen speb=.
replace speb=1 if spebv==. & spebf==1 
replace speb=1 if spebv==. & spebf==2
replace speb=1 if spebv==. & spebf==3
replace speb=1 if spebv==. & spebf==4
replace speb=1 if spebv==2 & spebf==.
replace speb=1 if spebv==2 & spebf==1
replace speb=1 if spebv==2 & spebf==2
replace speb=1 if spebv==2 & spebf==3
replace speb=1 if spebv==2 & spebf==4
replace speb=0 if spebv==1 & spebf==.

gen stmd=.
replace stmd=1 if stmdv==. & stmdf==1 
replace stmd=1 if stmdv==. & stmdf==2
replace stmd=1 if stmdv==. & stmdf==3
replace stmd=1 if stmdv==. & stmdf==4
replace stmd=1 if stmdv==2 & stmdf==.
replace stmd=1 if stmdv==2 & stmdf==1
replace stmd=1 if stmdv==2 & stmdf==2
replace stmd=1 if stmdv==2 & stmdf==3
replace stmd=1 if stmdv==2 & stmdf==4

replace stmd=0 if stmdv==. & stmdf==5
replace stmd=0 if stmdv==1 & stmdf==.
replace stmd=0 if stmdv==1 & stmdf==5

replace stmd=1 if stmd1==2|stmd2==2|stmd3==2|stmd4==2|stmd5==2|stmd6==2


forvalues i=250(10)410{
display "visit" `i'
tabulate stmd1 if visit==`i'
tabulate stmd2 if visit==`i'
count if (stmd1==1|stmd2==1) & visit==`i'
}

tabulate coke
tabulate hash
tabulate mda
tabulate uppr
tabulate popp
tabulate pcp
tabulate down
tabulate opia
tabulate speb
tabulate stmd

sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

gen drugs=.
replace drugs=1 if (coke==1|hash==1|popp==1|stmd==1)
replace drugs=0 if (coke==0 & hash==0 & popp==0 & stmd==0)
replace drugs=1 if down==1
replace drugs=. if down==. & visit>=10 & visit<=150
replace drugs=1 if pcp==1
replace drugs=. if pcp==. & visit>=10 & visit<=150
replace drugs=1 if opia==1
replace drugs=. if opia==. & visit>=10 & visit<=110
replace drugs=1 if speb==1
replace drugs=. if speb==. & visit>=360
replace drugs=1 if mda==1
replace drugs=. if mda==. & ((visit>=10 & visit<=150)|(visit>=260))
replace drugs=1 if uppr==1
replace drugs=. if uppr==. & ((visit>=10 & visit<=150)|(visit>=260))

gen hdrugs=.
replace hdrugs=1 if (coke==1|popp==1|stmd==1)
replace hdrugs=0 if (coke==0 & popp==0 & stmd==0)
replace hdrugs=1 if down==1
replace hdrugs=. if down==. & visit>=10 & visit<=150
replace hdrugs=1 if pcp==1
replace hdrugs=. if pcp==. & visit>=10 & visit<=150
replace hdrugs=1 if opia==1
replace hdrugs=. if opia==. & visit>=10 & visit<=110
replace hdrugs=1 if speb==1
replace hdrugs=. if speb==. & visit>=360
replace hdrugs=1 if mda==1
replace hdrugs=. if mda==. & ((visit>=10 & visit<=150)|(visit>=260))
replace hdrugs=1 if uppr==1
replace hdrugs=. if uppr==. & ((visit>=10 & visit<=150)|(visit>=260))

gen hhdrugs=.
replace hhdrugs=1 if (coke==1|stmd==1)
replace hhdrugs=0 if (coke==0 & stmd==0)
replace hhdrugs=1 if down==1
replace hhdrugs=. if down==. & visit>=10 & visit<=150
replace hhdrugs=1 if pcp==1
replace hhdrugs=. if pcp==. & visit>=10 & visit<=150
replace hhdrugs=1 if opia==1
replace hhdrugs=. if opia==. & visit>=10 & visit<=110
replace hhdrugs=1 if speb==1
replace hhdrugs=. if speb==. & visit>=360
replace hhdrugs=1 if mda==1
replace hhdrugs=. if mda==. & ((visit>=10 & visit<=150)|(visit>=260))
replace hhdrugs=1 if uppr==1
replace hhdrugs=. if uppr==. & ((visit>=10 & visit<=150)|(visit>=260))

by caseid: egen evcoke  =max(coke)
by caseid: egen evhash  =max(hash)
by caseid: egen evmda   =max(mda)
by caseid: egen evuppr  =max(uppr)
by caseid: egen evpopp  =max(popp)
by caseid: egen evpcp   =max(pcp)
by caseid: egen evdown  =max(down)
by caseid: egen evopia  =max(opia)
by caseid: egen evspeb  =max(speb)
by caseid: egen evstmd  =max(stmd)
by caseid: egen evdrugs =max(drugs)
by caseid: egen evhdrugs=max(hdrugs)
by caseid: egen evhhdrugs=max(hdrugs)


save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
*Subject Visits
count
tabulate hsmoke
tabulate hdrnk
tabulate coke
tabulate hash
tabulate mda
tabulate uppr
tabulate popp
tabulate pcp
tabulate down
tabulate opia
tabulate speb
tabulate stmd
tabulate drugs
tabulate hdrugs
tabulate hhdrugs

*Subjects
preserve
by caseid: keep if _n==1 
tabulate evhsmoke
tabulate evhdrnk
tabulate evcoke
tabulate evhash
tabulate evmda
tabulate evuppr
tabulate evpopp
tabulate evpcp
tabulate evdown
tabulate evopia
tabulate evspeb
tabulate evstmd
tabulate drugs
tabulate hdrugs
tabulate hhdrugs

restore
clear
*/


*************
*************
*SECTION 4:
*SEX
*************
*************

infix caseid 1-5 visit 6-8 sexav 2845 sexvf 2847 sexvm 2848 nsexf 2224-2226 nsexm 2227-2229 nnsxm 2147-2149 recty 2734-2736 condy 653-655 anin1 127 nainm 1999-2001 tcai1 3052-3054 tcaim 3055-3057 cain1 430 ncaim 2016-2018 rectp 2731-2733 condp 650-652 anrc1 137 tcarm 3063-3065 narim 2009-2011 tcar1 3060-3062 canr1 476 ncarm 2022-2024 mouty 1944-1946 mouy 1947-1949 orin1 2443 noinm 2169-2171 moup 1941-1943 orrc1 2444 norcm 2176-2178 rpart 2780 unfat 3361 ltepm 1716-1718 ltepy 1719-1720 anonm 134-136 ano2m 130 nanom 2003-2005 spart 2900 nhivk 2096-2098 nhivp 2102-2104 nhivn 2099-2101 nahiv 1995 hivkn 1465 hivst 1467 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
count
*95687

replace sexav=0 if sexav==1
replace sexav=1 if sexav==2
replace sexvm=0 if sexvm==1
replace sexvm=1 if sexvm==2
replace sexvf=0 if sexvf==1
replace sexvf=1 if sexvf==2
replace anin1=0 if anin1==1
replace anin1=1 if anin1==2
replace anrc1=0 if anrc1==1
replace anrc1=1 if anrc1==2
replace orin1=0 if orin1==1
replace orin1=1 if orin1==2
replace orrc1=0 if orrc1==1
replace orrc1=1 if orrc1==2
replace mouy=mouty if visit==10
drop mouty

************
*Check VARS
*Intercourse
************
count
*Look at number of male intercourse partners
count if nsexm==.
count if nsexm==0
count if nsexm==1
count if nsexm==2

*Deal with Missing 11454
count if nsexm==.

count if nsexm==. & sexav==. & sexvm==.
count if nsexm==. & sexav==0 & sexvm==.
count if nsexm==. & sexav==1 & sexvm==.
count if nsexm==. & sexav==. & sexvm==0
count if nsexm==. & sexav==0 & sexvm==0
count if nsexm==. & sexav==1 & sexvm==0
count if nsexm==. & sexav==. & sexvm==1
count if nsexm==. & sexav==0 & sexvm==1
count if nsexm==. & sexav==1 & sexvm==1

*But: there are 6 contradictions which we'll call unknowns
count if sexav==0 & nsexm==1
count if sexav==1 & sexvm==0 & nsexm==2
count if sexav==1 & sexvm==0 & nsexm==1

********************************
*MSEX (Intercourse with MEN 0,1)
********************************

gen msex=.
replace msex=0 if sexav==0 & sexvm==. & nsexm==.
replace msex=0 if sexav==. & sexvm==. & nsexm==0
replace msex=0 if sexav==0 & sexvm==. & nsexm==0
replace msex=0 if sexav==1 & sexvm==. & nsexm==0
replace msex=0 if sexav==. & sexvm==0 & nsexm==.
replace msex=0 if sexav==0 & sexvm==0 & nsexm==.
replace msex=0 if sexav==1 & sexvm==0 & nsexm==.
replace msex=0 if sexav==. & sexvm==0 & nsexm==0
replace msex=0 if sexav==0 & sexvm==0 & nsexm==0
replace msex=0 if sexav==1 & sexvm==0 & nsexm==0
replace msex=0 if sexav==. & sexvm==1 & nsexm==0
replace msex=0 if sexav==1 & sexvm==1 & nsexm==0

replace msex=1 if sexav==. & sexvm==. & nsexm==1
replace msex=1 if sexav==1 & sexvm==. & nsexm==1
replace msex=1 if sexav==. & sexvm==. & nsexm==2
replace msex=1 if sexav==1 & sexvm==. & nsexm==2
replace msex=1 if sexav==. & sexvm==1 & nsexm==1
replace msex=1 if sexav==1 & sexvm==1 & nsexm==1
replace msex=1 if sexav==. & sexvm==1 & nsexm==2
replace msex=1 if sexav==1 & sexvm==1 & nsexm==2
tabulate msex
count if msex==.
*1411

************************************
*NMSEX (Intercourse with MEN: 0,1,2)
************************************

gen nmsex=.
replace nmsex=0 if sexav==0 & sexvm==. & nsexm==.
replace nmsex=0 if sexav==. & sexvm==. & nsexm==0
replace nmsex=0 if sexav==0 & sexvm==. & nsexm==0
replace nmsex=0 if sexav==1 & sexvm==. & nsexm==0
replace nmsex=0 if sexav==. & sexvm==0 & nsexm==.
replace nmsex=0 if sexav==0 & sexvm==0 & nsexm==.
replace nmsex=0 if sexav==1 & sexvm==0 & nsexm==.
replace nmsex=0 if sexav==. & sexvm==0 & nsexm==0
replace nmsex=0 if sexav==0 & sexvm==0 & nsexm==0
replace nmsex=0 if sexav==1 & sexvm==0 & nsexm==0
replace nmsex=0 if sexav==. & sexvm==1 & nsexm==0
replace nmsex=0 if sexav==1 & sexvm==1 & nsexm==0

replace nmsex=1 if sexav==. & sexvm==. & nsexm==1
replace nmsex=1 if sexav==1 & sexvm==. & nsexm==1
replace nmsex=2 if sexav==. & sexvm==. & nsexm==2
replace nmsex=2 if sexav==1 & sexvm==. & nsexm==2
replace nmsex=1 if sexav==. & sexvm==1 & nsexm==1
replace nmsex=1 if sexav==1 & sexvm==1 & nsexm==1
replace nmsex=2 if sexav==. & sexvm==1 & nsexm==2
replace nmsex=2 if sexav==1 & sexvm==1 & nsexm==2
tabulate nmsex
count if nmsex==.
*1411

****************
*Check VARS
*NON-Intercourse
****************
count
*Look at number of male non-intercourse partners
count if nnsxm==.
count if nnsxm==0
count if nnsxm==1
count if nnsxm==2

*Deal with Missing 41085
count if nnsxm==.

count if nnsxm==. & sexav==. & sexvm==.
count if nnsxm==. & sexav==0 & sexvm==.
count if nnsxm==. & sexav==1 & sexvm==.
count if nnsxm==. & sexav==. & sexvm==0
count if nnsxm==. & sexav==0 & sexvm==0
count if nnsxm==. & sexav==1 & sexvm==0
count if nnsxm==. & sexav==. & sexvm==1
count if nnsxm==. & sexav==0 & sexvm==1
count if nnsxm==. & sexav==1 & sexvm==1




**************************************
*NIMSEX (NON-Intercourse with MEN 0,1)
**************************************

gen nimsex=.
replace nimsex=0 if sexav==0 & sexvm==. & nnsxm==.
replace nimsex=0 if sexav==. & sexvm==. & nnsxm==0
replace nimsex=0 if sexav==0 & sexvm==. & nnsxm==0
replace nimsex=0 if sexav==1 & sexvm==. & nnsxm==0
replace nimsex=0 if sexav==. & sexvm==0 & nnsxm==.
replace nimsex=0 if sexav==0 & sexvm==0 & nnsxm==.
replace nimsex=0 if sexav==1 & sexvm==0 & nnsxm==.
replace nimsex=0 if sexav==. & sexvm==0 & nnsxm==0
replace nimsex=0 if sexav==0 & sexvm==0 & nnsxm==0
replace nimsex=0 if sexav==1 & sexvm==0 & nnsxm==0
replace nimsex=0 if sexav==. & sexvm==1 & nnsxm==0
replace nimsex=0 if sexav==1 & sexvm==1 & nnsxm==0

replace nimsex=1 if sexav==. & sexvm==. & nnsxm==1
replace nimsex=1 if sexav==1 & sexvm==. & nnsxm==1
replace nimsex=1 if sexav==. & sexvm==. & nnsxm==2
replace nimsex=1 if sexav==1 & sexvm==. & nnsxm==2
replace nimsex=1 if sexav==. & sexvm==1 & nnsxm==1
replace nimsex=1 if sexav==1 & sexvm==1 & nnsxm==1
replace nimsex=1 if sexav==. & sexvm==1 & nnsxm==2
replace nimsex=1 if sexav==1 & sexvm==1 & nnsxm==2
tabulate nimsex
count if nimsex==. & visit>=70
*3164

******************************************
*NINMSEX (NON-Intercourse with MEN: 0,1,2)
******************************************

gen ninmsex=.
replace ninmsex=0 if sexav==0 & sexvm==. & nnsxm==.
replace ninmsex=0 if sexav==. & sexvm==. & nnsxm==0
replace ninmsex=0 if sexav==0 & sexvm==. & nnsxm==0
replace ninmsex=0 if sexav==1 & sexvm==. & nnsxm==0
replace ninmsex=0 if sexav==. & sexvm==0 & nnsxm==.
replace ninmsex=0 if sexav==0 & sexvm==0 & nnsxm==.
replace ninmsex=0 if sexav==1 & sexvm==0 & nnsxm==.
replace ninmsex=0 if sexav==. & sexvm==0 & nnsxm==0
replace ninmsex=0 if sexav==0 & sexvm==0 & nnsxm==0
replace ninmsex=0 if sexav==1 & sexvm==0 & nnsxm==0
replace ninmsex=0 if sexav==. & sexvm==1 & nnsxm==0
replace ninmsex=0 if sexav==1 & sexvm==1 & nnsxm==0

replace ninmsex=1 if sexav==. & sexvm==. & nnsxm==1
replace ninmsex=1 if sexav==1 & sexvm==. & nnsxm==1
replace ninmsex=2 if sexav==. & sexvm==. & nnsxm==2
replace ninmsex=2 if sexav==1 & sexvm==. & nnsxm==2
replace ninmsex=1 if sexav==. & sexvm==1 & nnsxm==1
replace ninmsex=1 if sexav==1 & sexvm==1 & nnsxm==1
replace ninmsex=2 if sexav==. & sexvm==1 & nnsxm==2
replace ninmsex=2 if sexav==1 & sexvm==1 & nnsxm==2
tabulate ninmsex
count if ninmsex==.
*3164

replace nimsex=. if visit<80
replace ninmsex=. if visit<80
count if visit>=80 & visit!=.
tabulate nimsex
count if nimsex==. & visit>=80 & visit!=.
tabulate ninmsex
count if ninmsex==. & visit>=80 & visit!=.

**************************************************
*WOMEN INTERLUDE --- BEGIN
**************************************************


************
*Check VARS
*Intercourse
************
count
*Look at number of female intercourse partners
count if nsexf==.
count if nsexf==0
count if nsexf==1
count if nsexf==2

*Deal with Missing 11454
count if nsexf==.

count if nsexf==. & sexav==. & sexvf==.
count if nsexf==. & sexav==0 & sexvf==.
count if nsexf==. & sexav==1 & sexvf==.
count if nsexf==. & sexav==. & sexvf==0
count if nsexf==. & sexav==0 & sexvf==0
count if nsexf==. & sexav==1 & sexvf==0
count if nsexf==. & sexav==. & sexvf==1
count if nsexf==. & sexav==0 & sexvf==1
count if nsexf==. & sexav==1 & sexvf==1

*But: there are 6 contradictions which we'll call unknowns
count if sexav==0 & nsexf==1
count if sexav==1 & sexvf==0 & nsexf==2
count if sexav==1 & sexvf==0 & nsexf==1

********************************
*FSEX (Intercourse with MEN 0,1)
********************************

gen fsex=.
replace fsex=0 if sexav==0 & sexvf==. & nsexf==.
replace fsex=0 if sexav==. & sexvf==. & nsexf==0
replace fsex=0 if sexav==0 & sexvf==. & nsexf==0
replace fsex=0 if sexav==1 & sexvf==. & nsexf==0
replace fsex=0 if sexav==. & sexvf==0 & nsexf==.
replace fsex=0 if sexav==0 & sexvf==0 & nsexf==.
replace fsex=0 if sexav==1 & sexvf==0 & nsexf==.
replace fsex=0 if sexav==. & sexvf==0 & nsexf==0
replace fsex=0 if sexav==0 & sexvf==0 & nsexf==0
replace fsex=0 if sexav==1 & sexvf==0 & nsexf==0
replace fsex=0 if sexav==. & sexvf==1 & nsexf==0
replace fsex=0 if sexav==1 & sexvf==1 & nsexf==0

replace fsex=1 if sexav==. & sexvf==. & nsexf==1
replace fsex=1 if sexav==1 & sexvf==. & nsexf==1
replace fsex=1 if sexav==. & sexvf==. & nsexf==2
replace fsex=1 if sexav==1 & sexvf==. & nsexf==2
replace fsex=1 if sexav==. & sexvf==1 & nsexf==1
replace fsex=1 if sexav==1 & sexvf==1 & nsexf==1
replace fsex=1 if sexav==. & sexvf==1 & nsexf==2
replace fsex=1 if sexav==1 & sexvf==1 & nsexf==2
tabulate fsex
count if fsex==.
*1489

************************************
*NMSEX (Intercourse with MEN: 0,1,2)
************************************

gen nfsex=.
replace nfsex=0 if sexav==0 & sexvf==. & nsexf==.
replace nfsex=0 if sexav==. & sexvf==. & nsexf==0
replace nfsex=0 if sexav==0 & sexvf==. & nsexf==0
replace nfsex=0 if sexav==1 & sexvf==. & nsexf==0
replace nfsex=0 if sexav==. & sexvf==0 & nsexf==.
replace nfsex=0 if sexav==0 & sexvf==0 & nsexf==.
replace nfsex=0 if sexav==1 & sexvf==0 & nsexf==.
replace nfsex=0 if sexav==. & sexvf==0 & nsexf==0
replace nfsex=0 if sexav==0 & sexvf==0 & nsexf==0
replace nfsex=0 if sexav==1 & sexvf==0 & nsexf==0
replace nfsex=0 if sexav==. & sexvf==1 & nsexf==0
replace nfsex=0 if sexav==1 & sexvf==1 & nsexf==0

replace nfsex=1 if sexav==. & sexvf==. & nsexf==1
replace nfsex=1 if sexav==1 & sexvf==. & nsexf==1
replace nfsex=2 if sexav==. & sexvf==. & nsexf==2
replace nfsex=2 if sexav==1 & sexvf==. & nsexf==2
replace nfsex=1 if sexav==. & sexvf==1 & nsexf==1
replace nfsex=1 if sexav==1 & sexvf==1 & nsexf==1
replace nfsex=2 if sexav==. & sexvf==1 & nsexf==2
replace nfsex=2 if sexav==1 & sexvf==1 & nsexf==2
tabulate nfsex
count if nfsex==.
*1489



**************************************************
*WOMEN INTERLUDE --- END
**************************************************

*********
*********
*ANAL SEX
*********
*********

*******************
*INSERTIVE ANAL SEX
*******************

gen niasex=.
replace niasex=0 if (sexav==. & sexvm==. & nsexm==.) & recty==0 & visit<80
replace niasex=0 if (sexav==1 & sexvm==. & nsexm==.) & recty==0 & visit<80
replace niasex=0 if (sexav==. & sexvm==1 & nsexm==.) & recty==0 & visit<80
replace niasex=0 if (sexav==1 & sexvm==1 & nsexm==.) & recty==0 & visit<80
replace niasex=0 if nmsex==0 & recty==. & visit<80
replace niasex=0 if nmsex==0 & recty==0 & visit<80
replace niasex=0 if nmsex==1 & recty==0 & visit<80
replace niasex=0 if nmsex==2 & recty==0 & visit<80

replace niasex=1 if (sexav==. & sexvm==. & nsexm==.) & recty==1 & visit<80
replace niasex=1 if (sexav==1 & sexvm==. & nsexm==.) & recty==1 & visit<80
replace niasex=1 if (sexav==. & sexvm==1 & nsexm==.) & recty==1 & visit<80
replace niasex=1 if (sexav==1 & sexvm==1 & nsexm==.) & recty==1 & visit<80
replace niasex=1 if nmsex==1 & recty==1 & visit<80
replace niasex=1 if nmsex==2 & recty==1 & visit<80

replace niasex=2 if (sexav==. & sexvm==. & nsexm==.) & recty==2 & visit<80
replace niasex=2 if (sexav==. & sexvm==1 & nsexm==.) & recty==2 & visit<80
replace niasex=2 if (sexav==1 & sexvm==. & nsexm==.) & recty==2 & visit<80
replace niasex=2 if (sexav==1 & sexvm==1 & nsexm==.) & recty==2 & visit<80
replace niasex=2 if nmsex==2 & recty==2 & visit<80

replace niasex=0 if (sexav==. & sexvm==. & nsexm==.) & anin1==0 & visit>=80
replace niasex=0 if (sexav==. & sexvm==1 & nsexm==.) & anin1==0 & visit>=80
replace niasex=0 if (sexav==1 & sexvm==. & nsexm==.) & anin1==0 & visit>=80
replace niasex=0 if (sexav==1 & sexvm==1 & nsexm==.) & anin1==0 & visit>=80
replace niasex=0 if nmsex==0 & anin1==. & visit>=80
replace niasex=0 if nmsex==0 & anin1==0 & visit>=80
replace niasex=0 if nmsex==1 & anin1==0 & visit>=80

replace niasex=1 if (sexav==. & sexvm==. & nsexm==.) & anin1==1 & visit>=80
replace niasex=1 if (sexav==. & sexvm==1 & nsexm==.) & anin1==1 & visit>=80
replace niasex=1 if (sexav==1 & sexvm==. & nsexm==.) & anin1==1 & visit>=80
replace niasex=1 if (sexav==1 & sexvm==1 & nsexm==.) & anin1==1 & visit>=80
replace niasex=1 if nmsex==1 & anin1==1 & visit>=80

replace niasex=0 if (sexav==. & sexvm==. & nsexm==.) & nainm==0 & visit>=80 
replace niasex=0 if (sexav==. & sexvm==1 & nsexm==.) & nainm==0 & visit>=80 
replace niasex=0 if (sexav==1 & sexvm==. & nsexm==.) & nainm==0 & visit>=80 
replace niasex=0 if (sexav==1 & sexvm==1 & nsexm==.) & nainm==0 & visit>=80 
replace niasex=0 if nmsex==0 & nainm==. & visit>=80 
replace niasex=0 if nmsex==0 & nainm==0 & visit>=80 
replace niasex=0 if nmsex==2 & nainm==0 & visit>=80 

replace niasex=1 if (sexav==. & sexvm==. & nsexm==.) & nainm==1 & visit>=80  
replace niasex=1 if (sexav==. & sexvm==1 & nsexm==.) & nainm==1 & visit>=80  
replace niasex=1 if (sexav==1 & sexvm==. & nsexm==.) & nainm==1 & visit>=80  
replace niasex=1 if (sexav==1 & sexvm==1 & nsexm==.) & nainm==1 & visit>=80  
replace niasex=1 if nmsex==2 & nainm==1 & visit>=80  

replace niasex=2 if (sexav==. & sexvm==. & nsexm==.) & nainm==2 & visit>=80  
replace niasex=2 if (sexav==. & sexvm==1 & nsexm==.) & nainm==2 & visit>=80  
replace niasex=2 if (sexav==1 & sexvm==. & nsexm==.) & nainm==2 & visit>=80  
replace niasex=2 if (sexav==1 & sexvm==1 & nsexm==.) & nainm==2 & visit>=80  
replace niasex=2 if nmsex==2 & nainm==2 & visit>=80  

*replace niasex=0 if nmsex==2 & anin1==0 & nainm==. & niasex==. 
*replace niasex=0 if nmsex==2 & anin1==0 & nainm==0 & niasex==. 
*replace niasex=1 if nmsex==2 & anin1==1 & nainm==. & niasex==. 
*replace niasex=1 if nmsex==2 & anin1==1 & nainm==1 & niasex==. 

*replace niasex=0 if nmsex==1 & anin1==0 & nainm==. & niasex==. 
*replace niasex=0 if nmsex==1 & anin1==0 & nainm==0 & niasex==. 
*replace niasex=1 if nmsex==1 & anin1==1 & nainm==. & niasex==. 
*replace niasex=1 if nmsex==1 & anin1==1 & nainm==1 & niasex==.

*******************
*RECEPTIVE ANAL SEX
*******************

gen nrasex=.
replace nrasex=0 if (sexav==. & sexvm==. & nsexm==.) & rectp==0 & visit<80
replace nrasex=0 if (sexav==1 & sexvm==. & nsexm==.) & rectp==0 & visit<80
replace nrasex=0 if (sexav==. & sexvm==1 & nsexm==.) & rectp==0 & visit<80
replace nrasex=0 if (sexav==1 & sexvm==1 & nsexm==.) & rectp==0 & visit<80
replace nrasex=0 if nmsex==0 & rectp==. & visit<80
replace nrasex=0 if nmsex==0 & rectp==0 & visit<80
replace nrasex=0 if nmsex==1 & rectp==0 & visit<80
replace nrasex=0 if nmsex==2 & rectp==0 & visit<80

replace nrasex=1 if (sexav==. & sexvm==. & nsexm==.) & rectp==1 & visit<80
replace nrasex=1 if (sexav==1 & sexvm==. & nsexm==.) & rectp==1 & visit<80
replace nrasex=1 if (sexav==. & sexvm==1 & nsexm==.) & rectp==1 & visit<80
replace nrasex=1 if (sexav==1 & sexvm==1 & nsexm==.) & rectp==1 & visit<80
replace nrasex=1 if nmsex==1 & rectp==1 & visit<80
replace nrasex=1 if nmsex==2 & rectp==1 & visit<80

replace nrasex=2 if (sexav==. & sexvm==. & nsexm==.) & rectp==2 & visit<80
replace nrasex=2 if (sexav==. & sexvm==1 & nsexm==.) & rectp==2 & visit<80
replace nrasex=2 if (sexav==1 & sexvm==. & nsexm==.) & rectp==2 & visit<80
replace nrasex=2 if (sexav==1 & sexvm==1 & nsexm==.) & rectp==2 & visit<80
replace nrasex=2 if nmsex==2 & rectp==2 & visit<80

replace nrasex=0 if (sexav==. & sexvm==. & nsexm==.) & anrc1==0 & visit>=80
replace nrasex=0 if (sexav==. & sexvm==1 & nsexm==.) & anrc1==0 & visit>=80
replace nrasex=0 if (sexav==1 & sexvm==. & nsexm==.) & anrc1==0 & visit>=80
replace nrasex=0 if (sexav==1 & sexvm==1 & nsexm==.) & anrc1==0 & visit>=80
replace nrasex=0 if nmsex==0 & anrc1==. & visit>=80
replace nrasex=0 if nmsex==0 & anrc1==0 & visit>=80
replace nrasex=0 if nmsex==1 & anrc1==0 & visit>=80

replace nrasex=1 if (sexav==. & sexvm==. & nsexm==.) & anrc1==1 & visit>=80
replace nrasex=1 if (sexav==. & sexvm==1 & nsexm==.) & anrc1==1 & visit>=80
replace nrasex=1 if (sexav==1 & sexvm==. & nsexm==.) & anrc1==1 & visit>=80
replace nrasex=1 if (sexav==1 & sexvm==1 & nsexm==.) & anrc1==1 & visit>=80
replace nrasex=1 if nmsex==1 & anrc1==1 & visit>=80

replace nrasex=0 if (sexav==. & sexvm==. & nsexm==.) & narim==0 & visit>=80 
replace nrasex=0 if (sexav==. & sexvm==1 & nsexm==.) & narim==0 & visit>=80 
replace nrasex=0 if (sexav==1 & sexvm==. & nsexm==.) & narim==0 & visit>=80 
replace nrasex=0 if (sexav==1 & sexvm==1 & nsexm==.) & narim==0 & visit>=80 
replace nrasex=0 if nmsex==0 & narim==. & visit>=80 
replace nrasex=0 if nmsex==0 & narim==0 & visit>=80 
replace nrasex=0 if nmsex==2 & narim==0 & visit>=80 

replace nrasex=1 if (sexav==. & sexvm==. & nsexm==.) & narim==1 & visit>=80  
replace nrasex=1 if (sexav==. & sexvm==1 & nsexm==.) & narim==1 & visit>=80  
replace nrasex=1 if (sexav==1 & sexvm==. & nsexm==.) & narim==1 & visit>=80  
replace nrasex=1 if (sexav==1 & sexvm==1 & nsexm==.) & narim==1 & visit>=80  
replace nrasex=1 if nmsex==2 & narim==1 & visit>=80  

replace nrasex=2 if (sexav==. & sexvm==. & nsexm==.) & narim==2 & visit>=80  
replace nrasex=2 if (sexav==. & sexvm==1 & nsexm==.) & narim==2 & visit>=80  
replace nrasex=2 if (sexav==1 & sexvm==. & nsexm==.) & narim==2 & visit>=80  
replace nrasex=2 if (sexav==1 & sexvm==1 & nsexm==.) & narim==2 & visit>=80  
replace nrasex=2 if nmsex==2 & narim==2 & visit>=80  

*replace nrasex=0 if nmsex==2 & anrc1==0 & narim==. & nrasex==. 
*replace nrasex=0 if nmsex==2 & anrc1==0 & narim==0 & nrasex==. 
*replace nrasex=1 if nmsex==2 & anrc1==1 & narim==. & nrasex==. 
*replace nrasex=1 if nmsex==2 & anrc1==1 & narim==1 & nrasex==. 

*replace nrasex=0 if nmsex==1 & anrc1==0 & narim==. & nrasex==. 
*replace nrasex=0 if nmsex==1 & anrc1==0 & narim==0 & nrasex==. 
*replace nrasex=1 if nmsex==1 & anrc1==1 & narim==. & nrasex==. 
*replace nrasex=1 if nmsex==1 & anrc1==1 & narim==1 & nrasex==.

*********
*********
*ORAL SEX
*********
*********

*******************
*INSERTIVE ORAL SEX
*******************


gen niosex=.
replace niosex=0 if (sexav==. & sexvm==. & nsexm==.) & mouy==0 & visit<80
replace niosex=0 if (sexav==1 & sexvm==. & nsexm==.) & mouy==0 & visit<80
replace niosex=0 if (sexav==. & sexvm==1 & nsexm==.) & mouy==0 & visit<80
replace niosex=0 if (sexav==1 & sexvm==1 & nsexm==.) & mouy==0 & visit<80
replace niosex=0 if nmsex==0 & mouy==. & visit<80
replace niosex=0 if nmsex==0 & mouy==0 & visit<80
replace niosex=0 if nmsex==1 & mouy==0 & visit<80
replace niosex=0 if nmsex==2 & mouy==0 & visit<80

replace niosex=1 if (sexav==. & sexvm==. & nsexm==.) & mouy==1 & visit<80
replace niosex=1 if (sexav==1 & sexvm==. & nsexm==.) & mouy==1 & visit<80
replace niosex=1 if (sexav==. & sexvm==1 & nsexm==.) & mouy==1 & visit<80
replace niosex=1 if (sexav==1 & sexvm==1 & nsexm==.) & mouy==1 & visit<80
replace niosex=1 if nmsex==1 & mouy==1 & visit<80
replace niosex=1 if nmsex==2 & mouy==1 & visit<80

replace niosex=2 if (sexav==. & sexvm==. & nsexm==.) & mouy==2 & visit<80
replace niosex=2 if (sexav==. & sexvm==1 & nsexm==.) & mouy==2 & visit<80
replace niosex=2 if (sexav==1 & sexvm==. & nsexm==.) & mouy==2 & visit<80
replace niosex=2 if (sexav==1 & sexvm==1 & nsexm==.) & mouy==2 & visit<80
replace niosex=2 if nmsex==2 & mouy==2 & visit<80

replace niosex=0 if (sexav==. & sexvm==. & nsexm==.) & orin1==0 & visit>=80
replace niosex=0 if (sexav==. & sexvm==1 & nsexm==.) & orin1==0 & visit>=80
replace niosex=0 if (sexav==1 & sexvm==. & nsexm==.) & orin1==0 & visit>=80
replace niosex=0 if (sexav==1 & sexvm==1 & nsexm==.) & orin1==0 & visit>=80
replace niosex=0 if nmsex==0 & orin1==. & visit>=80
replace niosex=0 if nmsex==0 & orin1==0 & visit>=80
replace niosex=0 if nmsex==1 & orin1==0 & visit>=80

replace niosex=1 if (sexav==. & sexvm==. & nsexm==.) & orin1==1 & visit>=80
replace niosex=1 if (sexav==. & sexvm==1 & nsexm==.) & orin1==1 & visit>=80
replace niosex=1 if (sexav==1 & sexvm==. & nsexm==.) & orin1==1 & visit>=80
replace niosex=1 if (sexav==1 & sexvm==1 & nsexm==.) & orin1==1 & visit>=80
replace niosex=1 if nmsex==1 & orin1==1 & visit>=80

replace niosex=0 if (sexav==. & sexvm==. & nsexm==.) & noinm==0 & visit>=80 
replace niosex=0 if (sexav==. & sexvm==1 & nsexm==.) & noinm==0 & visit>=80 
replace niosex=0 if (sexav==1 & sexvm==. & nsexm==.) & noinm==0 & visit>=80 
replace niosex=0 if (sexav==1 & sexvm==1 & nsexm==.) & noinm==0 & visit>=80 
replace niosex=0 if nmsex==0 & noinm==. & visit>=80 
replace niosex=0 if nmsex==0 & noinm==0 & visit>=80 
replace niosex=0 if nmsex==2 & noinm==0 & visit>=80 

replace niosex=1 if (sexav==. & sexvm==. & nsexm==.) & noinm==1 & visit>=80  
replace niosex=1 if (sexav==. & sexvm==1 & nsexm==.) & noinm==1 & visit>=80  
replace niosex=1 if (sexav==1 & sexvm==. & nsexm==.) & noinm==1 & visit>=80  
replace niosex=1 if (sexav==1 & sexvm==1 & nsexm==.) & noinm==1 & visit>=80  
replace niosex=1 if nmsex==2 & noinm==1 & visit>=80  

replace niosex=2 if (sexav==. & sexvm==. & nsexm==.) & noinm==2 & visit>=80  
replace niosex=2 if (sexav==. & sexvm==1 & nsexm==.) & noinm==2 & visit>=80  
replace niosex=2 if (sexav==1 & sexvm==. & nsexm==.) & noinm==2 & visit>=80  
replace niosex=2 if (sexav==1 & sexvm==1 & nsexm==.) & noinm==2 & visit>=80  
replace niosex=2 if nmsex==2 & noinm==2 & visit>=80  

*replace niosex=0 if nmsex==2 & orin1==0 & noinm==. & niosex==. 
*replace niosex=0 if nmsex==2 & orin1==0 & noinm==0 & niosex==. 
*replace niosex=1 if nmsex==2 & orin1==1 & noinm==. & niosex==. 
*replace niosex=1 if nmsex==2 & orin1==1 & noinm==1 & niosex==. 

*replace niosex=0 if nmsex==1 & orin1==0 & noinm==. & niosex==. 
*replace niosex=0 if nmsex==1 & orin1==0 & noinm==0 & niosex==. 
*replace niosex=1 if nmsex==1 & orin1==1 & noinm==. & niosex==. 
*replace niosex=1 if nmsex==1 & orin1==1 & noinm==1 & niosex==.

*******************
*RECEPTIVE ORAL SEX
*******************

gen nrosex=.
replace nrosex=0 if (sexav==. & sexvm==. & nsexm==.) & moup==0 & visit<80
replace nrosex=0 if (sexav==1 & sexvm==. & nsexm==.) & moup==0 & visit<80
replace nrosex=0 if (sexav==. & sexvm==1 & nsexm==.) & moup==0 & visit<80
replace nrosex=0 if (sexav==1 & sexvm==1 & nsexm==.) & moup==0 & visit<80
replace nrosex=0 if nmsex==0 & moup==. & visit<80
replace nrosex=0 if nmsex==0 & moup==0 & visit<80
replace nrosex=0 if nmsex==1 & moup==0 & visit<80
replace nrosex=0 if nmsex==2 & moup==0 & visit<80

replace nrosex=1 if (sexav==. & sexvm==. & nsexm==.) & moup==1 & visit<80
replace nrosex=1 if (sexav==1 & sexvm==. & nsexm==.) & moup==1 & visit<80
replace nrosex=1 if (sexav==. & sexvm==1 & nsexm==.) & moup==1 & visit<80
replace nrosex=1 if (sexav==1 & sexvm==1 & nsexm==.) & moup==1 & visit<80
replace nrosex=1 if nmsex==1 & moup==1 & visit<80
replace nrosex=1 if nmsex==2 & moup==1 & visit<80

replace nrosex=2 if (sexav==. & sexvm==. & nsexm==.) & moup==2 & visit<80
replace nrosex=2 if (sexav==. & sexvm==1 & nsexm==.) & moup==2 & visit<80
replace nrosex=2 if (sexav==1 & sexvm==. & nsexm==.) & moup==2 & visit<80
replace nrosex=2 if (sexav==1 & sexvm==1 & nsexm==.) & moup==2 & visit<80
replace nrosex=2 if nmsex==2 & moup==2 & visit<80

replace nrosex=0 if (sexav==. & sexvm==. & nsexm==.) & orrc1==0 & visit>=80
replace nrosex=0 if (sexav==. & sexvm==1 & nsexm==.) & orrc1==0 & visit>=80
replace nrosex=0 if (sexav==1 & sexvm==. & nsexm==.) & orrc1==0 & visit>=80
replace nrosex=0 if (sexav==1 & sexvm==1 & nsexm==.) & orrc1==0 & visit>=80
replace nrosex=0 if nmsex==0 & orrc1==. & visit>=80
replace nrosex=0 if nmsex==0 & orrc1==0 & visit>=80
replace nrosex=0 if nmsex==1 & orrc1==0 & visit>=80

replace nrosex=1 if (sexav==. & sexvm==. & nsexm==.) & orrc1==1 & visit>=80
replace nrosex=1 if (sexav==. & sexvm==1 & nsexm==.) & orrc1==1 & visit>=80
replace nrosex=1 if (sexav==1 & sexvm==. & nsexm==.) & orrc1==1 & visit>=80
replace nrosex=1 if (sexav==1 & sexvm==1 & nsexm==.) & orrc1==1 & visit>=80
replace nrosex=1 if nmsex==1 & orrc1==1 & visit>=80

replace nrosex=0 if (sexav==. & sexvm==. & nsexm==.) & norcm==0 & visit>=80 
replace nrosex=0 if (sexav==. & sexvm==1 & nsexm==.) & norcm==0 & visit>=80 
replace nrosex=0 if (sexav==1 & sexvm==. & nsexm==.) & norcm==0 & visit>=80 
replace nrosex=0 if (sexav==1 & sexvm==1 & nsexm==.) & norcm==0 & visit>=80 
replace nrosex=0 if nmsex==0 & norcm==. & visit>=80 
replace nrosex=0 if nmsex==0 & norcm==0 & visit>=80 
replace nrosex=0 if nmsex==2 & norcm==0 & visit>=80 

replace nrosex=1 if (sexav==. & sexvm==. & nsexm==.) & norcm==1 & visit>=80  
replace nrosex=1 if (sexav==. & sexvm==1 & nsexm==.) & norcm==1 & visit>=80  
replace nrosex=1 if (sexav==1 & sexvm==. & nsexm==.) & norcm==1 & visit>=80  
replace nrosex=1 if (sexav==1 & sexvm==1 & nsexm==.) & norcm==1 & visit>=80  
replace nrosex=1 if nmsex==2 & norcm==1 & visit>=80  

replace nrosex=2 if (sexav==. & sexvm==. & nsexm==.) & norcm==2 & visit>=80  
replace nrosex=2 if (sexav==. & sexvm==1 & nsexm==.) & norcm==2 & visit>=80  
replace nrosex=2 if (sexav==1 & sexvm==. & nsexm==.) & norcm==2 & visit>=80  
replace nrosex=2 if (sexav==1 & sexvm==1 & nsexm==.) & norcm==2 & visit>=80  
replace nrosex=2 if nmsex==2 & norcm==2 & visit>=80  

*replace nrosex=0 if nmsex==2 & orrc1==0 & norcm==. & nrosex==. 
*replace nrosex=0 if nmsex==2 & orrc1==0 & norcm==0 & nrosex==. 
*replace nrosex=1 if nmsex==2 & orrc1==1 & norcm==. & nrosex==. 
*replace nrosex=1 if nmsex==2 & orrc1==1 & norcm==1 & nrosex==. 

*replace nrosex=0 if nmsex==1 & orrc1==0 & norcm==. & nrosex==. 
*replace nrosex=0 if nmsex==1 & orrc1==0 & norcm==0 & nrosex==. 
*replace nrosex=1 if nmsex==1 & orrc1==1 & norcm==. & nrosex==. 
*replace nrosex=1 if nmsex==1 & orrc1==1 & norcm==1 & nrosex==.


****************************************
****************************************
****************************************
*GENERATE VARIOUS SEX BEHAVIOR VARIABLES
****************************************
****************************************
****************************************

*SEXVAR1: No Intercourse, Intercourse 1 Partner, Intercourse 2 Partners
gen sexvar1=.
replace sexvar1=0 if nmsex==0
replace sexvar1=1 if nmsex==1
replace sexvar1=2 if nmsex==2

*SEXVAR2: No Intercourse, Oral Only, Anal 1 Partner, Anal 2 Partners
gen sexvar2=.
replace sexvar2=0 if nmsex==0
replace sexvar2=1 if (niasex==0 & nrasex==0 & niosex==1) 
replace sexvar2=1 if (niasex==0 & nrasex==0 & niosex==2) 
replace sexvar2=1 if (niasex==0 & nrasex==0 & nrosex==1) 
replace sexvar2=1 if (niasex==0 & nrasex==0 & nrosex==2) 
replace sexvar2=2 if (niasex==1 | nrasex==1 & (niasex!=2 & nrasex!=2))
replace sexvar2=3 if (niasex==2 | nrasex==2)
replace sexvar2=. if (niasex==. | nrasex==. | niosex==. | nrosex==.)


******************************************
******************************************
*EVER REPORT ANONYMOUS Intercourse PARTNER
*VISITS 1-6
******************************************
****************************************** 
gen anon1_6=((anonm==1 | anonm==2) & visit<=60 & visit>=10)
replace anon1_6=. if anonm==.
by caseid: egen manon1_6=max(anon1_6)
*by caseid: keep if _n==1
tabulate manon1_6

gen anon1_12=(((anonm==1 | anonm==2) & visit<=75 & visit>=10)|((nanom==1 | nanom==2 | rpart==3) & visit<=120 & visit>=80))
replace anon1_12=. if anonm==. & visit<=75 & visit>=10
replace anon1_12=. if nanom==. & rpart==. & visit<=120 & visit>=80
by caseid: egen manon1_12=max(anon1_12)
*by caseid: keep if _n==1
tabulate manon1_12

drop anon1_6
drop anon1_12
rename manon1_6 anon1_6
rename manon1_12 anon1_12

******************************************
******************************************
*EVER REPORT ANONYMOUS Intercourse PARTNER
*AT BASELINE -- LAST 2 YEARS
******************************************
****************************************** 
by caseid: egen mano2m=max(ano2m)
drop ano2m
rename mano2m bl_anon
tabulate bl_anon



******************************************
******************************************
*EVER REPORT KNOWLEDGE OF PARTNER'S STATUS
******************************************
******************************************
gen know8_11=(hivkn==2)|(nhivk==1)|(nhivk==2) & visit>=80 & visit<=120
replace know8_11=. if (hivkn==. & nhivk==.) & (visit>=80 & visit<=120) 
by caseid: egen mknow8_11=max(know8_11)
drop know8_11
rename mknow8_11 know8_11


********************************************************
********************************************************
********************************************************
sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit

sort caseid visit
by caseid: egen mknow8_11=max(know8_11)
drop know8_11
rename mknow8_11 know8_11
sort caseid visit
by caseid: egen manon1_6=max(anon1_6)
drop anon1_6
rename manon1_6 anon1_6
sort caseid visit
by caseid: egen manon1_12=max(anon1_12)
drop anon1_12
rename manon1_12 anon1_12


*Check for Consistency
count
*97130
count if caseid!=caseid[_n-1]
*5519
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear





***************************************************
**********************************
*****************
*BASELINE 
*Behavioral
*Variables
*(TIME INVARIANT)
*****************
**********************************
***************************************************

***************
*Baseline Drugs
***************

infix caseid 1-5 visit 6-8 cok2f 613 cok2y 614 has2f 1378 has2y 1379 upp2f 3362 upp2y 3363 mda2f 1795 mda2y 1796  using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
keep if visit==10 | visit==75

sort caseid visit

replace cok2y=0 if cok2y==1
replace cok2y=1 if cok2y==2
replace has2y=0 if cok2y==1
replace has2y=1 if cok2y==2
replace upp2y=0 if cok2y==1
replace upp2y=1 if cok2y==2
replace mda2y=0 if cok2y==1
replace mda2y=1 if cok2y==2
replace cok2f=0 if cok2y==0
replace has2f=0 if has2y==0
replace upp2f=0 if upp2y==0
replace mda2f=0 if mda2y==0

sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit
by caseid: replace cok2y=cok2y[1]
by caseid: replace cok2f=cok2f[1]
by caseid: replace has2y=cok2y[1]
by caseid: replace has2f=cok2f[1]
by caseid: replace upp2y=cok2y[1]
by caseid: replace upp2f=cok2f[1]
by caseid: replace mda2y=cok2y[1]
by caseid: replace mda2f=cok2f[1]

*Check for Consistency
count
*97130
count if caseid!=caseid[_n-1]
*5519
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear


 
/*
*********************
*Smoking and drinking
*********************

use "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
gen bhsmoke=hsmoke if (visit==10 | visit==75)
gen bhdrnk =hdrnk  if (visit==10 | visit==75)
by caseid: replace bhsmoke=bhsmoke[1]
by caseid: replace bhdrnk =bhdrnk[1]
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear

infix caseid 1-5 visit 6-8 smoke 2881 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit
replace smoke=0 if smoke==1
replace smoke=1 if smoke==2
gen bsmoke=smoke
by caseid: replace bsmoke=bsmoke[1] 
sort caseid visit
*Check for Consistency
count
*97130
count if caseid!=caseid[_n-1]
*5519
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear
*/


infix caseid 1-5 visit 6-8 asexf 210-211 asexm 212-213 ano2m 130 nsx2m 2249-2252 using "STATA/DATASETS/MainDataFile/MACSmen/data/section4.dat"
sort caseid visit
replace nsx2m=0 if nsx2m==1
replace nsx2m=2 if nsx2m==2
by caseid: replace nsx2m=nsx2m[1]

gen anonsex=.
replace anonsex=0 if nsx2m==0 & ano2m==5
replace anonsex=0 if nsx2m==1 & ano2m==5
replace anonsex=0 if nsx2m==2 & ano2m==5
replace anonsex=0 if nsx2m==. & ano2m==5
replace anonsex=1 if nsx2m==1 & (ano2m>=1 & ano2m<=4)
replace anonsex=1 if nsx2m==2 & (ano2m>=1 & ano2m<=4)
by caseid: replace anonsex=anonsex[1]

gen teensex=.
replace teensex=0 if asexf==0 & asexm==0
replace teensex=0 if asexf==0 & asexm>1
replace teensex=0 if asexf>1 & asexm==0
replace teensex=0 if asexf>1 & asexm>0
replace teensex=1 if asexf==1|asexm==1
by caseid: replace teensex=teensex[1]

sort caseid visit
merge caseid visit using  "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
drop if _merge==1
drop _merge
sort caseid visit
by caseid: replace anonsex=anonsex[1]
by caseid: replace teensex=teensex[1]
by caseid: replace nsx2m=nsx2m[1]
sort caseid
*Check for Consistency
count
*97130
count if caseid!=caseid[_n-1]
*5519
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace

*gen d75=(minvisit==75)
*replace visit=(visit[_n+1]-10) if (visit==75 & caseid==caseid[_n+1])
*drop if visit==75 & caseid!=caseid[_n+1]
*drop d75

*Check for Consistency
count
*97060
count if caseid!=caseid[_n-1]
*5449
 
*replace d_pr=0 if d_pr==1 & visit==400
*replace d_po=1 if d_po==0 & visit==400
*drop minvisit
*drop maxvisit
*drop maxyear
*qui by caseid: egen maxvisit=max(visit)
*qui by caseid: egen minvisit=min(visit)
*gen year=(((visit-10)/20)+1984)
*gen maxyear=(((maxvisit-10)/20)+1984)
*gen minyear=(((minvisit-10)/20)+1984)
*gen posyear=(((posvis-10)/20)+1984)
*gen dvisit = (20*(dyear-1984)+10)
*gen diffvisit=dvisit-maxvisit

sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear
use "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"


*NUMBERS I SHOULD KNOW:
count
count if caseid!=caseid[_n-1]
preserve
by caseid: keep if _n==1
count if d_sp==1
count if d_sc==1
count if d_ng==1
restore

erase 	"STATA/DATASETS/MainDataFile/stata/datasets/drug.dta"
erase	"STATA/DATASETS/MainDataFile/stata/datasets/drug6_12_75.dta"
erase	"STATA/DATASETS/MainDataFile/stata/datasets/drugav.dta"
erase	"STATA/DATASETS/MainDataFile/stata/datasets/drugnav.dta" 

sort caseid visit
save "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta", replace
clear
use "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"

/*
*****************
*****************
**DOCUMENTATION**
**NOTES**********
*****************
*****************

SUBJECT VISITS:

There is no var to indicate "subject i was observed in some way at visit v".
(Subject visits often appear in one data file but not others).
This means: sample size can change if a var from a previously unused data file is called up.
To avoid this, we begin by calling up (and merging) caseid and visit from all data files.
The goal is to start with a sample of all subject-visits


DROPPED SUBJECTS and SUBJECT VISITS:

The following subject visits are dropped:
1: Those with unclear HIV status.  
We only keep those who are always positive, always negative or who seroconvert
This corresponds to status=1 (negative), status==2 (pos) or status==4 (seroconvert)

2: Seroconverters with no date of seroconversion

3: Non-seroconverters with a date of seroconversion

4: Those where posvis is long after max visit, i.e., does not make sense.

5: Posvis is not a real visit, e.g., posvis==31


This leaves a core sample size of 5519 subjects and 97130 subject-visits.

*************************************************************************
*************************************************************************

STATUS:
create dummies for HIV status
d_sp: HIV+ at baseline
d_sc: Seroconvert during study
d_ng: Negative at baseline and at latest wave or immediately prior to attrition or death


MEDS AND HAART:

First, call up HIV/AIDS medications vars from Section 4: any drug, then: AV's, nonAV's, others
Next, call up meds vars from drugf1 and drugf2 (and merge)
Construct dummy var (medav) for taking av-meds to treat HIV, using maids and drgav
Construct var (meds) taking nonzero drug value + 1000 for drug (first for subject visit)
and value 0 for no drug (. for unknown or before visit 130)
Here, I allow for contradiction, i.e., meds=drgav+1000 even if medav==. or med==1
Create HAART dummy for each period using meds and MACS definition (4 ways to be on HAART)
HAART takes value 0 if meds==0 for visit>=130
HAART takes value . if meds==. for visit>=130
HAART takes value . if visit<130
Create TRIAL dummy from resf1
TRIAL takes value 0 if meds==0 for visit>=170
TRIAL takes value . if meds==. for visit>=170
TRIAL takes value . for visit<170

(Analogous procedure for MEDNAV, NAVMEDS and NAVTRIAL)



DATE OF BIRTH:
Date of Birth seems to change over time.  I use the DOB reported at baseline.

AGE:
We don't know precise ages.
Used year of birth (BORNY) and (albeit approximate visit dates) to construct approximate age
Construct: age at baseline (BAGE)


RACE AND EDUCATION:
Just took baseline and extrapolated
Generated dummies for: white (WHITE), black (BLACK) and other (ROTHER)
Generated dummies for: >=college degree (COLLEGE), some college (SCOLLEG), hs or less (HSCHOOL)



GENERAL (Contradictory VARS):  

A general problem is that multiple vars provide information on a single behavior.  
For example, one var indicates if the subject has used cocaine since the previous visit.  
A second var tells how frequently this has occured. 
At times, multiple vars provide contradictory information.  
As a general rule, this situation is handled in the following manner: 
If the vars agree, a dummy is constructed to reflect this information.
If one var provides information and the other is missing, the information from the nonmissing var is used if possible.
However, if the information is ambiguous (e.g., yes to SMOKN, but blank PACKS), dummy HSMOKE is coded as missing.
If the information from multiple variables is contradictory, the dummy is coded as missing.
Finally, note that baseline versus continuation questions might be slightly different.
For alcohol: fdrnk asks about last 12 months at baseline and "since last visit" at follow-up
For smoking: not a problem: question asks: do you smoke now?
For drugs: at baseline, asked if you've used drugs in the last 2 years
However, at baseline AND follow-up, asked about frequency in last 6 months
This means: at baseline, I use frequency var.
At follow up: I use both "s.l.v." and "frequency" vars to check for ambiguity/contradictions (as outlined above).



ALCOHOL

fdrnk (freq drinkgin) is main var.  
However, at visits 360-400, subjects also asked if they drink, and then asked how frequently.
Dummy var (hdrnk) refers to heavy drinking (>= once per day or almost daily)
When drnk is present, code as outlined above: 1 or 0 when unambiguous and non-contradictory
Code as . when contradictory or ambiguous due to multiple vars.
At visit 410, no more fdrnk or drnk. 
New var: fadrnk.  New scale, no longer explicitly includes >1 per day
Code daily or almost daily as hdrnk=1, rest as hdrnk=0, missing as .


SMOKING:

Main variables are SMOKN PACKS and ESMOK (as of visit 80)  
SMOKN asks: do you smoke now? (1:NO, 2:YES, 3:<1 per day).  
PACKS asks how many packs are smoked per day (0:NONE, 1:<1/2, 2:1/2-1, 3:1-2, 4:>2, 5(8?)OCCASIONAL.  
ESMOK asks: have you ever smoked

Create var SMOKE for smoking "a significant amount, i.e., not counting occasional smokers

Coding before v80 uses general procedure above with SMOKN and PACKS
Coding uses ESMOK, too, as of visit 80.
PACKS==5 and SMOKN==3 taken as "not smoking" where not ambiguous
Where ambiguous (e.g. PACKS==5, SMOKN==1) or (SMOKN==3, PACKS==4), code SMOKE as .


DRUGS:

For cocaine, visit 10-110 ask about (general) cocain usage (since last visit and frequency)
I generate COKE (dummy for coke usage since last visit)
Followed general procedure: any usage (uncontradicted and unambiguous) gives value 1
Contradiction and uncontradicted missing yield value .
Uncontradicted and unambiguous "no" gives value 0.
Visits 110-410 ask same "since last visit" and frequency visits about crack and then "other forms of cocaine"
Used both to form post-110 values of COKE.  
(Again: any unambiguous or uncontradicted "yes" to usage gives value 1 to COKE)

Other drugs (hash, mda, uppers) follow simplified procedure since all asked the same way for all periods

TI Variables (evDRUG) constructed for DRUG==coke, hash, mda, uppr

SEX:

This was done in several steps
1: Generate a vars for sex with male (MSEX) and number of sex with male (NMSEX) using SEXAV, SEXVM, NSEXM 
(and same principle as above regarding contradiction and ambiguity)
This process is complicated by the fact that although NSEXM (number of male partners intercourse) is collected
at each visit, there are many missing values due to negative responses to either SEXAV and or SEXVM -- though this is
not always the case.  Moreover, SEXAV and SEXVM are not asked at visit 10.  Hence, when NSEXM is missing but we know
that SEXAV or SEXVM are 0, then we say the subject had no intercourse (i.e., no sex activity implies no intercourse.)
Of course, the reverse is not always true.  Hence, missing values for msex are due to No information or, as in about 6 cases, 
conflicting information.

2: Generate a var for number of IAS with male (0: none, 1: 1, 2: >1) (NIASEX) using NMSEX
Careful to only use NMSEX==. as "unknown" if NOT arose via contradiction
Make sure number of times matches
I.E.: strict with 1part answering 2part sex question
3: Same for NRASEX
4: Use NIASEX NRASEX to augment NMSEX and MSEX where possible (COMMENT IN AND OUT, only a few...)
5: USE NRASEX, NIASEX to construct NASEX: #time anal sex with men.
NOTE: Only used where BOTH are not missing.

BASELINE: Drugs
Here, 2 vars for each drug were used: DRUG2Y and DRUG2F
DRUG2Y asks "DRUG during last two years"
DRUG2F asks "Frequency of DRUG during last two years"
Coded DRUG2F=0 if answer to DRUG2Y is no

BASELINE: ALCOHOL
There is no separate var for "every drank"
Use period 10/75 answer as baseline

BASELINE: SMOKING
There is a separate variable for ever smoking (SMOKE) (asked at baseline)
There are many missing values, especially for v75 recruites
I construct 2 baseline variables
BHSMOKE  uses the TV constructed dummy, taking baseline value
BSMOKE uses SMOKE and is different because it includes people who've EVER smoked (versus ever reported having heavy smoked.
NOTE: Smoking in general has many missing values.

BASELINE: SEX
Several variables
1. Keep NSX2M (sex w/ male in last 2 years)
2. Use NSX2M and ANO2M to create dummy (ANONSEX) for having engaged in anonymous sex in last two years
3. Use ASEXF, ASEXM to create dummy var for first sex (male or female) at age <=15
4. Same as 3. but for regular sex
NOTE: for most variables, I have ignored sex with females.  
This can be changed later...


*/






