** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

*SM9

*3_Sim1_Fit

/*
Simulation1: Model Fit Exercise
*/

clear
clear matrix
set more off
set mem 1g
set scheme s2mono

**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION

cd "~/Dropbox/WORK/VMI/PAPER/REPLICATION/"

**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION



**************
*Simulation 1*
**************

clear
cd "STATA/DATASETS"
use drugs
sort caseid v_it

keep v_it H_it F_it F_it1 E_it A_it B_it1 ///
d_l0_1 d_l1_1 ///
d_m0_1 d_m1_1 d_m2_1 d_m3_1 /// 

keep if B_it1==0
drop B_it1
cd "../../SIMULATIONS/SIM1"
save drugs_sim1, replace

append using /// 
drugs_sim1 drugs_sim1 drugs_sim1 drugs_sim1 drugs_sim1 ///
drugs_sim1 drugs_sim1 drugs_sim1 drugs_sim1

gen ind=_n
sort ind
save drugs_sim1, replace
clear



/* *** ONE TYPE
insheet ///
v_it_sim1 E_it_sim1 d_it_m_sim1 H_it_sim1 A_it_sim1 ///
SIM_d_it1_m ///
SIM_d_it1_l /// 
using "sim1_stata.csv", comma case

gen ind=_n 
sort ind
merge ind using drugs_sim1

gen d_m0_1_sim1=(SIM_d_it1_m==0)
gen d_m1_1_sim1=(SIM_d_it1_m==1)
gen d_m2_1_sim1=(SIM_d_it1_m==2)
gen d_m3_1_sim1=(SIM_d_it1_m==3)
gen d_l0_1_sim1=(SIM_d_it1_l==0)
gen d_l1_1_sim1=(SIM_d_it1_l==1)
*/ 









 *** TWO TYPES
 /*
insheet ///
v_it_sim1 E_it_sim1 d_it_m_sim1 H_it_sim1 A_it_sim1 ///
SIM_d_it1_m_1 ///
SIM_d_it1_l_1 /// 
SIM_d_it1_m_2 ///
SIM_d_it1_l_2 /// 
type_p	///
using "sim1_stata.csv", comma case


gen ind=_n 
sort ind
merge ind using drugs_sim1



gen d_m0_1_sim1_1=(SIM_d_it1_m_1==0)
gen d_m1_1_sim1_1=(SIM_d_it1_m_1==1)
gen d_m2_1_sim1_1=(SIM_d_it1_m_1==2)
gen d_m3_1_sim1_1=(SIM_d_it1_m_1==3)

gen d_l0_1_sim1_1=(SIM_d_it1_l_1==0)
gen d_l1_1_sim1_1=(SIM_d_it1_l_1==1) 

gen d_m0_1_sim1_2=(SIM_d_it1_m_2==0)
gen d_m1_1_sim1_2=(SIM_d_it1_m_2==1)
gen d_m2_1_sim1_2=(SIM_d_it1_m_2==2)
gen d_m3_1_sim1_2=(SIM_d_it1_m_2==3)

gen d_l0_1_sim1_2=(SIM_d_it1_l_2==0)
gen d_l1_1_sim1_2=(SIM_d_it1_l_2==1)

gen d_m0_1_sim1=type_p*d_m0_1_sim1_1+(1-type_p)*d_m0_1_sim1_2
gen d_m1_1_sim1=type_p*d_m1_1_sim1_1+(1-type_p)*d_m1_1_sim1_2
gen d_m2_1_sim1=type_p*d_m2_1_sim1_1+(1-type_p)*d_m2_1_sim1_2
gen d_m3_1_sim1=type_p*d_m3_1_sim1_1+(1-type_p)*d_m3_1_sim1_2

gen d_l0_1_sim1=type_p*d_l0_1_sim1_1+(1-type_p)*d_l0_1_sim1_2
gen d_l1_1_sim1=type_p*d_l1_1_sim1_1+(1-type_p)*d_l1_1_sim1_2
*/






 *** FOUR TYPES
insheet ///
v_it_sim1 E_it_sim1 d_it_m_sim1 H_it_sim1 A_it_sim1 ///
SIM_d_it1_m_1 ///
SIM_d_it1_l_1 /// 
SIM_d_it1_m_2 ///
SIM_d_it1_l_2 /// 
SIM_d_it1_m_3 ///
SIM_d_it1_l_3 /// 
SIM_d_it1_m_4 ///
SIM_d_it1_l_4 /// 
type1 ///
type2 ///
type3 ///
type4 ///
using "sim1_stata.csv", comma case


gen ind=_n 
sort ind
merge ind using drugs_sim1

gen d_m0_1_sim1_1=(SIM_d_it1_m_1==0)
gen d_m1_1_sim1_1=(SIM_d_it1_m_1==1)
gen d_m2_1_sim1_1=(SIM_d_it1_m_1==2)
gen d_m3_1_sim1_1=(SIM_d_it1_m_1==3)

gen d_l0_1_sim1_1=(SIM_d_it1_l_1==0)
gen d_l1_1_sim1_1=(SIM_d_it1_l_1==1) 

gen d_m0_1_sim1_2=(SIM_d_it1_m_2==0)
gen d_m1_1_sim1_2=(SIM_d_it1_m_2==1)
gen d_m2_1_sim1_2=(SIM_d_it1_m_2==2)
gen d_m3_1_sim1_2=(SIM_d_it1_m_2==3)

gen d_l0_1_sim1_2=(SIM_d_it1_l_2==0)
gen d_l1_1_sim1_2=(SIM_d_it1_l_2==1)

gen d_m0_1_sim1_3=(SIM_d_it1_m_3==0)
gen d_m1_1_sim1_3=(SIM_d_it1_m_3==1)
gen d_m2_1_sim1_3=(SIM_d_it1_m_3==2)
gen d_m3_1_sim1_3=(SIM_d_it1_m_3==3)

gen d_l0_1_sim1_3=(SIM_d_it1_l_3==0)
gen d_l1_1_sim1_3=(SIM_d_it1_l_3==1) 

gen d_m0_1_sim1_4=(SIM_d_it1_m_4==0)
gen d_m1_1_sim1_4=(SIM_d_it1_m_4==1)
gen d_m2_1_sim1_4=(SIM_d_it1_m_4==2)
gen d_m3_1_sim1_4=(SIM_d_it1_m_4==3)

gen d_l0_1_sim1_4=(SIM_d_it1_l_4==0)
gen d_l1_1_sim1_4=(SIM_d_it1_l_4==1)

gen d_m0_1_sim1=type1*d_m0_1_sim1_1 + type2*d_m0_1_sim1_2+type3*d_m0_1_sim1_3 + type4*d_m0_1_sim1_4
gen d_m1_1_sim1=type1*d_m1_1_sim1_1 + type2*d_m1_1_sim1_2+type3*d_m1_1_sim1_3 + type4*d_m1_1_sim1_4
gen d_m2_1_sim1=type1*d_m2_1_sim1_1 + type2*d_m2_1_sim1_2+type3*d_m2_1_sim1_3 + type4*d_m2_1_sim1_4
gen d_m3_1_sim1=type1*d_m3_1_sim1_1 + type2*d_m3_1_sim1_2+type3*d_m3_1_sim1_3 + type4*d_m3_1_sim1_4

gen d_l0_1_sim1=type1*d_l0_1_sim1_1 + type2*d_l0_1_sim1_2 + type3*d_l0_1_sim1_3 + type4*d_l0_1_sim1_4
gen d_l1_1_sim1=type1*d_l1_1_sim1_1 + type2*d_l1_1_sim1_2 + type3*d_l1_1_sim1_3 + type4*d_l1_1_sim1_4

*********************************************

sum d_l1_1
sum d_l1_1_sim1
sum d_m0_1
sum d_m0_1_sim1
sum d_m1_1
sum d_m1_1_sim1
sum d_m2_1
sum d_m2_1_sim1
sum d_m3_1
sum d_m3_1_sim1

sum d_l1_1 if H_it==1
sum d_l1_1_sim1 if H_it==1
sum d_m0_1 if H_it==1
sum d_m0_1_sim1 if H_it==1
sum d_m1_1 if H_it==1
sum d_m1_1_sim1 if H_it==1
sum d_m2_1 if H_it==1
sum d_m2_1_sim1 if H_it==1
sum d_m3_1 if H_it==1
sum d_m3_1_sim1 if H_it==1

sum d_l1_1 if H_it==0
sum d_l1_1_sim1 if H_it==0
sum d_m0_1 if H_it==0
sum d_m0_1_sim1 if H_it==0
sum d_m1_1 if H_it==0
sum d_m1_1_sim1 if H_it==0
sum d_m2_1 if H_it==0
sum d_m2_1_sim1 if H_it==0
sum d_m3_1 if H_it==0
sum d_m3_1_sim1 if H_it==0

sum d_l1_1 if E_it>20
sum d_l1_1_sim1 if  E_it>20
sum d_m0_1 if  E_it>20
sum d_m0_1_sim1 if  E_it>20
sum d_m1_1 if  E_it>20
sum d_m1_1_sim1 if  E_it>20
sum d_m2_1 if  E_it>20
sum d_m2_1_sim1 if  E_it>20
sum d_m3_1 if  E_it>20
sum d_m3_1_sim1 if  E_it>20

sum d_l1_1 if E_it<=20
sum d_l1_1_sim1 if  E_it<=20
sum d_m0_1 if  E_it<=20
sum d_m0_1_sim1 if  E_it<=20
sum d_m1_1 if  E_it<=20
sum d_m1_1_sim1 if  E_it<=20
sum d_m2_1 if  E_it<=20
sum d_m2_1_sim1 if  E_it<=20
sum d_m3_1 if  E_it<=20
sum d_m3_1_sim1 if  E_it<=20

sum d_l1_1 if A_it>45
sum d_l1_1_sim1 if A_it>45
sum d_m0_1 if A_it>45
sum d_m0_1_sim1  if A_it>45
sum d_m1_1 if A_it>45
sum d_m1_1_sim1 if A_it>45
sum d_m2_1 if A_it>45
sum d_m2_1_sim1 if A_it>45
sum d_m3_1 if A_it>45
sum d_m3_1_sim1 if A_it>45

sum d_l1_1 if A_it<=45
sum d_l1_1_sim1 if A_it<=45
sum d_m0_1 if A_it<=45
sum d_m0_1_sim1  if A_it<=45
sum d_m1_1 if A_it<=45
sum d_m1_1_sim1 if A_it<=45
sum d_m2_1 if A_it<=45
sum d_m2_1_sim1 if A_it<=45
sum d_m3_1 if A_it<=45
sum d_m3_1_sim1 if A_it<=45

sum d_l1_1 if v_it<=23
sum d_l1_1_sim1 if v_it<=23
sum d_m0_1 if v_it<=23
sum d_m0_1_sim1 if v_it<=23
sum d_m1_1 if v_it<=23
sum d_m1_1_sim1 if v_it<=23
sum d_m2_1 if v_it<=23
sum d_m2_1_sim1 if v_it<=23
sum d_m3_1 if v_it<=23
sum d_m3_1_sim1 if v_it<=23

sum d_l1_1 if v_it>23
sum d_l1_1_sim1 if v_it>23
sum d_m0_1 if v_it>23
sum d_m0_1_sim1 if v_it>23
sum d_m1_1 if v_it>23
sum d_m1_1_sim1 if v_it>23
sum d_m2_1 if v_it>23
sum d_m2_1_sim1 if v_it>23
sum d_m3_1 if v_it>23
sum d_m3_1_sim1 if v_it>23

sum d_l1_1 if v_it<=23 & H_it==1
sum d_l1_1_sim1 if v_it<=23 & H_it==1
sum d_m0_1 if v_it<=23 & H_it==1
sum d_m0_1_sim1 if v_it<=23 & H_it==1
sum d_m1_1 if v_it<=23 & H_it==1
sum d_m1_1_sim1 if v_it<=23 & H_it==1
sum d_m2_1 if v_it<=23 & H_it==1
sum d_m2_1_sim1 if v_it<=23 & H_it==1
sum d_m3_1 if v_it<=23 & H_it==1
sum d_m3_1_sim1 if v_it<=23 & H_it==1


sum d_l1_1 if v_it<=23 & H_it==0
sum d_l1_1_sim1 if v_it<=23 & H_it==0
sum d_m0_1 if v_it<=23 & H_it==0
sum d_m0_1_sim1 if v_it<=23 & H_it==0
sum d_m1_1 if v_it<=23 & H_it==0
sum d_m1_1_sim1 if v_it<=23 & H_it==0
sum d_m2_1 if v_it<=23 & H_it==0
sum d_m2_1_sim1 if v_it<=23 & H_it==0
sum d_m3_1 if v_it<=23 & H_it==0
sum d_m3_1_sim1 if v_it<=23 & H_it==0


sum d_l1_1 if v_it>23 & H_it==1
sum d_l1_1_sim1 if v_it>23 & H_it==1
sum d_m0_1 if v_it>23 & H_it==1
sum d_m0_1_sim1 if v_it>23 & H_it==1
sum d_m1_1 if v_it>23 & H_it==1
sum d_m1_1_sim1 if v_it>23 & H_it==1
sum d_m2_1 if v_it>23 & H_it==1
sum d_m2_1_sim1 if v_it>23 & H_it==1
sum d_m3_1 if v_it>23 & H_it==1
sum d_m3_1_sim1 if v_it>23 & H_it==1

sum d_l1_1 if v_it>23 & H_it==0
sum d_l1_1_sim1 if v_it>23 & H_it==0
sum d_m0_1 if v_it>23 & H_it==0
sum d_m0_1_sim1 if v_it>23 & H_it==0
sum d_m1_1 if v_it>23 & H_it==0
sum d_m1_1_sim1 if v_it>23 & H_it==0
sum d_m2_1 if v_it>23 & H_it==0
sum d_m2_1_sim1 if v_it>23 & H_it==0
sum d_m3_1 if v_it>23 & H_it==0
sum d_m3_1_sim1 if v_it>23 & H_it==0


*********************************************

sum d_l1_1 if H_it==1
sum d_l1_1_sim1 if H_it==1

sum d_l1_1 if H_it==0
sum d_l1_1_sim1 if H_it==0

sum d_l1_1 if E_it<=20
sum d_l1_1_sim1 if E_it<=20

sum d_l1_1 if E_it>20
sum d_l1_1_sim1 if E_it>20

sum d_l1_1 if A_it<=50
sum d_l1_1_sim1 if A_it<=50

sum d_l1_1 if A_it>50
sum d_l1_1_sim1 if A_it>50

sum d_l1_1 if v_it<=23  
sum d_l1_1_sim1 if v_it<=23  

sum d_l1_1 if v_it>23  
sum d_l1_1_sim1 if v_it>23  

sum d_l1_1 if v_it<=23 & H_it==0
sum d_l1_1_sim1 if v_it<=23 & H_it==0

sum d_l1_1 if v_it<=23 & H_it==1
sum d_l1_1_sim1 if v_it<=23 & H_it==1

sum d_l1_1 if v_it>23 & H_it==0
sum d_l1_1_sim1 if v_it>23 & H_it==0

sum d_l1_1 if v_it>23 & H_it==1
sum d_l1_1_sim1 if v_it>23 & H_it==1

*********************************************


sum d_m0_1 		 
sum d_m1_1 		 
sum d_m2_1 		 
sum d_m3_1 		 

sum d_m0_1_sim1	 
sum d_m1_1_sim1  
sum d_m2_1_sim1	 
sum d_m3_1_sim1	 

sum d_m0_1 		if v_it<=23
sum d_m1_1 		if v_it<=23
sum d_m2_1 		if v_it<=23
sum d_m3_1 		if v_it<=23

sum d_m0_1_sim1	if v_it<=23
sum d_m1_1_sim1 if v_it<=23
sum d_m2_1_sim1	if v_it<=23
sum d_m3_1_sim1	if v_it<=23

sum d_m0_1 		if v_it>23
sum d_m1_1 		if v_it>23
sum d_m2_1 		if v_it>23
sum d_m3_1 		if v_it>23

sum d_m0_1_sim1	if v_it>23
sum d_m1_1_sim1 if v_it>23
sum d_m2_1_sim1	if v_it>23
sum d_m3_1_sim1	if v_it>23 

sum d_l1_1 if d_m0_1==1
sum d_l1_1 if d_m1_1==1
sum d_l1_1 if d_m2_1==1
sum d_l1_1 if d_m3_1==1

sum d_l1_1_sim1 if d_m0_1_sim1==1
sum d_l1_1_sim1 if d_m1_1_sim1==1
sum d_l1_1_sim1 if d_m2_1_sim1==1
sum d_l1_1_sim1 if d_m3_1_sim1==1

sum d_m0_1 if H_it==0 		 
sum d_m1_1 if H_it==0 		 
sum d_m2_1 if H_it==0 		 
sum d_m3_1 if H_it==0 		 

sum d_m0_1_sim1 if H_it==0	 
sum d_m1_1_sim1 if H_it==0  
sum d_m2_1_sim1 if H_it==0	 
sum d_m3_1_sim1 if H_it==0	 

sum d_m0_1 if H_it==0 & v_it<=23 		 
sum d_m1_1 if H_it==0 & v_it<=23 		 
sum d_m2_1 if H_it==0 & v_it<=23		 
sum d_m3_1 if H_it==0 & v_it<=23 		 

sum d_m0_1_sim1 if H_it==0 & v_it<=23	 
sum d_m1_1_sim1 if H_it==0 & v_it<=23  
sum d_m2_1_sim1 if H_it==0 & v_it<=23	 
sum d_m3_1_sim1 if H_it==0 & v_it<=23	 

sum d_m0_1 if H_it==0 & v_it>23 		 
sum d_m1_1 if H_it==0 & v_it>23 		 
sum d_m2_1 if H_it==0 & v_it>23		 
sum d_m3_1 if H_it==0 & v_it>23 		 

sum d_m0_1_sim1 if H_it==0 & v_it>23	 
sum d_m1_1_sim1 if H_it==0 & v_it>23  
sum d_m2_1_sim1 if H_it==0 & v_it>23	 
sum d_m3_1_sim1 if H_it==0 & v_it>23	 

sum d_m0_1 if H_it==1 		 
sum d_m1_1 if H_it==1 		 
sum d_m2_1 if H_it==1 		 
sum d_m3_1 if H_it==1 		 

sum d_m0_1_sim1 if H_it==1	 
sum d_m1_1_sim1 if H_it==1  
sum d_m2_1_sim1 if H_it==1	 
sum d_m3_1_sim1 if H_it==1	

sum d_m0_1 if H_it==1 & v_it<=23 		 
sum d_m1_1 if H_it==1 & v_it<=23 		 
sum d_m2_1 if H_it==1 & v_it<=23		 
sum d_m3_1 if H_it==1 & v_it<=23 		 

sum d_m0_1_sim1 if H_it==1 & v_it<=23	 
sum d_m1_1_sim1 if H_it==1 & v_it<=23  
sum d_m2_1_sim1 if H_it==1 & v_it<=23	 
sum d_m3_1_sim1 if H_it==1 & v_it<=23	 

sum d_m0_1 if H_it==1 & v_it>23 		 
sum d_m1_1 if H_it==1 & v_it>23 		 
sum d_m2_1 if H_it==1 & v_it>23		 
sum d_m3_1 if H_it==1 & v_it>23 		 

sum d_m0_1_sim1 if H_it==1 & v_it>23	 
sum d_m1_1_sim1 if H_it==1 & v_it>23  
sum d_m2_1_sim1 if H_it==1 & v_it>23	 
sum d_m3_1_sim1 if H_it==1 & v_it>23


