** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 

*SM9

*4_Sim2_Treatments

/*
Simulation 2: Change available treatments
and then look at treatment choice and other
factors.
*/

clear
clear matrix
set more off
set mem 1g
set scheme s2mono

**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION

cd "~/Dropbox/WORK/VMI/PAPER/REPLICATION/"

**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION

*****************
*Simulation 2_24*
*****************

*************************
*SIM2_24_CF0: HAART as is
*************************
forvalues t=1(1)4	{

clear
insheet ///
v_it E_it d_it_m H_it A_it B_it ///
d_it1_l d_it1_m  ///
v_it1 E_it1 d_m1 H_it1 A_it1 B_it1 I_it1 F_it ///
using "SIMULATIONS/SIM2/sim2_24_CF0_`t'_stata.csv", comma case
replace E_it=E_it/2
replace E_it1=E_it1/2

*CYCLING
preserve
keep if B_it1==0
*Healthy, go off HT
tab d_it1_m if H_it==1 & d_it_m==3

*Healthy, stay off HT
tab d_it1_m if H_it==1 & d_it_m!=3  

*Get sick if NOT ON HT
tab H_it1 if H_it==1 & d_it_m!=3   

*Back on HT if off and sick
tab d_it1_m if H_it==0 & d_it_m!=3

*Stay on HT if sick
tab d_it1_m if H_it==0 & d_it_m==3

*Get better if on HT
tab H_it1 if H_it==0 & d_it_m==3   
restore

*CYCLING LABOR
preserve
tab d_it1_l if d_it1_m==3  & H_it==1
tab d_it1_l if d_it1_m!=3  & H_it==1
tab d_it1_l if d_it1_m==0 & H_it==1

tab d_it1_l if d_it1_m==3  & H_it==0
tab d_it1_l if d_it1_m==0 & H_it==0
restore


replace E_it=0 if B_it==1
replace H_it=0 if B_it==1
replace I_it1=0 if B_it1==1 
replace d_it1_l=0 if B_it1==1

sort v_it
by v_it: egen meanE0`t'=mean(E_it)  
by v_it: egen meanH0`t'=mean(H_it)  
by v_it: egen meanI0`t'=mean(I_it)  
by v_it: egen meanL0`t'=mean(d_it1_l)

keep if B_it==0
by v_it: egen death_prob0`t'=mean(B_it1)
by v_it: egen meanE0A`t'=mean(E_it)  
by v_it: egen meanH0A`t'=mean(H_it)  
by v_it: egen meanF0A`t'=mean(F_it)  

keep if B_it1==0
by v_it: egen meanI0A`t'=mean(I_it1)  
by v_it: egen meanL0A`t'=mean(d_it1_l)  
gen d00=(d_it1_m==0)
gen d01=(d_it1_m==1)
gen d02=(d_it1_m==2)
gen d03=(d_it1_m==3)
by v_it: egen md00`t'=mean(d00)
by v_it: egen md01`t'=mean(d01)
by v_it: egen md02`t'=mean(d02)
by v_it: egen md03`t'=mean(d03)

sort v_it
by v_it: keep if _n==1
save "SIMULATIONS/SIM2/sim2_24_CF0`t'", replace
}

************************************************

****************************
*SIM2_24_1: HAART like COMBO
****************************
forvalues t=1(1)4	{

clear
insheet ///
v_it E_it d_it_m H_it A_it B_it ///
d_it1_l d_it1_m  ///
v_it1 E_it1 d_m1 H_it1 A_it1 B_it1 I_it1 F_it ///
using "SIMULATIONS/SIM2/sim2_24_CF1_`t'_stata.csv", comma case
replace E_it=E_it/2
replace E_it1=E_it1/2

replace E_it=0 if B_it==1
replace H_it=0 if B_it==1
replace I_it1=0 if B_it1==1 
replace d_it1_l=0 if B_it1==1

sort v_it
by v_it: egen meanE1`t'=mean(E_it)  
by v_it: egen meanH1`t'=mean(H_it)  
by v_it: egen meanI1`t'=mean(I_it)  
by v_it: egen meanL1`t'=mean(d_it1_l)

keep if B_it==0
by v_it: egen death_prob1`t'=mean(B_it1)
by v_it: egen meanE1A`t'=mean(E_it)  
by v_it: egen meanH1A`t'=mean(H_it)  
by v_it: egen meanF1A`t'=mean(F_it)  

keep if B_it1==0
by v_it: egen meanI1A`t'=mean(I_it1)  
by v_it: egen meanL1A`t'=mean(d_it1_l)  
gen d00=(d_it1_m==0)
gen d01=(d_it1_m==1)
gen d02=(d_it1_m==2)
gen d03=(d_it1_m==3)
by v_it: egen md10`t'=mean(d00)
by v_it: egen md11`t'=mean(d01)
by v_it: egen md12`t'=mean(d02)
by v_it: egen md13`t'=mean(d03)

sort v_it
by v_it: keep if _n==1
save "SIMULATIONS/SIM2/sim2_24_CF1`t'", replace
}

************************************************

**********************
*SIM2_24_2: JUST HAART
**********************
forvalues t=1(1)4	{

clear
insheet ///
v_it E_it d_it_m H_it A_it B_it ///
d_it1_l d_it1_m  ///
v_it1 E_it1 d_m1 H_it1 A_it1 B_it1 I_it1 F_it ///
using "SIMULATIONS/SIM2/sim2_24_CF2_`t'_stata.csv", comma case
replace E_it=E_it/2
replace E_it1=E_it1/2

replace E_it=0 if B_it==1
replace H_it=0 if B_it==1
replace I_it1=0 if B_it1==1 
replace d_it1_l=0 if B_it1==1

sort v_it
by v_it: egen meanE2`t'=mean(E_it)  
by v_it: egen meanH2`t'=mean(H_it)  
by v_it: egen meanI2`t'=mean(I_it)  
by v_it: egen meanL2`t'=mean(d_it1_l)

keep if B_it==0
by v_it: egen death_prob2`t'=mean(B_it1)
by v_it: egen meanE2A`t'=mean(E_it)  
by v_it: egen meanH2A`t'=mean(H_it)  
by v_it: egen meanF2A`t'=mean(F_it)  

keep if B_it1==0
by v_it: egen meanI2A`t'=mean(I_it1)  
by v_it: egen meanL2A`t'=mean(d_it1_l)  
gen d00=(d_it1_m==0)
gen d01=(d_it1_m==1)
gen d02=(d_it1_m==2)
gen d03=(d_it1_m==3)
by v_it: egen md20`t'=mean(d00)
by v_it: egen md21`t'=mean(d01)
by v_it: egen md22`t'=mean(d02)
by v_it: egen md23`t'=mean(d03)


sort v_it
by v_it: keep if _n==1
save "SIMULATIONS/SIM2/sim2_24_CF2`t'", replace
}

************************************************

******************************
*SIM2_24_3: HAART Improvements
******************************
forvalues t=1(1)4	{

clear
insheet ///
v_it E_it d_it_m H_it A_it B_it ///
d_it1_l d_it1_m  ///
v_it1 E_it1 d_m1 H_it1 A_it1 B_it1 I_it1 F_it ///
using "SIMULATIONS/SIM2/sim2_24_CF3_`t'_stata.csv", comma case
replace E_it=E_it/2
replace E_it1=E_it1/2


*BEGIN: Checking Some Stuff
preserve 
keep if B_it1==0
tab F_it
tab d_it1_l
tab d_it1_l if H_it==1 
tab d_it1_l if H_it==0
tab d_it1_l if F_it<.45 
tab d_it1_l if F_it>.75
restore
*END: Checking Some Stuff

*BEGIN: Find An Example of Cycling!

gen caseid=.
forvalues i=24(1)40{
qui replace caseid=_n-3180*(`i'-24) if v_it==`i'
}
sort caseid v_it
*keep if B_it1==0

*END: Find An Example of Cycling

replace E_it=0 if B_it==1
replace H_it=0 if B_it==1
replace I_it1=0 if B_it1==1 
replace d_it1_l=0 if B_it1==1

sort v_it
by v_it: egen meanE3`t'=mean(E_it)  
by v_it: egen meanH3`t'=mean(H_it)  
by v_it: egen meanI3`t'=mean(I_it)  
by v_it: egen meanL3`t'=mean(d_it1_l)

keep if B_it==0
by v_it: egen death_prob3`t'=mean(B_it1)
by v_it: egen meanE3A`t'=mean(E_it)  
by v_it: egen meanH3A`t'=mean(H_it)  
by v_it: egen meanF3A`t'=mean(F_it)  

keep if B_it1==0
by v_it: egen meanI3A`t'=mean(I_it1)  
by v_it: egen meanL3A`t'=mean(d_it1_l)  
gen d00=(d_it1_m==0)
gen d01=(d_it1_m==1)
gen d02=(d_it1_m==2)
gen d03=(d_it1_m==3)
by v_it: egen md30`t'=mean(d00)
by v_it: egen md31`t'=mean(d01)
by v_it: egen md32`t'=mean(d02)
by v_it: egen md33`t'=mean(d03)

sort v_it
by v_it: keep if _n==1
save "SIMULATIONS/SIM2/sim2_24_CF3`t'", replace
}

************************************************
************************************************

clear
cd "SIMULATIONS/SIM2/"
use SIM2_24_CF01
merge v_it using SIM2_24_CF02
sort v_it
drop _merge
merge v_it using SIM2_24_CF03
sort v_it
drop _merge
merge v_it using SIM2_24_CF04
sort v_it
drop _merge

forvalues j=1(1)3 {
forvalues t=1(1)4 {

merge v_it using SIM2_24_CF`j'`t'
sort v_it
drop _merge

}
}
/*
merge v_it using SIM2_24_CF12
sort v_it
drop _merge
merge v_it using SIM2_24_CF13
sort v_it
drop _merge
merge v_it using SIM2_24_CF14
sort v_it
drop _merge
merge v_it using SIM2_24_CF21
sort v_it
drop _merge
merge v_it using SIM2_24_CF22
sort v_it
drop _merge
merge v_it using SIM2_24_CF23
sort v_it
drop _merge
merge v_it using SIM2_24_CF24
sort v_it
drop _merge
merge v_it using SIM2_24_CF31
sort v_it
drop _merge
merge v_it using SIM2_24_CF32
sort v_it
drop _merge
merge v_it using SIM2_24_CF33
sort v_it
drop _merge
merge v_it using SIM2_24_CF34
sort v_it
drop _merge
*/

save SIM2_24, replace

***********************************************

sort v_it
by v_it: keep if _n==1
gen year=(v_it-15)/2+1991

***********************************************

forvalues t=1(1)4	{
twoway ///
(line md00`t' year) ///
(line md01`t' year) ///
(line md02`t' year) ///
(line md03`t' year), ///
title(Treatment Choice: Factual Simulation) ///
ylabel(0(.2)1) ///
subtitle(Preference Type I & Health Type I) ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
legend(label(1 "None")  label(2 "Mono") label(3 "Combo") label(4 "HAART"))
graph export "../../ARTWORK/sim2_24_treat_CF0_`t'.png", replace

}

***********************************************

forvalues t=1(1)4	{

twoway ///
(line md10`t' year) ///
(line md11`t' year) ///
(line md12`t' year) ///
(line md13`t' year), ///
title(Treatment Choice: No HAART) ///
ylabel(0(.2)1) ///
subtitle(Preference Type I & Health Type I) ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
legend(label(1 "None")  label(2 "Mono") label(3 "Combo") label(4 "Combo 2"))
graph export "../../ARTWORK/sim2_24_treat_CF1_`t'.png", replace

}

***********************************************

forvalues t=1(1)4	{

twoway ///
(line md20`t' year) ///
(line md21`t' year) ///
(line md22`t' year) ///
(line md23`t' year), ///
title(Treatment Choice: Only HAART) ///
ylabel(0(.2)1) ///
subtitle(Preference Type I & Health Type I) ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
legend(label(1 "None")  label(2 "HAART") label(3 "HAART 2") label(4 "HAART 3"))
graph export "../../ARTWORK/sim2_24_treat_CF2_`t'.png", replace

}

***********************************************

forvalues t=1(1)4	{

twoway ///
(line md30`t' year) ///
(line md31`t' year) ///
(line md32`t' year) ///
(line md33`t' year), ///
title(Treatment Choice) ///
ylabel(0(.2)1) ///
subtitle(Preference Type I & Health Type I: Innovations) ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
legend(label(1 "None")  label(2 "HAART") label(3 "HAART+H") label(4 "HAART+F"))
graph export "../../ARTWORK/sim2_24_treat_CF3_`t'.png", replace

}

************************************************

forvalues t=1(1)4	{

twoway ///
(line death_prob0`t' year) ///
(line death_prob1`t' year) ///
(line death_prob3`t' year), ///
title(Simulated Probability of Death) ///
subtitle(Preference Type I & Health Type I) ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
legend(cols(1) label(1 "HAART: Introduced as Observed in 1996")  label(2 "HAART not Introduced") label(3 "HAART Innovations"))
graph export "../../ARTWORK/sim2_24_death_`t'.png", replace

}

************************************************

forvalues t=1(1)4	{

twoway ///
(line meanH0A`t' year) ///
(line meanH1A`t' year) ///
(line meanH3A`t' year), ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
title(Simulated Probability: Good Health) ///
subtitle(Preference Type I & Health Type I) ///
legend(cols(1) label(1 "HAART: Introduced as Observed in 1996")  label(2 "HAART not Introduced") label(3 "HAART Innovations"))
graph export "../../ARTWORK/sim2_24_health_A_`t'.png", replace

}

************************************************

forvalues t=1(1)4	{

twoway ///
(line meanF0A`t' year) ///
(line meanF1A`t' year) ///   
(line meanF3A`t' year), ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
title(Simulated Probability: Free of Ailments) ///
subtitle(Preference Type I & Health Type I) ///
legend(cols(1) label(1 "HAART: Introduced as Observed in 1996")  label(2 "HAART not Introduced") label(3 "HAART Innovations"))
graph export "../../ARTWORK/sim2_24_ailment_A_`t'.png", replace

}

************************************************

forvalues t=1(1)4	{

twoway ///
(line meanL0A`t' year) ///
(line meanL1A`t' year) ///
(line meanL3A`t' year), ///
ytitle(Sample Average (%)) ///
xtitle(Year) ///
title(Simulated Probability: Full-Time Work) ///
subtitle(Preference Type I & Health Type I) ///
legend(cols(1) label(1 "HAART: Introduced as Observed in 1996")  label(2 "HAART not Introduced") label(3 "HAART Innovations"))
graph export "../../ARTWORK/sim2_24_labor_A_`t'.png", replace

}

************************************************

forvalues t=1(1)4	{

twoway ///
(line meanI0A`t' year) ///
(line meanI1A`t' year) ///
(line meanI3A`t' year), ///
title(Simulated Average Income) xtitle(Year) ///
ytitle("Sample Average (2003 $/Semester)") ///
subtitle(Preference Type I & Health Type I) ///
legend(cols(1) label(1 "HAART: Introduced as Observed in 1996")  label(2 "HAART not Introduced") label(3 "HAART Innovations"))
graph export "../../ARTWORK/sim2_24_income_A_`t'.png", replace

}

************************************************

forvalues t=1(1)4	{

twoway ///
(line meanE0A`t' year) ///
(line meanE1A`t' year) ///
(line meanE3A`t' year), ///
ytitle(Sample Average (Years)) xtitle(Year) ///
title(Simulated Average Experience) ///
subtitle(Preference Type I & Health Type I) ///
legend(cols(1) label(1 "HAART: Introduced as Observed in 1996")  label(2 "HAART not Introduced") label(3 "HAART Innovations"))
graph export "../../ARTWORK/sim2_24_exp_A_`t'.png", replace

}

************************************************

