** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** **                                                          ** 
** ** ** **                                                          ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** **       V A L U E  O F  M E D I C A L  I N N O V A T I O N ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** 
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **  

*SM9

*6_Posterior Exercise

/*
Use posterior probability of type to explore non-state variables
*/

clear
clear matrix
set more off
set mem 1g
set scheme s2mono


**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION

cd "~/Dropbox/WORK/VMI/PAPER/REPLICATION/"

**** HERE, REPLACE cd COMMAND TO NAVIGATE TO FOLDER REPLICATION



*POSTERIOR
clear
use "STATA/DATASETS/drugs_posterior"
sort obs
save "SIMULATIONS/SIM_POST/drugs_posterior", replace
clear

insheet ///
obs ind_MAT v_it_MAT A_it_MAT p4 p3 p2 p1 ///
using "SIMULATIONS/SIM_POST/posterior_stata.csv", comma case
sort obs
merge obs using "SIMULATIONS/SIM_POST/drugs_posterior"
keep caseid v_it p1 p2 p3 p4
sort caseid v_it
save "SIMULATIONS/SIM_POST/posterior", replace
clear

use "STATA/DATASETS/MainDataFile/stata/datasets/maindatafile_vmi.dta"
keep caseid visit teensex white black orace age college hschool scolleg cesd depress anonsex
sort caseid visit
by caseid: egen MAX_depress=max(depress) if depress!=.
rename visit v_it
replace v_it=v_it/10
sort caseid v_it
merge caseid v_it using "SIMULATIONS/SIM_POST/posterior"
keep if _merge==3
drop _merge
sort caseid v_it
save "SIMULATIONS/SIM_POST/posterior", replace

use "STATA/DATASETS/drugs"
keep caseid v_it occup IN_it
sort caseid v_it
merge caseid v_it using "SIMULATIONS/SIM_POST/posterior"
keep if _merge==3
drop _merge
save "SIMULATIONS/SIM_POST/posterior", replace

sort caseid
by caseid: egen mIN_it=mean(IN_it)
gen IN18870=IN_it>18870 & IN_it!=.
gen occup100=(occup==100)
gen occup300=(occup==300)
gen occup450=(occup==450)
gen occup500=(occup==500)
gen occup600=(occup==600)
gen occup800=(occup==800)

by caseid: keep if _n==1

gen pT1=p1+p3
gen pT2=p2+p4
gen tT1=p1+p2
gen tT2=p3+p4


latabstat pT1 pT2 tT1 tT2, by(teensex) f(%9.2f)
latabstat pT1 pT2 tT1 tT2, by(anon) f(%9.2f)
latabstat pT1 pT2 tT1 tT2, by(college) f(%9.2f)
latabstat pT1 pT2 tT1 tT2, by(white) f(%9.2f)
latabstat pT1 pT2 tT1 tT2, by(black) f(%9.2f)
latabstat pT1 pT2 tT1 tT2, by(MAX_depress) f(%9.2f)
latabstat pT1 pT2 tT1 tT2 if occup100==1, f(%9.2f) // Prof. Specialty
latabstat pT1 pT2 tT1 tT2 if occup300==1, f(%9.2f) // Admin or clerical
latabstat pT1 pT2 tT1 tT2 if occup450==1, f(%9.2f) // Waitor
latabstat pT1 pT2 tT1 tT2 if occup500==1, f(%9.2f) // Prec. prod / craft / construction
latabstat pT1 pT2 tT1 tT2 if occup600==1, f(%9.2f) // Extractive (mining)
latabstat pT1 pT2 tT1 tT2 if occup800==1, f(%9.2f) // Transportation

